package au.net.netstorm.boost.bullet.clobber.core;

import java.util.List;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.EnumParser;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.IntegerParse;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.ListParser;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.LongParse;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.Parse;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.ParseParser;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.Parser;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.Parsers;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.StringParse;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.StrongParser;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.StructParser;
import au.net.netstorm.boost.bullet.clobber.read.parse.type.TimePointParse;
import au.net.netstorm.boost.bullet.incredibles.core.Strong;
import au.net.netstorm.boost.bullet.incredibles.core.Struct;
import au.net.netstorm.boost.bullet.time.core.TimePoint;
import au.net.netstorm.boost.spider.api.config.web.Web;
import au.net.netstorm.boost.spider.api.config.wire.Wire;
import au.net.netstorm.boost.spider.api.runtime.Impl;

public final class ClobberWeb implements Web {
    String scope = "au.net.netstorm.boost.bullet.clobber";
    Parsers parsers;
    Wire wire;
    Impl impl;

    public void web() {
        parsers();
    }

    // FIX 1202 Jan 15, 2009 Split out into a ParsersWeb?
    private void parsers() {
        wire.ref(parsers).to(Parsers.class);
        // FIX 1202 Jan 15, 2009 Parsing other primitives? int, bool....
        parser(Strong.class, StrongParser.class);
        parser(Struct.class, StructParser.class);
        parser(List.class, ListParser.class);
        parser(Enum.class, EnumParser.class);
        parse(String.class, StringParse.class);
        parse(Integer.class, IntegerParse.class);
        parse(Long.class, LongParse.class);
        parse(TimePoint.class, TimePointParse.class);
    }

    private void parser(Class type, Class<? extends Parser> p) {
        Parser parser = impl.impl(p);
        parsers.add(type, parser);
    }

    private void parse(Class type, Class<? extends Parse> p) {
        Parse parse = impl.impl(p);
        Parser parser = impl.impl(ParseParser.class, parse);
        parsers.add(type, parser);
    }
}
