package au.net.netstorm.boost.bullet.clobber.read.lex;

import java.util.List;
import au.net.netstorm.boost.spider.api.runtime.Nu;

public final class DefaultLexer implements Lexer {
    Classifier classifier;
    Escapee escapee;
    Greedy greedy;
    Nu nu;

    public Tokens lex(String text) {
        List result = nu.nu(List.class);
        Scanner scanner = nu.nu(Scanner.class, text);
        while (scanner.more()) process(result, scanner);
        return nu.nu(Tokens.class, result);
    }

    private void process(List result, Scanner scanner) {
        Token token = process(scanner);
        result.add(token);
    }

    private Token process(Scanner scanner) {
        scanner.mark();
        Type type = head(scanner);
        tail(scanner, type);
        return token(type, scanner);
    }

    private Type head(Scanner scanner) {
        return classifier.classify(scanner);
    }

    private void tail(Scanner scanner, Type type) {
        if (escapee.is(scanner)) escapee.gobble(scanner);
        else if (greedy.is(type)) greedy.gobble(scanner, type);
        else scanner.next();
    }

    private Token token(Type open, Scanner scanner) {
        String s = scanner.chop();
        return nu.nu(Token.class, open, s);
    }
}
