package au.net.netstorm.boost.bullet.clobber.read.lex;

import java.util.List;
import au.net.netstorm.boost.bullet.primordial.Primordial;

public final class DefaultTokens extends Primordial implements Tokens {
    List<Token> tokens;

    public DefaultTokens(List tokens) {
        this.tokens = tokens;
    }

    public Token expect(Type type) {
        Token token = tokens.remove(0);
        check(token, type);
        return token;
    }

    public boolean is(Type type) {
        Token token = tokens.get(0);
        return is(token, type);
    }

    private void check(Token token, Type expected) {
        if (is(token, expected)) return;
        throw new IllegalStateException("Expected: " + expected + " Actual: " + token.type());
    }

    private boolean is(Token token, Type expected) {
        Type actual = token.type();
        return actual == expected;
    }
}
