package au.net.netstorm.boost.bullet.clobber.read.parse.sexp;

import java.util.List;
import au.net.netstorm.boost.bullet.clobber.read.lex.Lexer;
import au.net.netstorm.boost.bullet.clobber.read.lex.Token;
import au.net.netstorm.boost.bullet.clobber.read.lex.Tokens;
import static au.net.netstorm.boost.bullet.clobber.read.lex.Type.ATOM;
import static au.net.netstorm.boost.bullet.clobber.read.lex.Type.CLOSE;
import static au.net.netstorm.boost.bullet.clobber.read.lex.Type.OPEN;
import static au.net.netstorm.boost.bullet.clobber.read.lex.Type.SEPARATOR;
import au.net.netstorm.boost.spider.api.runtime.Impl;
import au.net.netstorm.boost.spider.api.runtime.Nu;

// FIX 1202 use or lose. wire into a typed parser equiv to old guy.
public class DefaultSexpParser implements SexpParser {
    Lexer lexer;
    Impl impl;
    Nu nu;

    public Expr parse(String text) {
        Tokens tokens = lexer.lex(text);
        return expression(tokens);
    }

    private Expr expression(Tokens tokens) {
        tokens.expect(OPEN);
        List children = nu.nu(List.class);
        list(children, tokens);
        tokens.expect(CLOSE);
        return impl.impl(CompoundExpr.class, children);
    }

    private Expr atom(Tokens tokens) {
        Token token = tokens.expect(ATOM);
        String value = token.lexeme();
        return impl.impl(AtomExpr.class, value);
    }

    private void list(List children, Tokens tokens) {
        Expr child = child(tokens);
        children.add(child);
        if (tokens.is(SEPARATOR)) next(children, tokens);
    }

    private Expr child(Tokens tokens) {
        if (tokens.is(OPEN)) return expression(tokens);
        if (tokens.is(ATOM)) return atom(tokens);
        throw new IllegalStateException();
    }

    private void next(List children, Tokens tokens) {
        tokens.expect(SEPARATOR);
        if (tokens.is(CLOSE)) return;
        list(children, tokens);
    }
}
