package au.net.netstorm.boost.bullet.clobber.read.parse.sexp;

import java.util.List;
import au.net.netstorm.boost.bullet.clobber.core.ClobberTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.spider.api.runtime.Impl;
import au.net.netstorm.boost.spider.api.runtime.Nu;
import junit.framework.Assert;

public class SexpParserModuleTest extends ClobberTestCase implements InjectableTest {
    SexpParser subject;
    Impl impl;
    Nu nu;

    public void testSingle() {
        String input = "(hello)";
        Expr expected = c(a("hello"));
        check(input, expected);
    }

    public void testMulti() {
        String input = "(foo bar baz)";
        Expr expected = c(a("foo"), a("bar"), a("baz"));
        check(input, expected);
    }

    public void testTrailing() {
        String input = "(hello    )";
        Expr expected = c(a("hello"));
        check(input, expected);
    }

    public void testCompound() {
        String input = "(big (ball of mud))";
        Expr expected = c(a("big"), c(a("ball"), a("of"), a("mud")));
        check(input, expected);
    }

    private void check(String input, Expr expected) {
        Expr actual = subject.parse(input);
        Assert.assertEquals(expected, actual);
    }

    private Expr c(Expr... exprs) {
        List list = nu.nu(List.class);
        for (Expr e : exprs) list.add(e);
        return impl.impl(CompoundExpr.class, list);
    }

    private Expr a(String value) {
        return impl.impl(AtomExpr.class, value);
    }
}
