package au.net.netstorm.boost.bullet.clobber.read.parse.type;

import au.net.netstorm.boost.gunge.collection.StrictMap;
import au.net.netstorm.boost.gunge.type.Marker;

public final class DefaultParsers implements Parsers {
    StrictMap<Class, Parser> parsers;
    Marker marker;

    public Parser get(Class cls) {
        Class type = find(cls);
        return parsers.get(type);
    }

    public void add(Class type, Parser parser) {
        parsers.put(type, parser);
    }

    private Class find(Class cls) {
        for (Class type : parsers.keySet()) if (marker.is(cls, type)) return type;
        throw new IllegalArgumentException("Unsupported type: " + cls);
    }
}
