package au.net.netstorm.boost.bullet.farmer;

import au.net.netstorm.boost.bullet.incredibles.core.Weaken;

public final class DefaultOperationManager implements OperationManager {
    Timeout timeout;
    Waiter waiter;
    Weaken weaken;
    boolean spent;
    boolean done;

    public synchronized void start() {
        spent = false;
        done = false;
    }

    public synchronized void stop() {
        if (spent) return;
        done = true;
        notifyAll();
    }

    public synchronized void done() {
        check();
        stop();
    }

    public synchronized void hold() {
        if (done) return;
        holdon();
        if (!done) throw new Killed();
    }

    private void holdon() {
        long duration = weaken.w(timeout);
        waiter.wait(this, duration);
        spent = true;
    }

    private void check() {
        if (spent) throw new IllegalStateException("Timeout has happened.  Going no further.");
    }
}
