package au.net.netstorm.boost.bullet.farmer;

public final class DefaultPullDecorator<T> implements PullDecorator<T> {
    private final Pull<T> p;
    private final OperationManager m;

    public DefaultPullDecorator(OperationManager m, Pull<T> p) {
        this.m = m;
        this.p = p;
    }

    public T pull() {
        try {
            return p.pull();
        } finally {
            m.done();
        }
    }
}
