package au.net.netstorm.boost.bullet.farmer;

import au.net.netstorm.boost.gunge.async.AsynchronousLayer;
import au.net.netstorm.boost.gunge.lifecycle.StartStop;
import au.net.netstorm.boost.spider.api.config.aspect.Aspector;
import au.net.netstorm.boost.spider.api.config.web.Web;
import au.net.netstorm.boost.spider.api.config.wire.Wire;

// OK NCSS {
public final class FarmerPollingWeb implements Web {
    Aspector aspector;
    Wire wire;

    public void web() {
        wire.cls(PollingFarmerFu.class).to(FarmerFu.class);
        wire.cls(SafeFarmerFu.class).to(FarmerFu.class, PollingFarmerFu.class);
        wire.cls(ManagingFarmerFu.class).to(FarmerFu.class, SafeFarmerFu.class);
        wire.cls(LifecycleFarmerFu.class).to(FarmerFu.class, ManagingFarmerFu.class);
        wire.cls(DefaultFarmerFu.class).to(FarmerFu.class, LifecycleFarmerFu.class);
        wire.cls(FarmerStartStop.class).to(StartStop.class);
        // FIX 3083 Mar 4, 2009 Should not have to specify mapping here.  Just that Continuer is single.
        wire.cls(DefaultContinuer.class).one().to(Continuer.class);
        // FIX 3083 Mar 4, 2009 Should not have to specify mapping here.  Just that OperationManager is single.
        wire.cls(DefaultOperationManager.class).one().to(OperationManager.class);
        aspector.cut(PollingFarmerFu.class, AsynchronousLayer.class);
        aspector.cut(LifecycleFarmerFu.class, AsynchronousLayer.class);
    }
}
// } OK NCSS