package au.net.netstorm.boost.bullet.hub;

import au.net.netstorm.boost.gunge.layer.Layer;
import au.net.netstorm.boost.gunge.layer.Method;

public class HubLayer implements Layer {
    Object[] spokes;

    public HubLayer(Object[] spokes) {
        this.spokes = spokes;
    }

    // FIX 2852 Jan 21, 2009 Do we want this to fail hard on any failure or to be resiliant?
    // FIX 2852 Jan 23, 2009 Probably should be resiliant,
    public Object invoke(Method method, Object[] args) {
        validate(method);
        for (Object spoke : spokes) method.invoke(spoke, args);
        return null;
    }

    private void validate(Method method) {
        if (void.class != method.getReturnType()) throw new IllegalArgumentException("Can only hub void methods.");
    }
}
