package au.net.netstorm.boost.bullet.incredibles.engine.core;

import au.net.netstorm.boost.bullet.incredibles.core.Incredible;
import au.net.netstorm.boost.bullet.incredibles.engine.layer.IncredibleSuit;
import au.net.netstorm.boost.bullet.incredibles.engine.layer.IncredibleTailor;
import au.net.netstorm.boost.bullet.incredibles.engine.layer.StrongLayer;
import au.net.netstorm.boost.bullet.incredibles.engine.layer.StructLayer;
import au.net.netstorm.boost.bullet.incredibles.engine.nvp.core.Nvps;
import au.net.netstorm.boost.bullet.incredibles.engine.order.OrderFu;
import au.net.netstorm.boost.gunge.goop.Ntp;
import au.net.netstorm.boost.gunge.goop.Nvp;
import au.net.netstorm.boost.gunge.layer.Layer;
import au.net.netstorm.boost.gunge.proxy.LayerFactory;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.spider.api.runtime.Nu;

public final class DefaultIncrediblesGu implements IncrediblesGu {
    OrderFu order;
    IncredibleTailor tailor;
    LayerFactory proxies;
    Nvps nvper;
    Nu nu;

    public <T extends Incredible> T struct(Interface<T> iface, Object[] args) {
        Ntp[] ntps = order.o(iface);
        Nvp[] nvps = nvper.nvps(iface, ntps, args);
        IncredibleSuit suit = tailor.struct(iface, nvps);
        Layer layer = nu.nu(StructLayer.class, suit, nvps);
        return nu(iface, layer);
    }

    public <T extends Incredible> T strong(Interface<T> iface, Object arg) {
        IncredibleSuit suit = tailor.strong(iface, arg);
        Layer layer = nu.nu(StrongLayer.class, suit, iface, arg);
        return nu(iface, layer);
    }

    private <T extends Incredible> T nu(Interface<T> iface, Layer layer) {
        return (T) proxies.newProxy(iface, layer);
    }
}