package au.net.netstorm.boost.bullet.incredibles.engine.core;

import java.util.LinkedHashMap;
import java.util.Map;
import au.net.netstorm.boost.bullet.incredibles.engine.layer.DefaultIncredibleSuit;
import au.net.netstorm.boost.bullet.incredibles.engine.layer.DefaultStructLayer;
import au.net.netstorm.boost.bullet.incredibles.engine.nvp.core.CoreNvps;
import au.net.netstorm.boost.bullet.incredibles.engine.nvp.core.GuardNvps;
import au.net.netstorm.boost.bullet.incredibles.engine.nvp.core.Nvps;
import au.net.netstorm.boost.bullet.incredibles.engine.nvp.explicit.ExplicitNvps;
import au.net.netstorm.boost.bullet.incredibles.engine.nvp.inferenced.InferencedNvps;
import au.net.netstorm.boost.bullet.incredibles.engine.order.CoreOrderFu;
import au.net.netstorm.boost.bullet.incredibles.engine.order.ExplicitOrderFu;
import au.net.netstorm.boost.bullet.incredibles.engine.order.LooseOrderFu;
import au.net.netstorm.boost.bullet.incredibles.engine.order.OrderFu;
import au.net.netstorm.boost.gunge.tostring.IndentingToString;
import au.net.netstorm.boost.gunge.tostring.ToString;
import au.net.netstorm.boost.spider.api.config.web.Web;
import au.net.netstorm.boost.spider.api.config.wire.Wire;

public final class IncrediblesWeb implements Web {
    Wire wire;

    public void web() {
        nvp();
        order();
        other();
    }

    private void order() {
        wire.cls(CoreOrderFu.class).to(OrderFu.class);
        wire.cls(ExplicitOrderFu.class).to(OrderFu.class, CoreOrderFu.class, "explicit");
        wire.cls(LooseOrderFu.class).to(OrderFu.class, CoreOrderFu.class, "loose");
    }

    private void other() {
        wire.cls(IndentingToString.class).to(ToString.class, DefaultIncredibleSuit.class);
        wire.cls(LinkedHashMap.class).to(Map.class, DefaultStructLayer.class);
    }

    private void nvp() {
        wire.cls(GuardNvps.class).to(Nvps.class);
        wire.cls(CoreNvps.class).to(Nvps.class, GuardNvps.class);
        wire.cls(ExplicitNvps.class).to(Nvps.class, CoreNvps.class, "explicit");
        wire.cls(InferencedNvps.class).to(Nvps.class, CoreNvps.class, "inferenced");
    }
}
