package au.net.netstorm.boost.bullet.incredibles.engine.layer;

import au.net.netstorm.boost.bullet.primordial.Primordial;
import au.net.netstorm.boost.gunge.layer.Layers;
import au.net.netstorm.boost.gunge.layer.Method;
import au.net.netstorm.boost.gunge.layer.Methods;
import au.net.netstorm.boost.gunge.layer.Stripper;
import au.net.netstorm.boost.gunge.type.Interface;

public class DefaultStrongLayer extends Primordial implements StrongLayer {
    private IncredibleSuit suit;
    private Interface type;
    private Object value;
    Stripper stripper;
    Methods methods;
    Layers layers;

    public DefaultStrongLayer(IncredibleSuit suit, Interface type, Object value) {
        this.suit = suit;
        this.type = type;
        this.value = value;
    }

    public Object value() {
        return value;
    }

    public Class type() {
        return type.v();
    }

    public Object invoke(Method method, Object[] args) {
        if (methods.is(method, "equals")) return eq(args[0]);
        if (methods.is(method, "hashCode")) return suit.hashCode();
        if (methods.is(method, "toString")) return suit.toString();
        throw new UnsupportedOperationException();
    }

    // OK IllegalType {
    private boolean eq(Object o) {
        if (!layers.is(o)) return false;
        DefaultStrongLayer other = stripper.strip(DefaultStrongLayer.class, o);
        return suit.equals(other.suit);
    }
    // } OK IllegalType
}
