package au.net.netstorm.boost.bullet.incredibles.engine.layer;

import au.net.netstorm.boost.bullet.incredibles.core.Weaken;
import au.net.netstorm.boost.bullet.incredibles.engine.core.IncredibleTypes;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.gunge.type.Marker;

public final class DefaultStrongValidator implements StrongValidator {
    IncredibleTypes types;
    Weaken weaken;
    Marker marker;

    public void check(Interface iface, Object value) {
        if (!types.strong(iface)) throw new IllegalArgumentException("Expected a strong.");
        Class weak = weaken.w(iface.v());
        check(weak, value);
    }

    private void check(Class weak, Object value) {
        if (!marker.is(value, weak)) barf(weak, value);
    }

    private void barf(Class weak, Object value) {
        String msg = "Type error, expected " + weak + " got " + value.getClass();
        throw new IllegalArgumentException(msg);
    }
}
