package au.net.netstorm.boost.bullet.incredibles.engine.nvp.core;

import java.util.Arrays;
import java.util.List;
import au.net.netstorm.boost.gunge.goop.Ntp;
import au.net.netstorm.boost.gunge.goop.Nvp;
import au.net.netstorm.boost.gunge.type.Interface;

public final class GuardNvps implements Nvps {
    Nvps nvps;

    public Nvp[] nvps(Interface iface, Ntp[] ntps, Object[] values) {
        guard(iface, ntps, values);
        return nvps.nvps(iface, ntps, values);
    }

    private void guard(Interface iface, Ntp[] ntps, Object[] values) {
        length(iface, ntps, values);
        nulls(iface, values);
    }

    private void nulls(Interface iface, Object[] values) {
        for (int i = 0; i < values.length; i++) {
            if (values[i] == null) pop(iface, i);
        }
    }

    private void length(Interface iface, Ntp[] methods, Object[] values) {
        if (methods.length != values.length) pop(iface, values);
    }

    private void pop(Interface iface, Object... values) {
        List these = Arrays.asList(values);
        throw new IllegalArgumentException("Argument number mismatch for " + iface + " with " + these);
    }

    private void pop(Interface iface, int i) {
        throw new IllegalArgumentException("Cannot have null argument (arg " + i + ") in " + iface);
    }
}
