package au.net.netstorm.boost.bullet.incredibles.engine.nvp.explicit;

import au.net.netstorm.boost.bullet.incredibles.engine.nvp.core.Nvps;
import static au.net.netstorm.boost.bullet.incredibles.engine.order.NaughtyNugget.NUGGET;
import au.net.netstorm.boost.gunge.goop.Ntp;
import au.net.netstorm.boost.gunge.goop.Nvp;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.spider.api.runtime.Nu;

public final class ExplicitNvps implements Nvps {
    Nu nu;

    public Nvp[] nvps(Interface iface, Ntp[] ns, Object[] os) {
        Nvp[] r = new Nvp[ns.length];
        for (int i = 0; i < ns.length; i++) r[i] = nu(iface, ns[i], os[i]);
        return r;
    }

    private Nvp nu(Interface iface, Ntp ns, Object o) {
        check(iface, ns, o);
        String name = ns.name();
        return nu.nu(Nvp.class, name, o);
    }

    private void check(Interface iface, Ntp ns, Object o) {
        Class cls = o.getClass();
        Class type = ns.type();
        if (!type.isAssignableFrom(cls)) barf(iface);
    }

    private void barf(Interface iface) {
        throw new IllegalArgumentException("Incorrect explicit constructor order.  " +
                "Review value of '" + NUGGET + "' for: " + iface);
    }
}
