package au.net.netstorm.boost.bullet.incredibles.engine.nvp.inferenced;

import static au.net.netstorm.boost.bullet.incredibles.engine.order.NaughtyNugget.NUGGET;
import au.net.netstorm.boost.gunge.goop.Ntp;
import au.net.netstorm.boost.gunge.type.Interface;

public final class DefaultInferencedChecker implements InferencedChecker {
    public void check(Interface iface, Ntp[] ntps) {
        for (int i = 0; i < ntps.length; i++)
            checkUnique(iface, ntps, ntps[i], i + 1);
    }

    private void checkUnique(Interface iface, Ntp[] methods, Ntp method, int start) {
        Class type = method.type();
        for (int i = start; i < methods.length; i++)
            checkNotVariant(iface, type, methods[i]);
    }

    private void checkNotVariant(Interface iface, Class<?> type, Ntp other) {
        Class check = other.type();
        if (compatible(type, check)) barf(iface);
        if (compatible(check, type)) barf(iface);
    }

    private boolean compatible(Class c1, Class c2) {
        return c1.isAssignableFrom(c2);
    }

    private void barf(Interface iface) {
        String message = "Could not infer arguments, for " + iface +
                " use explicit '" + NUGGET + "' field to designate constructor order.";
        throw new IllegalArgumentException(message);
    }
}
