package au.net.netstorm.boost.bullet.incredibles.engine.nvp.inferenced;

import au.net.netstorm.boost.bullet.incredibles.engine.nvp.core.Nvps;
import au.net.netstorm.boost.gunge.goop.Ntp;
import au.net.netstorm.boost.gunge.goop.Nvp;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.spider.api.runtime.Nu;

public final class InferencedNvps implements Nvps {
    InferencedChecker inferenced;
    Nu nu;

    public Nvp[] nvps(Interface iface, Ntp[] ntps, Object[] values) {
        inferenced.check(iface, ntps);
        return build(ntps, values);
    }

    private Nvp[] build(Ntp[] ntps, Object[] values) {
        Nvp[] r = new Nvp[ntps.length];
        for (int i = 0; i < ntps.length; i++) {
            r[i] = spec(ntps[i], values);
        }
        return r;
    }

    private Nvp spec(Ntp ntp, Object[] values) {
        String name = ntp.name();
        Class type = ntp.type();
        Object value = findCompatible(type, values);
        return nu.nu(Nvp.class, name, value);
    }

    private Object findCompatible(Class<?> type, Object[] values) {
        for (Object arg : values) {
            Class cls = arg.getClass();
            if (compatible(type, cls)) return arg;
        }
        throw new IllegalStateException();
    }

    private boolean compatible(Class c1, Class c2) {
        return c1.isAssignableFrom(c2);
    }
}
