package au.net.netstorm.boost.bullet.incredibles.engine.order;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import static au.net.netstorm.boost.bullet.incredibles.engine.order.NaughtyNugget.NUGGET;
import au.net.netstorm.boost.gunge.array.ArrayMaestro;
import au.net.netstorm.boost.gunge.goop.Ntp;
import au.net.netstorm.boost.gunge.reflect.field.StaticFields;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.spider.api.runtime.Nu;

public final class ExplicitOrderFu implements OrderFu {
    ArrayMaestro arrays;
    StaticFields fields;
    Nu nu;

    public Ntp[] o(Interface type) {
        Class cls = type.v();
        return o(cls);
    }

    private Ntp[] o(Class cls) {
        String[] order = fields.get(cls, NUGGET, String[].class);
        Method[] methods = cls.getMethods();
        Map ms = map(methods);
        return build(cls, order, ms);
    }

    private Ntp[] build(Class type, String[] names, Map methods) {
        List<Ntp> r = new ArrayList();
        for (String name : names) add(r, type, name, methods);
        if (methods.size() > 0) throw new IllegalStateException("More methods than in explicit declaration " + type);
        return arrays.array(r, Ntp.class);
    }

    private void add(List<Ntp> r, Class type, String name, Map<String, Method> methods) {
        if (!methods.containsKey(name)) throw new IllegalStateException("No method with name " + name + " in " + type);
        Method method = methods.get(name);
        add(r, method);
        methods.remove(name);
    }

    private void add(List<Ntp> r, Method method) {
        Class type = method.getReturnType();
        String name = method.getName();
        Ntp ntp = nu.nu(Ntp.class, name, type);
        r.add(ntp);
    }

    private Map map(Method[] ms) {
        Map<String, Method> r = new HashMap();
        for (Method m : ms) put(r, m);
        return r;
    }

    private void put(Map r, Method m) {
        String name = m.getName();
        r.put(name, m);
    }
}
