package au.net.netstorm.boost.bullet.log;

import au.net.netstorm.boost.gunge.exception.ThrowableMaster;
import au.net.netstorm.boost.gunge.layer.Layer;
import au.net.netstorm.boost.gunge.layer.Method;
import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.type.Implementation;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.gunge.type.TypeMaster;
import au.net.netstorm.boost.spider.api.lifecycle.Constructable;
import au.net.netstorm.boost.spider.api.runtime.Nu;

// FIX ()  97098 Spike.  TDD up.
public class LogLayer implements Layer, Constructable {
    private final Object ref;
    private Interface service;
    ClassNames classer;
    ThrowableMaster tosser;
    TypeMaster master;
    Nu nu;
    Log log;

    public LogLayer(Object ref) {
        this.ref = ref;
    }

    public void constructor() {
        service = service(ref);
    }

    public Object invoke(Method method, Object[] args) {
        String name = method.getName();
        return invoke(name, method, args);
    }

    // OK NCSS {
    private Object invoke(String action, Method method, Object[] args) {
        try {
            log("Attempt", action, args);
            Object result = method.invoke(ref, args);
            log("Success", action, args);
            return result;
        } catch (Throwable t) {
            log("Failed", action, args);
            tosser.rethrow(t);
        }
        return NEVER;
    }
    // } OK NCSS

    private void log(String status, String action, Object[] args) {
        String arguments = args(args);
        String operation = classer.shorty(service);
        log.trace(status + " " + operation + " : " + action + " : " + arguments);
    }

    // FIX 97098 Sort out this ugly little dog biscuit
    private String args(Object[] args) {
        String result = "[";
        if (args != null) result += commaSeparate(args);
        result += "]";
        return result;
    }

    private String commaSeparate(Object[] args) {
        String result = "";
        for (int i = 0; i < args.length; i++) {
            if (i > 0) result += ", ";
            result += args[i];
        }
        return result;
    }

    private Interface service(Object ref) {
        Class cls = ref.getClass();
        Implementation impl = nu.nu(Implementation.class, cls);
        Interface[] ifaces = master.interfaces(impl);
        // FIX  96238 This is broken - don't always want the first one!
        return ifaces[0];
    }

    private static final Object NEVER = null;
}
