package au.net.netstorm.boost.bullet.roughly;

import au.net.netstorm.boost.bullet.time.core.Duration;
import au.net.netstorm.boost.bullet.time.core.TimeUnit;

public final class DefaultRoughly implements Roughly {
    TimeSlicer slicer;

    public String is(Duration duration) {
        TimeSlice slice = slicer.slice(duration);
        return format(slice, duration);
    }

    private String format(TimeSlice slice, Duration duration) {
        String message = slice.message();
        if (!message.contains("%d")) return message;
        return format(slice, duration, message);
    }

    private String format(TimeSlice slice, Duration duration, String message) {
        TimeUnit unit = slice.units();
        long value = duration.millis / unit.millis;
        return String.format(message, value);
    }
}
