package au.net.netstorm.boost.bullet.roughly;

import au.net.netstorm.boost.bullet.time.core.Duration;
import au.net.netstorm.boost.bullet.time.core.TimeUnit;

public final class DefaultTimeSlicer implements TimeSlicer {
    TimeSlices slices;

    public TimeSlice slice(Duration duration) {
        TimeSlice selected = first();
        for (TimeSlice slice : slices.v()) {
            if (past(duration, slice)) return selected;
            selected = slice;
        }
        return selected;
    }

    private TimeSlice first() {
        TimeSlice[] list = slices.v();
        return list[0];
    }

    private boolean past(Duration duration, TimeSlice slice) {
        long start = slice.start();
        TimeUnit unit = slice.units();
        long reference = start * unit.millis;
        return reference > duration.millis;
    }
}
