package au.net.netstorm.boost.bullet.roughly;

import au.net.netstorm.boost.bullet.time.core.TimeUnit;
import static au.net.netstorm.boost.bullet.time.core.TimeUnit.DAYS;
import static au.net.netstorm.boost.bullet.time.core.TimeUnit.HOURS;
import static au.net.netstorm.boost.bullet.time.core.TimeUnit.MINUTES;
import static au.net.netstorm.boost.bullet.time.core.TimeUnit.MONTHS;
import static au.net.netstorm.boost.bullet.time.core.TimeUnit.SECONDS;
import static au.net.netstorm.boost.bullet.time.core.TimeUnit.WEEKS;
import static au.net.netstorm.boost.bullet.time.core.TimeUnit.YEARS;
import au.net.netstorm.boost.spider.api.lifecycle.Constructable;
import au.net.netstorm.boost.spider.api.runtime.Nu;

public final class DefaultTimeSlices implements TimeSlices, Constructable {
    private TimeSlice[] slices;
    Nu nu;

    // Suggest: "humour 8 months since PF".
    // Suggest: "humour Since Christmas".
    public void constructor() {
        slices = new TimeSlice[]{
                s(0, SECONDS, "just happened"),
                s(1, SECONDS, "1 second"),
                s(2, SECONDS, "%d seconds"),
                s(40, SECONDS, "almost a minute"),
                s(1, MINUTES, "1 minute"),
                s(2, MINUTES, "%d minutes"),
                s(20, MINUTES, "half an hour"),
                s(40, MINUTES, "almost an hour"),
                s(1, HOURS, "1 hour"),
                s(2, HOURS, "%d hours"),
                s(4, HOURS, "half a day"),
                s(8, HOURS, "almost a day"),
                s(1, DAYS, "1 day"),
                s(2, DAYS, "%d days"),
                s(5, DAYS, "almost a week"),
                s(1, WEEKS, "1 week"),
                s(2, WEEKS, "%d weeks"),
                s(4, WEEKS, "almost a month"),
                s(1, MONTHS, "1 month"),
                s(2, MONTHS, "%d months"),
                s(6, MONTHS, "half a year"),
                s(7, MONTHS, "over half a year"),
                s(9, MONTHS, "almost a year"),
                s(1, YEARS, "1 year"),
                s(2, YEARS, "%d years"),
        };
    }

    public TimeSlice[] v() {
        return slices;
    }

    private TimeSlice s(long start, TimeUnit unit, String message) {
        return nu.nu(TimeSlice.class, start, message, unit);
    }
}
