package au.net.netstorm.boost.bullet.scalpel.engine;

import au.net.netstorm.boost.bullet.scalpel.core.Edge;
import au.net.netstorm.boost.bullet.scalpel.core.Unedgable;
import au.net.netstorm.boost.gunge.proxy.LayerFactory;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.gunge.type.InterfaceMaster;
import au.net.netstorm.boost.spider.api.runtime.Impl;

public final class DefaultEdgesFu implements EdgesFu {
    InterfaceMaster interfaces;
    LayerFactory layers;
    Impl impl;

    public <E extends Edge> E instance(Class<E> eclass, Class rclass, Object real) {
        Scalpel scalpel = scalpel(rclass, real);
        return proxy(eclass, scalpel, eclass, Unedgable.class);
    }

    public <E extends Edge> E statik(Class<E> edge, Class rclass) {
        Scalpel common = impl.impl(DefaultScalpel.class, rclass, null);
        Scalpel scalpel = impl.impl(StaticScalpel.class, common, rclass);
        return proxy(edge, scalpel, edge);
    }

    public <O extends Edge, E extends O> E cast(Class<E> eclass, Class rclass, O old) {
        Unedgable unedgable = (Unedgable) old;
        Object real = unedgable.unedge();
        Scalpel scalpel = scalpel(rclass, real);
        return proxy(eclass, scalpel, eclass, Unedgable.class);
    }

    private <E extends Edge> E proxy(Class<E> eclass, Scalpel scalpel, Class... type) {
        Interface[] ifaces = interfaces.interfaces(type);
        Object proxy = layers.newProxy(ifaces, scalpel);
        return eclass.cast(proxy);
    }

    private Scalpel scalpel(Class rclass, Object real) {
        return impl.impl(DefaultScalpel.class, rclass, real);
    }
}
