package au.net.netstorm.boost.bullet.scalpel.engine;

import au.net.netstorm.boost.bullet.scalpel.core.Edge;

public final class DefaultEdging implements Edging {
    EdgeMapper mapper;
    EdgesFu fu;
    RealNu nu;

    public <E extends Edge> E ref(Class<E> edge, Object real) {
        Class realClass = mapper.edgeToReal(edge);
        check(realClass, real);
        return fu.instance(edge, realClass, real);
    }

    public <E extends Edge> E statik(Class<E> edge) {
        Class realClass = mapper.staticEdgeToReal(edge);
        return fu.statik(edge, realClass);
    }

    public <O extends Edge, E extends O> E cast(Class<E> edge, O oldEdge) {
        Class realClass = mapper.edgeToReal(edge);
        return fu.cast(edge, realClass, oldEdge);
    }

    public <E extends Edge> E nu(Class<E> edge, Object... params) {
        Class realClass = mapper.edgeToReal(edge);
        Object real = nu.nu(realClass, params);
        return fu.instance(edge, realClass, real);
    }

    public <E extends Edge> E impl(Class<E> edge, Class concrete, Object... params) {
        Object real = nu.nu(concrete, params);
        Class realClass = mapper.edgeToReal(edge);
        return fu.instance(edge, realClass, real);
    }

    private void check(Class cls, Object o) {
        if (!cls.isInstance(o)) throw new IllegalArgumentException("Real class mismatch - illegal type.");
    }
}
