package au.net.netstorm.boost.bullet.scalpel.engine;

import au.net.netstorm.boost.bullet.scalpel.core.Unedgable;
import au.net.netstorm.boost.gunge.layer.Method;
import au.net.netstorm.boost.gunge.layer.Methods;

public final class DefaultScalpel implements Scalpel {
    private final Class rclass;
    private final Object real;
    Methods methods;
    GroupUnedger unedger;
    ReturnEdger returner;
    MethodWarp warper;

    public DefaultScalpel(Class rclass, Object real) {
        this.rclass = rclass;
        this.real = real;
    }

    public Object invoke(Method emethod, Object[] eargs) {
        if (methods.on(emethod, Unedgable.class)) return real;
        Object[] rargs = unedger.unedge(eargs);
        Method rmethod = method(emethod);
        Object rreturn = rmethod.invoke(real, rargs);
        return returner.edge(emethod, rreturn);
    }

    private Method method(Method emethod) {
        return methods.on(emethod, Object.class) ? emethod : warper.warp(rclass, emethod);
    }
}
