package au.net.netstorm.boost.bullet.scalpel.engine;

import au.net.netstorm.boost.bullet.scalpel.core.Edge;
import au.net.netstorm.boost.bullet.scalpel.core.Unedgable;

public final class DefaultUnedger implements Unedger {
    EdgeMapper mapper;
    Unedger arrays;

    public Class unedge(Class candidate) {
        if (candidate.isArray()) return arrays.unedge(candidate);
        if (!Edge.class.isAssignableFrom(candidate)) return candidate;
        return mapper.edgeToReal(candidate);
    }

    public Object unedge(Object candidate) {
        if (candidate == null) return null;
        if (isArray(candidate)) return arrays.unedge(candidate);
        if (!(candidate instanceof Unedgable)) return candidate;
        Unedgable edge = (Unedgable) candidate;
        return edge.unedge();
    }

    private boolean isArray(Object candidate) {
        Class cls = candidate.getClass();
        return cls.isArray();
    }
}
