package au.net.netstorm.boost.bullet.scalpel.engine;

import au.net.netstorm.boost.gunge.layer.Layers;
import au.net.netstorm.boost.gunge.layer.Method;
import au.net.netstorm.boost.gunge.layer.Methods;
import au.net.netstorm.boost.gunge.layer.Stripper;

public class StaticScalpel implements Scalpel {
    private final Class real;
    private Scalpel delegate;
    Stripper stripper;
    Methods methods;
    Layers layers;

    public StaticScalpel(Scalpel delegate, Class real) {
        this.real = real;
        this.delegate = delegate;
    }

    public Object invoke(Method method, Object[] args) {
        if (methods.is(method, "toString")) return string();
        if (methods.is(method, "hashCode")) return hash();
        if (methods.is(method, "equals")) return eq(args[0]);
        return delegate.invoke(method, args);
    }

    private boolean eq(Object o) {
        if (!layers.is(o)) return false;
        StaticScalpel other = stripper.strip(StaticScalpel.class, o);
        return real.equals(other.real);
    }

    private int hash() {
        return real.hashCode();
    }

    private String string() {
        String name = real.getName();
        return "StaticEdge<" + name + ">";
    }
}
