package au.net.netstorm.boost.bullet.scalpel.spider;

import au.net.netstorm.boost.bullet.scalpel.core.Edge;
import au.net.netstorm.boost.spider.api.runtime.Impl;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.plugs.factory.core.Factory;
import au.net.netstorm.boost.spider.plugs.gunge.Is;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class EdgeFactory implements Factory {
    Impl impl;
    Is is;

    public Provider nu(InjectionType type) {
        Class edge = type.rawClass();
        Class<? extends Provider> provider = determine(edge);
        return impl.impl(provider, edge);
    }

    public boolean can(InjectionType type) {
        return is.assignable(type, Edge.class);
    }

    private Class<? extends Provider> determine(Class edge) {
        String name = edge.getName();
        return name.endsWith("Static") ? EdgeStaticProvider.class : EdgeInstanceProvider.class;
    }
}
