package au.net.netstorm.boost.bullet.time.core;

import au.net.netstorm.boost.gunge.sledge.java.lang.EdgeSystem;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.marker.LazyFields;
import au.net.netstorm.boost.sniper.reflect.util.FieldTestUtil;

public final class DefaultClockAtomicTest extends LifecycleTestCase implements HasFixtures, InjectableTest, LazyFields {
    Long now = 1L;
    Clock subject;
    FieldTestUtil fielder;
    TimePoint expected;
    EdgeSystem systemMock;
    Long millis;

    public void fixtures() {
        inject(subject);
    }

    public void testSubject() {
        expect.oneCall(systemMock, new Long(now), "currentTimeMillis");
        TimePoint expected = new DefaultTimePoint(now);
        TimePoint actual = subject.now();
        assertEquals(expected, actual);
    }

    private void inject(Object ref) {
        fielder.setInstance(ref, "system", systemMock);
    }
}
