package au.net.netstorm.boost.bullet.time.core;

public final class DefaultNowFactory implements NowFactory {
    Clock clock;
    TimeFactory timer;

    public TimePoint now() {
        return clock.now();
    }

    public boolean inPast(TimePoint time) {
        TimePoint now = now();
        return time.before(now);
    }

    public boolean inFuture(TimePoint time) {
        TimePoint now = now();
        return time.after(now);
    }

    // FIX 244 Consider returning range, probably more usefull as a whole.
    public Duration since(TimePoint past) {
        TimePoint now = now();
        if (!past.before(now)) throw new IllegalArgumentException("Past must be in the past.");
        return duration(now, past);
    }

    public Duration until(TimePoint future) {
        TimePoint now = now();
        if (!future.after(now)) throw new IllegalArgumentException("Future must be in the future.");
        return duration(future, now);
    }

    private Duration duration(TimePoint start, TimePoint end) {
        TimeRange range = timer.range(end, start);
        return range.duration();
    }
}
