package au.net.netstorm.boost.demo.hub.spider;

import au.net.netstorm.boost.bullet.hub.Hubs;
import au.net.netstorm.boost.demo.hub.direct.DefaultGrabBag;
import au.net.netstorm.boost.demo.hub.direct.GrabBag;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.marker.OverlaysWeb;

public class HubSpiderDemoTest extends LifecycleTestCase implements InjectableTest, OverlaysWeb {
    GrabBag checker;
    Canon canon;

    public void overlay() {
        // FIX 2950 Feb 16, 2009 Sort out Scoreboard Hub.
        wire.cls(DefaultGrabBag.class).one().to(GrabBag.class);
        // FIX 3323 Mar 5, 2009 Work out a nicer way to do hubs.  No longer done in Target.
        Hubs hubs = spider.resolve(Hubs.class);
        Canon ref = hubs.nu(Canon.class, BigCanon.class, LittleCanon.class);
        wire.ref(ref).to(Canon.class);
    }

    public void test() {
        canon.fire();
        check(true, BigCanon.class);
        check(true, LittleCanon.class);
    }

    private void check(boolean expected, Class cls) {
        boolean actual = checker.has(cls);
        assertEquals(expected, actual);
    }
}