package au.net.netstorm.boost.demo.incredibles.basic;

import au.net.netstorm.boost.bullet.incredibles.core.Strong;
import au.net.netstorm.boost.bullet.incredibles.core.Typen;
import au.net.netstorm.boost.bullet.incredibles.core.Weaken;
import static au.net.netstorm.boost.gunge.separator.Separator.LINE;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public final class IncrediblesBasicDemoTest extends LifecycleTestCase implements InjectableTest {
    SockFactory socks;
    Weaken weaken;
    Typen typen;

    public void testEquality() {
        Sock s1 = socks.sock();
        Sock s2 = socks.sock();
        assertEquals(true, s1 != s2);
        assertEquals(s1, s2);
    }

    public void testString() {
        Sock sock = socks.sock();
        assertEquals(expected(), "" + sock);
    }

    public void testTypen() {
        Sock sock = socks.sock();
        checkTypen(Host.class, sock.host());
        checkTypen(Port.class, sock.port());
    }

    public void testWeaken() {
        Sock sock = socks.sock();
        checkWeaken("doggdot.us", sock.host());
        checkWeaken(8081, sock.port());
    }

    private String expected() {
        return "Sock[" + LINE +
                "    host=Host[doggdot.us]" + LINE +
                "    port=Port[8081]" + LINE +
                "]";
    }

    private void checkTypen(Class expected, Strong s) {
        Class actual = typen.t(s);
        assertEquals(expected, actual);
    }

    private void checkWeaken(Object expected, Strong s) {
        Object actual = weaken.w(s);
        assertEquals(expected, actual);
    }
}
