package au.net.netstorm.boost.demo.scalpel.core;

import au.net.netstorm.boost.bullet.scalpel.core.Edges;
import au.net.netstorm.boost.demo.scalpel.edge.au.net.netstorm.boost.demo.scalpel.fixture.ArrayGuy;
import au.net.netstorm.boost.demo.scalpel.edge.java.lang.Integer;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public final class ArrayGuyDemoTest extends LifecycleTestCase implements HasFixtures, InjectableTest {
    private au.net.netstorm.boost.demo.scalpel.fixture.ArrayGuy real;
    private ArrayGuy edge;
    Edges edges;

    public void fixtures() {
        real = new au.net.netstorm.boost.demo.scalpel.fixture.ArrayGuy();
        edge = edges.ref(ArrayGuy.class, real);
    }

    public void testRealPrimitiveArray() {
        byte[] expected = real.bytes();
        byte[] actual = edge.bytes();
        assertEquals(expected, actual);
    }

    public void testRealPrimitiveDualArray() {
        byte[][] expected = real.lotsOfBytes();
        byte[][] actual = edge.lotsOfBytes();
        assertEquals(expected, actual);
    }

    public void testEdgeObjectArray() {
        java.lang.Integer[] reals = real.ints();
        Integer[] expected = edge(reals);
        Integer[] actual = edge.ints();
        assertEquals(expected, actual);
    }

    public void testEdgeObjectDualArray() {
        java.lang.Integer[][] integers = real.lotsOfInts();
        Integer[][] expected = edge(integers);
        Integer[][] actual = edge.lotsOfInts();
        assertEquals(expected, actual);
    }

    public void testRealObjectArray() {
        Double[] expected = real.doubles();
        Double[] actual = edge.doubles();
        assertEquals(expected, actual);
    }

    public void testRealObjectDualArray() {
        Double[][] expected = real.lotsOfDoubles();
        Double[][] actual = edge.lotsOfDoubles();
        assertEquals(expected, actual);
    }

    // FIX 2394 Below here -- This should be a utility with the autoedger.
    private Integer[][] edge(java.lang.Integer[][] integers) {
        Integer[][] result = new Integer[integers.length][integers[0].length];
        for (int i = 0; i < integers.length; i++) {
            result[i] = edge(integers[i]);
        }
        return result;
    }

    private Integer[] edge(java.lang.Integer[] reals) {
        Integer[] result = new Integer[reals.length];
        for (int i = 0; i < reals.length; i++) {
            Integer edge = edges.ref(Integer.class, reals[i]);
            result[i] = edge;
        }
        return result;
    }
}
