package au.net.netstorm.boost.demo.scalpel.core;

import au.net.netstorm.boost.bullet.scalpel.core.Edges;
import au.net.netstorm.boost.demo.scalpel.bad.edge.java.lang.BadName;
import au.net.netstorm.boost.demo.scalpel.bad.edge.java.lang.Class;
import au.net.netstorm.boost.demo.scalpel.bad.edge.java.lang.ClassStatic;
import au.net.netstorm.boost.demo.scalpel.bad.edge.java.lang.Object;
import au.net.netstorm.boost.demo.scalpel.edge.bad.pack.age.String;
import au.net.netstorm.boost.gunge.exception.ThrowableMaster;
import au.net.netstorm.boost.gunge.sledge.support.SledgeException;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public class BadEdgeDefinitionDemoTest extends LifecycleTestCase implements InjectableTest {
    ThrowableMaster thrower;
    Edges edges;

    public void testMethodMissing() {
        Object o = edges.ref(au.net.netstorm.boost.demo.scalpel.bad.edge.java.lang.Object.class, new java.lang.Object());
        try {
            o.missing();
            fail();
        } catch (SledgeException e) {
            Throwable real = thrower.rootCause(e);
            assertEquals(true, real instanceof NoSuchMethodException);
        }
    }

    public void testInvalidName() {
        try {
            edges.ref(BadName.class, new java.lang.Object());
            fail();
        } catch (IllegalArgumentException expected) { }
    }

    public void testInvalidReturnType() {
        ClassStatic classes = edges.statik(ClassStatic.class);
        try {
            classes.forName("blah");
            fail();
        } catch (IllegalArgumentException expected) {}
    }

    public void testInvalidArrayReturnType() {
        Class cls = edges.ref(Class.class, Edges.class);
        try {
            cls.getFields();
            fail();
        } catch (IllegalArgumentException expected) {}
    }

    public void testInvalidPackage() {
        try {
            edges.ref(String.class, "");
            fail();
        } catch (IllegalArgumentException expected) { }
    }
}
