package au.net.netstorm.boost.demo.scalpel.core;

import java.io.ByteArrayInputStream;
import au.net.netstorm.boost.bullet.scalpel.core.Edges;
import au.net.netstorm.boost.demo.scalpel.edge.java.io.InputStream;
import au.net.netstorm.boost.demo.scalpel.edge.java.security.cert.Certificate;
import au.net.netstorm.boost.demo.scalpel.edge.java.security.cert.CertificateFactory;
import au.net.netstorm.boost.demo.scalpel.edge.java.security.cert.CertificateFactoryStatic;
import au.net.netstorm.boost.demo.scalpel.edge.java.security.cert.X509Certificate;
import au.net.netstorm.boost.demo.scalpel.edge.java.util.Date;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public final class CertificateDemoTest extends LifecycleTestCase implements InjectableTest {
    Edges edges;

    // FIX 2040 Jan 12, 2009 Add another test to demonstrate the preferred pattern of creating an edge BAIS to avoid using nee.
    public void testEdge() {
        CertificateFactoryStatic stat = edges.statik(CertificateFactoryStatic.class);
        InputStream stream = edges.impl(InputStream.class, ByteArrayInputStream.class, CERT);
        checkEdge(stat, stream);
    }

    private void checkEdge(CertificateFactoryStatic stat, InputStream stream) {
        CertificateFactory factory = stat.getInstance("X.509");
        Certificate certificate = factory.generateCertificate(stream);
        X509Certificate x509 = edges.cast(X509Certificate.class, certificate);
        Date notAfter = x509.getNotAfter();
        long time = notAfter.getTime();
        assertEquals(991468533000L, time);
    }

    private static final byte[] CERT = {
            (byte) 0x30, (byte) 0x82, (byte) 0x03, (byte) 0x6c, (byte) 0x30, (byte) 0x82, (byte) 0x02, (byte) 0xd5,
            (byte) 0xa0, (byte) 0x03, (byte) 0x02, (byte) 0x01, (byte) 0x02, (byte) 0x02, (byte) 0x01, (byte) 0x00,
            (byte) 0x30, (byte) 0x0d, (byte) 0x06, (byte) 0x09, (byte) 0x2a, (byte) 0x86, (byte) 0x48, (byte) 0x86,
            (byte) 0xf7, (byte) 0x0d, (byte) 0x01, (byte) 0x01, (byte) 0x04, (byte) 0x05, (byte) 0x00, (byte) 0x30,
            (byte) 0x81, (byte) 0xb7, (byte) 0x31, (byte) 0x0b, (byte) 0x30, (byte) 0x09, (byte) 0x06, (byte) 0x03,
            (byte) 0x55, (byte) 0x04, (byte) 0x06, (byte) 0x13, (byte) 0x02, (byte) 0x41, (byte) 0x55, (byte) 0x31,
            (byte) 0x11, (byte) 0x30, (byte) 0x0f, (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x04, (byte) 0x08,
            (byte) 0x13, (byte) 0x08, (byte) 0x56, (byte) 0x69, (byte) 0x63, (byte) 0x74, (byte) 0x6f, (byte) 0x72,
            (byte) 0x69, (byte) 0x61, (byte) 0x31, (byte) 0x18, (byte) 0x30, (byte) 0x16, (byte) 0x06, (byte) 0x03,
            (byte) 0x55, (byte) 0x04, (byte) 0x07, (byte) 0x13, (byte) 0x0f, (byte) 0x53, (byte) 0x6f, (byte) 0x75,
            (byte) 0x74, (byte) 0x68, (byte) 0x20, (byte) 0x4d, (byte) 0x65, (byte) 0x6c, (byte) 0x62, (byte) 0x6f,
            (byte) 0x75, (byte) 0x72, (byte) 0x6e, (byte) 0x65, (byte) 0x31, (byte) 0x1a, (byte) 0x30, (byte) 0x18,
            (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x04, (byte) 0x0a, (byte) 0x13, (byte) 0x11, (byte) 0x43,
            (byte) 0x6f, (byte) 0x6e, (byte) 0x6e, (byte) 0x65, (byte) 0x63, (byte) 0x74, (byte) 0x20, (byte) 0x34,
            (byte) 0x20, (byte) 0x50, (byte) 0x74, (byte) 0x79, (byte) 0x20, (byte) 0x4c, (byte) 0x74, (byte) 0x64,
            (byte) 0x31, (byte) 0x1e, (byte) 0x30, (byte) 0x1c, (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x04,
            (byte) 0x0b, (byte) 0x13, (byte) 0x15, (byte) 0x43, (byte) 0x65, (byte) 0x72, (byte) 0x74, (byte) 0x69,
            (byte) 0x66, (byte) 0x69, (byte) 0x63, (byte) 0x61, (byte) 0x74, (byte) 0x65, (byte) 0x20, (byte) 0x41,
            (byte) 0x75, (byte) 0x74, (byte) 0x68, (byte) 0x6f, (byte) 0x72, (byte) 0x69, (byte) 0x74, (byte) 0x79,
            (byte) 0x31, (byte) 0x15, (byte) 0x30, (byte) 0x13, (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x04,
            (byte) 0x03, (byte) 0x13, (byte) 0x0c, (byte) 0x43, (byte) 0x6f, (byte) 0x6e, (byte) 0x6e, (byte) 0x65,
            (byte) 0x63, (byte) 0x74, (byte) 0x20, (byte) 0x34, (byte) 0x20, (byte) 0x43, (byte) 0x41, (byte) 0x31,
            (byte) 0x28, (byte) 0x30, (byte) 0x26, (byte) 0x06, (byte) 0x09, (byte) 0x2a, (byte) 0x86, (byte) 0x48,
            (byte) 0x86, (byte) 0xf7, (byte) 0x0d, (byte) 0x01, (byte) 0x09, (byte) 0x01, (byte) 0x16, (byte) 0x19,
            (byte) 0x77, (byte) 0x65, (byte) 0x62, (byte) 0x6d, (byte) 0x61, (byte) 0x73, (byte) 0x74, (byte) 0x65,
            (byte) 0x72, (byte) 0x40, (byte) 0x63, (byte) 0x6f, (byte) 0x6e, (byte) 0x6e, (byte) 0x65, (byte) 0x63,
            (byte) 0x74, (byte) 0x34, (byte) 0x2e, (byte) 0x63, (byte) 0x6f, (byte) 0x6d, (byte) 0x2e, (byte) 0x61,
            (byte) 0x75, (byte) 0x30, (byte) 0x1e, (byte) 0x17, (byte) 0x0d, (byte) 0x30, (byte) 0x30, (byte) 0x30,
            (byte) 0x36, (byte) 0x30, (byte) 0x32, (byte) 0x30, (byte) 0x37, (byte) 0x35, (byte) 0x35, (byte) 0x33,
            (byte) 0x33, (byte) 0x5a, (byte) 0x17, (byte) 0x0d, (byte) 0x30, (byte) 0x31, (byte) 0x30, (byte) 0x36,
            (byte) 0x30, (byte) 0x32, (byte) 0x30, (byte) 0x37, (byte) 0x35, (byte) 0x35, (byte) 0x33, (byte) 0x33,
            (byte) 0x5a, (byte) 0x30, (byte) 0x81, (byte) 0xb7, (byte) 0x31, (byte) 0x0b, (byte) 0x30, (byte) 0x09,
            (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x04, (byte) 0x06, (byte) 0x13, (byte) 0x02, (byte) 0x41,
            (byte) 0x55, (byte) 0x31, (byte) 0x11, (byte) 0x30, (byte) 0x0f, (byte) 0x06, (byte) 0x03, (byte) 0x55,
            (byte) 0x04, (byte) 0x08, (byte) 0x13, (byte) 0x08, (byte) 0x56, (byte) 0x69, (byte) 0x63, (byte) 0x74,
            (byte) 0x6f, (byte) 0x72, (byte) 0x69, (byte) 0x61, (byte) 0x31, (byte) 0x18, (byte) 0x30, (byte) 0x16,
            (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x04, (byte) 0x07, (byte) 0x13, (byte) 0x0f, (byte) 0x53,
            (byte) 0x6f, (byte) 0x75, (byte) 0x74, (byte) 0x68, (byte) 0x20, (byte) 0x4d, (byte) 0x65, (byte) 0x6c,
            (byte) 0x62, (byte) 0x6f, (byte) 0x75, (byte) 0x72, (byte) 0x6e, (byte) 0x65, (byte) 0x31, (byte) 0x1a,
            (byte) 0x30, (byte) 0x18, (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x04, (byte) 0x0a, (byte) 0x13,
            (byte) 0x11, (byte) 0x43, (byte) 0x6f, (byte) 0x6e, (byte) 0x6e, (byte) 0x65, (byte) 0x63, (byte) 0x74,
            (byte) 0x20, (byte) 0x34, (byte) 0x20, (byte) 0x50, (byte) 0x74, (byte) 0x79, (byte) 0x20, (byte) 0x4c,
            (byte) 0x74, (byte) 0x64, (byte) 0x31, (byte) 0x1e, (byte) 0x30, (byte) 0x1c, (byte) 0x06, (byte) 0x03,
            (byte) 0x55, (byte) 0x04, (byte) 0x0b, (byte) 0x13, (byte) 0x15, (byte) 0x43, (byte) 0x65, (byte) 0x72,
            (byte) 0x74, (byte) 0x69, (byte) 0x66, (byte) 0x69, (byte) 0x63, (byte) 0x61, (byte) 0x74, (byte) 0x65,
            (byte) 0x20, (byte) 0x41, (byte) 0x75, (byte) 0x74, (byte) 0x68, (byte) 0x6f, (byte) 0x72, (byte) 0x69,
            (byte) 0x74, (byte) 0x79, (byte) 0x31, (byte) 0x15, (byte) 0x30, (byte) 0x13, (byte) 0x06, (byte) 0x03,
            (byte) 0x55, (byte) 0x04, (byte) 0x03, (byte) 0x13, (byte) 0x0c, (byte) 0x43, (byte) 0x6f, (byte) 0x6e,
            (byte) 0x6e, (byte) 0x65, (byte) 0x63, (byte) 0x74, (byte) 0x20, (byte) 0x34, (byte) 0x20, (byte) 0x43,
            (byte) 0x41, (byte) 0x31, (byte) 0x28, (byte) 0x30, (byte) 0x26, (byte) 0x06, (byte) 0x09, (byte) 0x2a,
            (byte) 0x86, (byte) 0x48, (byte) 0x86, (byte) 0xf7, (byte) 0x0d, (byte) 0x01, (byte) 0x09, (byte) 0x01,
            (byte) 0x16, (byte) 0x19, (byte) 0x77, (byte) 0x65, (byte) 0x62, (byte) 0x6d, (byte) 0x61, (byte) 0x73,
            (byte) 0x74, (byte) 0x65, (byte) 0x72, (byte) 0x40, (byte) 0x63, (byte) 0x6f, (byte) 0x6e, (byte) 0x6e,
            (byte) 0x65, (byte) 0x63, (byte) 0x74, (byte) 0x34, (byte) 0x2e, (byte) 0x63, (byte) 0x6f, (byte) 0x6d,
            (byte) 0x2e, (byte) 0x61, (byte) 0x75, (byte) 0x30, (byte) 0x81, (byte) 0x9f, (byte) 0x30, (byte) 0x0d,
            (byte) 0x06, (byte) 0x09, (byte) 0x2a, (byte) 0x86, (byte) 0x48, (byte) 0x86, (byte) 0xf7, (byte) 0x0d,
            (byte) 0x01, (byte) 0x01, (byte) 0x01, (byte) 0x05, (byte) 0x00, (byte) 0x03, (byte) 0x81, (byte) 0x8d,
            (byte) 0x00, (byte) 0x30, (byte) 0x81, (byte) 0x89, (byte) 0x02, (byte) 0x81, (byte) 0x81, (byte) 0x00,
            (byte) 0xe0, (byte) 0xb3, (byte) 0x9a, (byte) 0x6d, (byte) 0x34, (byte) 0x6e, (byte) 0x90, (byte) 0xbf,
            (byte) 0x56, (byte) 0x69, (byte) 0x08, (byte) 0x3b, (byte) 0x94, (byte) 0x34, (byte) 0x69, (byte) 0xaf,
            (byte) 0xae, (byte) 0x18, (byte) 0xea, (byte) 0x30, (byte) 0x33, (byte) 0xdd, (byte) 0xde, (byte) 0xb8,
            (byte) 0xbc, (byte) 0x27, (byte) 0x36, (byte) 0x4d, (byte) 0x46, (byte) 0x28, (byte) 0x85, (byte) 0x94,
            (byte) 0x10, (byte) 0x38, (byte) 0x7b, (byte) 0xaf, (byte) 0xd1, (byte) 0x79, (byte) 0xa3, (byte) 0xb5,
            (byte) 0x53, (byte) 0xc0, (byte) 0x12, (byte) 0x7b, (byte) 0x00, (byte) 0xde, (byte) 0x40, (byte) 0xc1,
            (byte) 0xfa, (byte) 0x8b, (byte) 0xd4, (byte) 0x7a, (byte) 0x75, (byte) 0xe8, (byte) 0x05, (byte) 0x75,
            (byte) 0x04, (byte) 0x4b, (byte) 0x9e, (byte) 0x06, (byte) 0xee, (byte) 0x24, (byte) 0xfd, (byte) 0x2c,
            (byte) 0xc5, (byte) 0xc1, (byte) 0x04, (byte) 0xf9, (byte) 0x29, (byte) 0x2c, (byte) 0x11, (byte) 0x63,
            (byte) 0x6f, (byte) 0xca, (byte) 0x07, (byte) 0xf3, (byte) 0x2f, (byte) 0x05, (byte) 0x7d, (byte) 0x27,
            (byte) 0xfa, (byte) 0xbe, (byte) 0x4d, (byte) 0x00, (byte) 0xf2, (byte) 0x25, (byte) 0x82, (byte) 0xb9,
            (byte) 0xda, (byte) 0xeb, (byte) 0x5b, (byte) 0xfb, (byte) 0xe9, (byte) 0x52, (byte) 0xd1, (byte) 0xbe,
            (byte) 0x3c, (byte) 0x03, (byte) 0x52, (byte) 0x8f, (byte) 0x2f, (byte) 0x01, (byte) 0x2c, (byte) 0xc8,
            (byte) 0xbe, (byte) 0xa4, (byte) 0x38, (byte) 0x08, (byte) 0x1e, (byte) 0x95, (byte) 0xbb, (byte) 0xab,
            (byte) 0xba, (byte) 0x4c, (byte) 0x31, (byte) 0xa3, (byte) 0x0a, (byte) 0x6b, (byte) 0x29, (byte) 0x42,
            (byte) 0x15, (byte) 0xec, (byte) 0xa9, (byte) 0xdf, (byte) 0xd5, (byte) 0xa8, (byte) 0xde, (byte) 0xb5,
            (byte) 0x02, (byte) 0x03, (byte) 0x01, (byte) 0x00, (byte) 0x01, (byte) 0xa3, (byte) 0x81, (byte) 0x85,
            (byte) 0x30, (byte) 0x81, (byte) 0x82, (byte) 0x30, (byte) 0x24, (byte) 0x06, (byte) 0x03, (byte) 0x55,
            (byte) 0x1d, (byte) 0x11, (byte) 0x04, (byte) 0x1d, (byte) 0x30, (byte) 0x1b, (byte) 0x81, (byte) 0x19,
            (byte) 0x77, (byte) 0x65, (byte) 0x62, (byte) 0x6d, (byte) 0x61, (byte) 0x73, (byte) 0x74, (byte) 0x65,
            (byte) 0x72, (byte) 0x40, (byte) 0x63, (byte) 0x6f, (byte) 0x6e, (byte) 0x6e, (byte) 0x65, (byte) 0x63,
            (byte) 0x74, (byte) 0x34, (byte) 0x2e, (byte) 0x63, (byte) 0x6f, (byte) 0x6d, (byte) 0x2e, (byte) 0x61,
            (byte) 0x75, (byte) 0x30, (byte) 0x0f, (byte) 0x06, (byte) 0x03, (byte) 0x55, (byte) 0x1d, (byte) 0x13,
            (byte) 0x04, (byte) 0x08, (byte) 0x30, (byte) 0x06, (byte) 0x01, (byte) 0x01, (byte) 0xff, (byte) 0x02,
            (byte) 0x01, (byte) 0x00, (byte) 0x30, (byte) 0x36, (byte) 0x06, (byte) 0x09, (byte) 0x60, (byte) 0x86,
            (byte) 0x48, (byte) 0x01, (byte) 0x86, (byte) 0xf8, (byte) 0x42, (byte) 0x01, (byte) 0x0d, (byte) 0x04,
            (byte) 0x29, (byte) 0x16, (byte) 0x27, (byte) 0x6d, (byte) 0x6f, (byte) 0x64, (byte) 0x5f, (byte) 0x73,
            (byte) 0x73, (byte) 0x6c, (byte) 0x20, (byte) 0x67, (byte) 0x65, (byte) 0x6e, (byte) 0x65, (byte) 0x72,
            (byte) 0x61, (byte) 0x74, (byte) 0x65, (byte) 0x64, (byte) 0x20, (byte) 0x63, (byte) 0x75, (byte) 0x73,
            (byte) 0x74, (byte) 0x6f, (byte) 0x6d, (byte) 0x20, (byte) 0x43, (byte) 0x41, (byte) 0x20, (byte) 0x63,
            (byte) 0x65, (byte) 0x72, (byte) 0x74, (byte) 0x69, (byte) 0x66, (byte) 0x69, (byte) 0x63, (byte) 0x61,
            (byte) 0x74, (byte) 0x65, (byte) 0x30, (byte) 0x11, (byte) 0x06, (byte) 0x09, (byte) 0x60, (byte) 0x86,
            (byte) 0x48, (byte) 0x01, (byte) 0x86, (byte) 0xf8, (byte) 0x42, (byte) 0x01, (byte) 0x01, (byte) 0x04,
            (byte) 0x04, (byte) 0x03, (byte) 0x02, (byte) 0x02, (byte) 0x04, (byte) 0x30, (byte) 0x0d, (byte) 0x06,
            (byte) 0x09, (byte) 0x2a, (byte) 0x86, (byte) 0x48, (byte) 0x86, (byte) 0xf7, (byte) 0x0d, (byte) 0x01,
            (byte) 0x01, (byte) 0x04, (byte) 0x05, (byte) 0x00, (byte) 0x03, (byte) 0x81, (byte) 0x81, (byte) 0x00,
            (byte) 0xac, (byte) 0x1a, (byte) 0xf7, (byte) 0xdd, (byte) 0x82, (byte) 0x11, (byte) 0xfc, (byte) 0xa4,
            (byte) 0xf8, (byte) 0x65, (byte) 0xc2, (byte) 0x6d, (byte) 0x6b, (byte) 0xde, (byte) 0x94, (byte) 0x24,
            (byte) 0x9a, (byte) 0xc9, (byte) 0xcb, (byte) 0x01, (byte) 0x52, (byte) 0x01, (byte) 0x6f, (byte) 0x4d,
            (byte) 0x44, (byte) 0x85, (byte) 0xb5, (byte) 0xe6, (byte) 0xdb, (byte) 0xce, (byte) 0xb5, (byte) 0x89,
            (byte) 0x76, (byte) 0x5f, (byte) 0x5a, (byte) 0xa1, (byte) 0x90, (byte) 0x8e, (byte) 0xb1, (byte) 0x80,
            (byte) 0x68, (byte) 0x0d, (byte) 0x19, (byte) 0xa5, (byte) 0x73, (byte) 0x64, (byte) 0xf6, (byte) 0x8a,
            (byte) 0x35, (byte) 0xd7, (byte) 0x4c, (byte) 0xb1, (byte) 0xa2, (byte) 0xa1, (byte) 0x28, (byte) 0x48,
            (byte) 0x94, (byte) 0xb3, (byte) 0x9e, (byte) 0x26, (byte) 0x5a, (byte) 0xed, (byte) 0x7b, (byte) 0x73,
            (byte) 0xb2, (byte) 0x84, (byte) 0xf0, (byte) 0x35, (byte) 0x4a, (byte) 0x44, (byte) 0xd1, (byte) 0x22,
            (byte) 0xc7, (byte) 0xbd, (byte) 0x67, (byte) 0xff, (byte) 0x4a, (byte) 0x52, (byte) 0x9d, (byte) 0x15,
            (byte) 0x69, (byte) 0x73, (byte) 0x5c, (byte) 0x0f, (byte) 0xaf, (byte) 0x39, (byte) 0x96, (byte) 0xf3,
            (byte) 0x12, (byte) 0xfe, (byte) 0x14, (byte) 0x9a, (byte) 0x37, (byte) 0x9e, (byte) 0x95, (byte) 0xe9,
            (byte) 0x13, (byte) 0x9b, (byte) 0xb9, (byte) 0x5c, (byte) 0xd3, (byte) 0x51, (byte) 0x04, (byte) 0x6b,
            (byte) 0x94, (byte) 0x11, (byte) 0x57, (byte) 0x33, (byte) 0xb1, (byte) 0x1c, (byte) 0x5b, (byte) 0x50,
            (byte) 0x0e, (byte) 0x19, (byte) 0x1a, (byte) 0x27, (byte) 0xc5, (byte) 0x6a, (byte) 0x38, (byte) 0xc6,
            (byte) 0xa3, (byte) 0x91, (byte) 0x01, (byte) 0x66, (byte) 0x6b, (byte) 0x6a, (byte) 0xfd, (byte) 0x88,
    };
}
