package au.net.netstorm.boost.demo.scalpel.core;

import au.net.netstorm.boost.bullet.edge.java.lang.ThreadStatic;
import au.net.netstorm.boost.bullet.scalpel.core.Edges;
import au.net.netstorm.boost.demo.scalpel.edge.java.lang.Class;
import au.net.netstorm.boost.demo.scalpel.edge.java.lang.ClassStatic;
import au.net.netstorm.boost.gunge.exception.ThrowableMaster;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public class ClassStaticDemoTest extends LifecycleTestCase implements HasFixtures, InjectableTest {
    private ClassStatic subject;
    ThrowableMaster thrower;
    Edges edges;

    public void fixtures() {
        subject = edges.statik(ClassStatic.class);
    }

    public void testForName() {
        Class<?> edgedStringClass = subject.forName("java.lang.String");
        Object stringInstance = edgedStringClass.newInstance();
        assertEquals(String.class, stringInstance.getClass());
    }
    // FIX 2040 Jan 13, 2009 Module tests not demo tests.

    public void testToString() {
        String actual = subject.toString();
        assertEquals("StaticEdge<java.lang.Class>", actual);
    }

    public void testEquals() {
        ClassStatic other = edges.statik(ClassStatic.class);
        ThreadStatic different = edges.statik(ThreadStatic.class);
        Object spaz = new Object();
        checkEquals(true, subject, subject);
        checkEquals(true, subject, other);
        checkEquals(false, subject, different);
        checkEquals(false, subject, spaz);
    }

    public void testHashCode() {
        int expected = java.lang.Class.class.hashCode();
        int actual = subject.hashCode();
        assertEquals(expected, actual);
    }

    // FIX 2040 Jan 13, 2009 Why is there not methods like this exposed on TestCase? more useful that assert equals.
    private void checkEquals(boolean expected, Object a, Object b) {
        boolean actual = a.equals(b);
        assertEquals(expected, actual);
    }

    // FIX 2130 Got AFed by the exception rootCause not being the right thing to use.
    public void testForNameFailure() {
        try {
            subject.forName("bad.Name");
            fail();
        } catch (Throwable t) {
            Throwable real = thrower.realCause(t);
            assertEquals(ClassNotFoundException.class, real.getClass());
        }
    }
}
