package au.net.netstorm.boost.demo.scalpel.core;

import java.net.MalformedURLException;
import au.net.netstorm.boost.bullet.scalpel.core.Edges;
import au.net.netstorm.boost.demo.scalpel.edge.java.net.URL;
import au.net.netstorm.boost.gunge.exception.ThrowableMaster;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public class URLDemoTest extends LifecycleTestCase implements InjectableTest {
    private URL subject;
    ThrowableMaster thrower;
    Edges edges;

    public void testURLEdgeConstruction() {
        String url = "http://boost";
        subject = edges.nu(URL.class, url);
        assertEquals(url, subject.toExternalForm());
    }

    public void testURLEdgeConstructionFailure() {
        try {
            edges.nu(URL.class, "..badone..");
            fail();
        } catch (Exception e) {
            Throwable real = thrower.rootCause(e);
            assertEquals(true, real instanceof MalformedURLException);
        }
    }
}

