package au.net.netstorm.boost.demo.spider.lifecycle.constructable;

import au.net.netstorm.boost.demo.spider.test.NuSpiderDemooooTest;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.spider.api.config.wire.Wire;
import au.net.netstorm.boost.spider.api.runtime.Resolver;

public final class ConstructableDemoTest extends NuSpiderDemooooTest implements HasFixtures, InjectableTest {
    Resolver resolver;
    Wire wire;

    public void fixtures() {
        wire.cls(DefaultConstructableThing.class).to(ConstructableMulti.class);
        wire.cls(DefaultConstructableThing.class).to(ConstructableSingle.class);
    }

    public void testConstructMultiton() {
        checkConstructCount(1, ConstructableMulti.class);
        checkConstructCount(1, ConstructableMulti.class);
    }

    public void testConstructSingleton() {
        checkConstructCount(1, ConstructableSingle.class);
        checkConstructCount(1, ConstructableSingle.class);
    }

    private void checkConstructCount(int expected, Class<? extends ConstructableThing> type) {
        ConstructableThing thing = resolver.resolve(type);
        checkConstructCount(expected, thing);
    }

    private void checkConstructCount(int expected, ConstructableThing thing) {
        int actual = thing.constructionCount();
        assertEquals(expected, actual);
    }
}
