package au.net.netstorm.boost.demo.spider.scope;

import au.net.netstorm.boost.gunge.graph.GraphUtil;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.spider.api.builder.Egg;
import au.net.netstorm.boost.spider.api.builder.SpiderEgg;
import au.net.netstorm.boost.spider.api.runtime.Spider;

public final class ScopeDemoTest extends LifecycleTestCase implements InjectableTest {
    GraphUtil grapher;

    public void testSingleScope() {
        // FIX 3324 Mar 13, 2009 Should be able to use spider.nu() here but it barfs.
        Egg egg = new SpiderEgg(EverestWeb.class);
        Spider spider = egg.hatch();
        Mountain mountain = spider.resolve(Mountain.class);
        checkNotResolved(mountain, "cliff.nothingness");
    }

    // FIX 3324 Mar 13, 2009 You know, it's pretty confusing having two spiders both called "spider".
    public void testMultiScope() {
        Egg egg = new SpiderEgg(HimalayaWeb.class);
        Spider spider = egg.hatch();
        Mountains mountains = spider.resolve(Mountains.class);
        checkNotResolved(mountains, "k1.cliff.nothingness");
        checkNotResolved(mountains, "everest.cliff.nothingness");
    }

    private void checkNotResolved(Object o, String attribute) {
        Object nothingness = grapher.get(o, attribute);
        assertEquals(true, null == nothingness);
    }
}
