package au.net.netstorm.boost.demo.spider.trapdoor.cyclic.simple;

import au.net.netstorm.boost.gunge.graph.GraphUtil;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.marker.OverlaysWeb;
import au.net.netstorm.boost.spider.api.runtime.Resolver;

public final class SimpleCyclicDependenciesDemoTest extends LifecycleTestCase implements OverlaysWeb, InjectableTest {
    Resolver resolver;
    GraphUtil grapher;

    public void overlay() {
        wire.cls(DefaultBall.class).to(Ball.class);
        wire.cls(DefaultRunner.class).to(Runner.class);
    }

    public void testDependencyWithTwoObjects() {
        checkResolveBall();
        checkResolveRunner();
    }

    private void checkResolveBall() {
        Ball ball = resolver.resolve(Ball.class);
        checkSet(ball, "runner");
    }

    private void checkResolveRunner() {
        Runner runner = resolver.resolve(Runner.class);
        checkSet(runner, "ball");
    }

    private void checkSet(Object ref, String fieldName) {
        Object value = grapher.get(ref, fieldName);
        assertNotNull(value);
    }
}
