package au.net.netstorm.boost.demo.spider.trapdoor.diamond;

import au.net.netstorm.boost.gunge.graph.DefaultGraphUtil;
import au.net.netstorm.boost.gunge.graph.GraphUtil;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.marker.OverlaysWeb;
import au.net.netstorm.boost.spider.api.runtime.Resolver;

public final class DiamondDemoTest extends LifecycleTestCase implements OverlaysWeb, InjectableTest {
    GraphUtil grapher = new DefaultGraphUtil();
    Tomato t1 = new JuicyTomato("Tomato 1");
    Tomato t2 = new JuicyTomato("Tomato 2");
    Resolver resolver;

    public void overlay() {
        wire.cls(HealthyFridge.class).to(Fridge.class);
    }

    public void testOneInstance() {
        check(t1, t1);
    }

    public void testTwoInstances() {
        check(t1, t2);
    }

    private void check(Tomato tomato1, Tomato tomato2) {
        wire.ref(tomato1).to(Fruit.class);
        wire.ref(tomato2).to(Vegetable.class);
        Fridge fridge = resolver.resolve(Fridge.class);
        check(fridge, tomato1, "fruit");
        check(fridge, tomato2, "vegetable");
    }

    private void check(Fridge fridge, Tomato tomato, String name) {
        Edible edible = (Edible) grapher.get(fridge, name);
        assertSame(tomato, edible);
    }
}