package au.net.netstorm.boost.demo.spider.vararg;

import au.net.netstorm.boost.demo.spider.test.NuSpiderDemooooTest;
import au.net.netstorm.boost.gunge.graph.GraphUtil;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.marker.LazyFields;
import au.net.netstorm.boost.spider.api.runtime.Nu;

public final class VarargsConstructionDemoTest extends NuSpiderDemooooTest implements InjectableTest, LazyFields, HasFixtures {
    private HairyBoy[] one;
    HairyBoy[] none = {};
    HairyBoy[] some;
    GraphUtil grapher;
    HairyBoy boy;
    String name;
    Nu nu;

    public void fixtures() {
        one = new HairyBoy[]{boy};
    }

    public void testJustVarargs() {
        checkBumNone();
        checkBumOne();
        checkBumSome();
        checkBumIndirect(none);
        checkBumIndirect(one);
        checkBumIndirect(some);
    }

    public void testVarargsCombo() {
        checkButtNone();
        checkButtOne();
        checkButtSome();
        checkButtIndirect(none);
        checkButtIndirect(one);
        checkButtIndirect(some);
    }

    private void checkBumNone() {
        Bum bum = nu.nu(Bum.class);
        HairyBoy[] expected = {};
        checkBum(bum, expected);
    }

    private void checkBumOne() {
        Bum bum = nu.nu(Bum.class, boy);
        HairyBoy[] expected = {boy};
        checkBum(bum, expected);
    }

    private void checkBumSome() {
        Bum bum = nu.nu(Bum.class, boy, boy);
        HairyBoy[] expected = {boy, boy};
        checkBum(bum, expected);
    }

    private void checkButtNone() {
        Butt butt = nu.nu(Butt.class, name);
        HairyBoy[] expected = {};
        checkButt(butt, expected);
    }

    private void checkButtOne() {
        Butt butt = nu.nu(Butt.class, name, boy);
        HairyBoy[] expected = {boy};
        checkButt(butt, expected);
    }

    private void checkButtSome() {
        Butt butt = nu.nu(Butt.class, name, boy, boy);
        HairyBoy[] expected = {boy, boy};
        checkButt(butt, expected);
    }

    private void checkBumIndirect(HairyBoy... expected) {
        Bum bum = nu.nu(Bum.class, (Object[])expected);
        checkBum(bum, expected);
    }

    private void checkButtIndirect(HairyBoy... expected) {
        Butt butt = nu.nu(Butt.class, name, expected);
        checkButt(butt, expected);
    }

    private void checkBum(Bum bum, HairyBoy... expected) {
        HairyBoy[] boys = (HairyBoy[]) grapher.get(bum, "boys");
        assertEquals(expected, boys);
    }

    private void checkButt(Butt butt, HairyBoy... expected) {
        String n = (String) grapher.get(butt, "name");
        HairyBoy[] bs = (HairyBoy[]) grapher.get(butt, "boys");
        assertEquals(name, n);
        assertEquals(expected, bs);
    }
}
