package au.net.netstorm.boost.gunge.array;

import java.lang.reflect.Array;
import java.util.Collection;

public final class DefaultArrayMaestro implements ArrayMaestro {
    public <T> T single(T[] t) {
        if (t.length != 1) throw new IllegalArgumentException("Expected single element array.");
        return t[0];
    }

    public <T> Class<T[]> arrayize(Class<T> component) {
        Object o = Array.newInstance(component, 0);
        return (Class<T[]>) o.getClass();
    }

    public <T> T[] array(Collection<T> collection, Class<T> type) {
        int i = collection.size();
        T[] array = (T[]) Array.newInstance(type, i);
        return collection.toArray(array);
    }

    public <T> T[] array(Collection<T> collection, T[] type) {
        Class<T> componentType = componentType(type);
        return array(collection, componentType);
    }

    private <T> Class<T> componentType(T[] array) {
        Class arrayClass = array.getClass();
        return arrayClass.getComponentType();
    }
}
