package au.net.netstorm.boost.gunge.array;

import java.util.Arrays;
import java.util.List;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.LazyFields;

public final class DefaultArrayMaestroAtomicTest extends LifecycleTestCase implements LazyFields {
    ArrayMaestro subject = new DefaultArrayMaestro();
    Integer[] a1;
    Integer[] a2 = {3, 0};

    public void testToArray() {
        checkToArray(a1);
        checkToArray();
    }

    public void testSingle() {
        try {
            subject.single(a2);
            fail();
        } catch (IllegalArgumentException expected) { }
    }

    private <T> void checkToArray(T... elems) {
        List<T> list = Arrays.asList(elems);
        Class cls = elems.getClass();
        Class<T> type = cls.getComponentType();
        T[] array = subject.array(list, type);
        assertEquals(array, elems);
    }
}
