package au.net.netstorm.boost.gunge.array;

import java.util.List;
import java.util.Set;
import au.net.netstorm.boost.gunge.collection.CollectionMaster;
import au.net.netstorm.boost.gunge.collection.DefaultCollectionMaster;

public final class DefaultArrayMaster implements ArrayMaster {
    CollectionMaster collections = new DefaultCollectionMaster();
    ArrayMaestro arrays = new DefaultArrayMaestro();

    public <T> T[] minus(T[] minuend, T... subtrahend) {
        Set<T> result = collections.mutableSet(minuend);
        Set<T> subSet = collections.immutableSet(subtrahend);
        result.removeAll(subSet);
        return arrays.array(result, minuend);
    }

    public <T> T[] plus(T[] a, T... b) {
        List<T> result = collections.mutableList(a);
        List<T> set = collections.immutableList(b);
        result.addAll(set);
        return arrays.array(result, a);
    }

    public boolean contains(Object[] array, Object o) {
        List result = collections.immutableList(array);
        return result.contains(o);
    }
}
