package au.net.netstorm.boost.gunge.array;

import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.LazyFields;

public final class DefaultArrayMasterAtomicTest extends LifecycleTestCase implements LazyFields {
    ArrayMaster subject = new DefaultArrayMaster();
    Byte[] bigfoobar = {(byte) 0xAA, (byte) 0xBB, (byte) 0xCC, (byte) 0xDD, (byte) 0xEE, (byte) 0xFF};
    Byte[] bigfoobaz = {(byte) 0xAA, (byte) 0xBB, (byte) 0xCC, (byte) 0xFE};
    Byte[] bigBar = {(byte) 0xDD, (byte) 0xEE, (byte) 0xFF};
    Byte[] bigFoo = {(byte) 0xAA, (byte) 0xBB, (byte) 0xCC};
    Byte baz = (byte) 0xFE;

    public void testMinusBytes() {
        Byte[] actual = subject.minus(bigfoobar, bigBar);
        assertEqualsUnordered(bigFoo, actual);
    }

    public void testPlus() {
        Byte[] actual = subject.plus(bigFoo, bigBar);
        assertEquals(bigfoobar, actual);
        checkType(actual, Byte[].class);
    }

    public void testPlusSingleElement() {
        Byte[] actual = subject.plus(bigFoo, baz);
        assertEquals(bigfoobaz, actual);
        checkType(actual, Byte[].class);
    }

    public void testContains() {
        boolean actual = subject.contains(bigFoo, bigFoo[2]);
        assertEquals(true, actual);
    }

    private void checkType(Object[] actual, Class type) {
        Class arrayType = actual.getClass();
        boolean matches = type.isAssignableFrom(arrayType);
        assertEquals(true, matches);
    }
}
