package au.net.netstorm.boost.gunge.async;

import au.net.netstorm.boost.bullet.incredibles.core.Weaken;
import au.net.netstorm.boost.gunge.layer.Layer;
import au.net.netstorm.boost.gunge.layer.Method;
import au.net.netstorm.boost.gunge.sledge.java.lang.EdgeThread;
import au.net.netstorm.boost.spider.api.runtime.Impl;
import au.net.netstorm.boost.spider.api.runtime.Nu;

// FIX 1438 Check package name.
public final class AsynchronousLayer implements Layer {
    private final Object delegate;
    EdgeThread threads;
    Weaken weaken;
    Daemon daemon;
    Impl impl;
    Nu nu;

    public AsynchronousLayer(Object delegate) {
        this.delegate = delegate;
    }

    public Object invoke(Method method, Object[] args) {
        Runnable runnable = impl.impl(DelegateRunnable.class, delegate, method, args);
        Thread thread = thread(runnable);
        threads.start(thread);
        return IRRELEVANT;
    }

    // FIX 1438 Move stuff below here out.  In ThreadGiver.
    // FIX 1438 Should return a Thread.  Should return a start/stop instance.
    private Thread thread(Runnable runnable) {
        Thread thread = new Thread(runnable);
        daemonise(thread);
        return thread;
    }

    private void daemonise(Thread thread) {
        // SUGGEST: So would be really nice if we could declare "void setDaemon(Daemon daemon).
        // SUGGEST: This would be a scalpel lovely.
        Boolean b = weaken.w(daemon);
        thread.setDaemon(b);
    }

    private static final Object IRRELEVANT = null;
}
