package au.net.netstorm.boost.gunge.collection;

import java.lang.reflect.Array;

public final class DefaultFunctionalMaestro implements FunctionalMaestro {
    public <T> boolean detect(Iterable<T> ts, Filter<T> filter) {
        for (T t : ts) if (filter.accept(t)) return true;
        return false;
    }

    public <A, B> B[] mapArray(A[] arr, Function<A, B> function, Class<B> bClass) {
        // FIX 3015 10/02/2009 GLEN - unchecked cast, but unavoidable I think
        B[] values = (B[]) Array.newInstance(bClass, arr.length);
        for (int i = 0; i < values.length; ++i) values[i] = function.apply(arr[i]);
        return values;
    }
}
