package au.net.netstorm.boost.gunge.collection;

import java.util.Arrays;
import java.util.List;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableSubject;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.marker.LazyFields;

public final class DefaultFunctionalMaestroAtomicTest extends LifecycleTestCase
        implements InjectableSubject, InjectableTest, LazyFields, HasFixtures {
    FunctionalMaestro subject;
    Function<String, Integer> functionMock;
    String[] arr;
    List<String> list;

    public void fixtures() {
        arr = new String[]{"one", "two", "three"};
        list = Arrays.asList(arr);
    }

    public void testDetectTrue() {
        boolean result = subject.detect(list, new ObjectEqualityFilter<String>("two"));
        assertEquals(true, result);
    }

    public void testDetectFalse() {
        boolean result = subject.detect(list, new ObjectEqualityFilter<String>("foo"));
        assertEquals(false, result);
    }

    public void testMap() {
        expect.oneCall(functionMock, 1, "apply", "one");
        expect.oneCall(functionMock, 2, "apply", "two");
        expect.oneCall(functionMock, 3, "apply", "three");
        Integer[] mappedArray = subject.mapArray(arr, functionMock, Integer.class);
        assertEquals(new Integer[]{1, 2, 3}, mappedArray);
    }
}