package au.net.netstorm.boost.gunge.collection;

public final class DefaultSwizzleMap<K, V> implements SwizzleMap<K, V> {
    StrictMap<K, V> swizzle = strict();
    StrictMap<V, K> deswizzle = strict();

    public V swizzle(K key) {
        return swizzle.get(key);
    }

    public K deswizzle(V value) {
        return deswizzle.get(value);
    }

    public void put(K key, V value) {
        swizzle.put(key, value);
        deswizzle.put(value, key);
    }

    private <K, V> StrictMap<K, V> strict() {
        return new DefaultStrictMap<K, V>();
    }
}
