package au.net.netstorm.boost.gunge.equals;

import au.net.netstorm.boost.bullet.primordial.Primordial;

public final class CoreEquals implements Equals {
    Equals arrays = new ArrayEquals();
    Equals fields = new FieldEquals();

    // OK CyclomaticComplexity {
    public boolean equals(Object o1, Object o2) {
        if (o1 == null || o2 == null) return o1 == o2;
        if (field(o1) || field(o2)) return fields(o1, o2);
        if (array(o1) || array(o2)) return arrays(o1, o2);
        return equality(o1, o2);
    }
    // } OK CyclomaticComplexity

    private boolean field(Object o) {
        return o instanceof Primordial;
    }

    private boolean arrays(Object o1, Object o2) {
        if (!array(o1) || !array(o2)) return false;
        return arrays.equals(o1, o2);
    }

    private boolean fields(Object o1, Object o2) {
        if (!field(o1) || !field(o2)) return false;
        return fields.equals(o1, o2);
    }

    private boolean equality(Object o1, Object o2) {
        return o1.equals(o2);
    }

    private boolean array(Object o) {
        Class cls = o.getClass();
        return cls.isArray();
    }
}
