package au.net.netstorm.boost.gunge.equals;

import au.net.netstorm.boost.gunge.goop.Nvp;
import au.net.netstorm.boost.gunge.reflect.field.DefaultFieldNvps;
import au.net.netstorm.boost.gunge.reflect.field.FieldNvps;

public final class FieldEquals implements Equals {
    private final EqualsConstraints constraints = new DefaultEqualsConstraints();
    private final FieldNvps fields = new DefaultFieldNvps();

    public boolean equals(Object o1, Object o2) {
        if (o1 == o2) return true;
        if (!constraints.ok(o1, o2)) return false;
        return fields(o1, o2);
    }

    private boolean fields(Object o1, Object o2) {
        Nvp[] n1 = fields(o1);
        Nvp[] n2 = fields(o2);
        return equals(n1, n2);
    }

    private boolean equals(Nvp[] n1, Nvp[] n2) {
        for (int i = 0; i < n1.length; i++) {
            if (!n1[i].equals(n2[i])) return false;
        }
        return true;
    }

    private Nvp[] fields(Object o) {
        return fields.nvps(o);
    }
}
