package au.net.netstorm.boost.gunge.equals;

import au.net.netstorm.boost.gunge.layer.Layer;
import au.net.netstorm.boost.gunge.layer.Layered;

public final class LayeredEquals implements Equals {
    private final Equals fields = new FieldEquals();

    public boolean equals(Object o1, Object o2) {
        if (isNull(o1, o2)) return false;
        if (!isLayered(o1, o2)) return false;
        Layer l1 = layer(o1);
        Layer l2 = layer(o2);
        return fields.equals(l1, l2);
    }

    private boolean isNull(Object o1, Object o2) {
        return o1 == null || o2 == null;
    }

    private boolean isLayered(Object o1, Object o2) {
        return isLayered(o1) && isLayered(o2);
    }

    private Layer layer(Object o) {
        if (isLayer(o)) return (Layer) o;
        Layered layered = (Layered) o;
        return layered.layer();
    }

    private boolean isLayered(Object o) {
        return o instanceof Layered || isLayer(o);
    }

    private boolean isLayer(Object o) {
        return o instanceof Layer;
    }
}
