package au.net.netstorm.boost.gunge.exception;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.UndeclaredThrowableException;
import au.net.netstorm.boost.gunge.sledge.support.SledgeException;

public final class DefaultThrowableMaster implements ThrowableMaster {
    // Never, ever change the return type or I will kill you.
    public void rethrow(Throwable t) {
        if (t instanceof Error) throw (Error) t;
        if (t instanceof RuntimeException) throw (RuntimeException) t;
        throw new UndeclaredThrowableException(t);
    }

    public boolean checked(Throwable t) {
        return !(t instanceof RuntimeException) && !(t instanceof Error);
    }

    public boolean contains(Throwable t, Class cls) {
        Throwable throwable = t.getCause();
        if (t.getClass() == cls) return true;
        if (throwable == null) return false;
        return contains(throwable, cls);
    }

    // FIX 2328 Work out whether difference between rootCause/realCause is justified.
    // I think both are useful. Maybe name change for realCause to removeNoise?? - BW
    // FIX 2328 This definitely does not belong here.
    // SUGGEST: Does this really belong?
    // Please say why (It relates to Throwables) - BW
    public String trace(Throwable t) {
        StringWriter stringWriter = new StringWriter();
        PrintWriter writer = new PrintWriter(stringWriter);
        t.printStackTrace(writer);
        return stringWriter.toString();
    }

    public Throwable rootCause(Throwable t) {
        Throwable cause = t.getCause();
        if (cause == null) return t;
        return rootCause(cause);
    }

    // FIX 2130 This crap stinks and needs to be sorted.
    // FIX 2130 A PROPER APPROACH ACROSS THE BOARD!!!!!!!!!!!!!!!!!!!!
    // FIX 2328 We don't know enough to be able to know what this really is.
    // This gets rid of all the proxy noise in the stack trace - BW
    public Throwable realCause(Throwable t) {
        if (!noise(t)) return t;
        Throwable cause = t.getCause();
        return realCause(cause);
    }

    private boolean noise(Throwable t) {
        return t instanceof UndeclaredThrowableException ||
                t instanceof InvocationTargetException ||
                t instanceof SledgeException;
    }
}