package au.net.netstorm.boost.gunge.generics;

import java.lang.reflect.GenericArrayType;
import java.lang.reflect.Type;
import au.net.netstorm.boost.gunge.array.ArrayMaestro;
import au.net.netstorm.boost.gunge.array.DefaultArrayMaestro;

public final class DefaultGenericArrays implements GenericArrays {
    ArrayMaestro arrays = new DefaultArrayMaestro();
    final Generics generics;

    public DefaultGenericArrays(Generics generics) {
        this.generics = generics;
    }

    public boolean is(Type type) {
        return type instanceof GenericArrayType;
    }

    public Class erased(Type type) {
        Class component = component(type);
        return arrays.arrayize(component);
    }

    public Class component(Type type) {
        Type component = type(type);
        return generics.erased(component);
    }

    private Type type(Type type) {
        if (!is(type)) throw new IllegalArgumentException();
        GenericArrayType generic = (GenericArrayType) type;
        return generic.getGenericComponentType();
    }

    public Class[] params(Type type) {
        Type component = type(type);
        return generics.params(component);
    }
}
