package au.net.netstorm.boost.gunge.generics;

import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;

public final class DefaultGenericParameterized implements GenericParameterized {
    Generics generics;

    public DefaultGenericParameterized(DefaultGenerics generics) {
        this.generics = generics;
    }

    public boolean is(Type t) {
        return t instanceof ParameterizedType;
    }

    public Class erased(Type t) {
        ParameterizedType parameterized = (ParameterizedType) t;
        Type raw = parameterized.getRawType();
        return generics.erased(raw);
    }

    public Class[] params(Type t) {
        ParameterizedType parameterized = (ParameterizedType) t;
        Type[] arguments = parameterized.getActualTypeArguments();
        Class[] result = new Class[arguments.length];
        for (int i = 0; i < arguments.length; i++) result[i] = generics.erased(arguments[i]);
        return result;
    }
}
