package au.net.netstorm.boost.gunge.generics;

import java.lang.reflect.Type;

public final class DefaultGenerics implements Generics {
    GenericParameterized parameterized = new DefaultGenericParameterized(this);
    GenericWildcards wildcards = new DefaultGenericWildcards();
    GenericTypeVariable types = new DefaultGenericTypeVariable();
    GenericArrays arrays = new DefaultGenericArrays(this);
    GenericRaw raw = new DefaultGenericRaw();
    Generics[] all = {parameterized, wildcards, types, arrays, raw};

    public boolean is(Type t) {
        return !(t instanceof Class);
    }

    public Class erased(Type t) {
        Generics generics = find(t);
        return generics.erased(t);
    }

    public Class[] params(Type t) {
        Generics generics = find(t);
        return generics.params(t);
    }

    private Generics find(Type t) {
        for (Generics g : all) if (g.is(t)) return g;
        return barf(t);
    }

    private Generics barf(Type t) {
        String message = "Generic type not handled [" + t.getClass() + "]";
        throw new IllegalStateException(message);
    }
}
