package au.net.netstorm.boost.gunge.generics;

import java.lang.reflect.Type;
import java.util.List;
import java.util.Map;
import au.net.netstorm.boost.bullet.incredibles.core.Strong;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.reflect.util.FieldTestUtil;

public class DefaultGenericsAtomicTest<T> extends LifecycleTestCase implements InjectableTest {
    private Boolean[] fix1;
    private List<?>[] fix2;
    private List<Boolean>[] fix3;
    private List fix4;
    private List<?> fix5;
    private List<? extends Strong> fix6;
    private List<T> fix7;
    private List<Boolean> fix8;
    private Map<?, ?> fix9;
    private Map<String, Boolean> fix10;
    Generics subject;
    FieldTestUtil fielder;

    public void testIs() {
        checkIs(false, "fix1");
        checkIs(true, "fix2");
        checkIs(true, "fix3");
        checkIs(false, "fix4");
        checkIs(true, "fix5");
        checkIs(true, "fix6");
        checkIs(true, "fix7");
        checkIs(true, "fix8");
    }

    public void testErased() {
        checkErased(Boolean[].class, "fix1");
        checkErased(List[].class, "fix2");
        checkErased(List[].class, "fix3");
        checkErased(List.class, "fix4");
    }

    // OK NCSS {
    public void testParams() {
        checkParams("fix1");
        checkParams("fix2", Object.class);
        checkParams("fix3", Boolean.class);
        checkParams("fix4");
        checkParams("fix5", Object.class);
        checkParams("fix6", Object.class);
        checkParams("fix7", Object.class);
        checkParams("fix8", Boolean.class);
        checkParams("fix9", Object.class, Object.class);
        checkParams("fix10", String.class, Boolean.class);
    }
    // } OK NCSS

    private void checkIs(boolean expected, String name) {
        Type type = field(name);
        boolean actual = subject.is(type);
        assertEquals(expected, actual);
    }

    private void checkErased(Class expected, String name) {
        Type type = field(name);
        Class actual = subject.erased(type);
        assertEquals(expected, actual);
    }

    private void checkParams(String name, Class... expected) {
        Type type = field(name);
        Class[] actual = subject.params(type);
        assertEquals(expected, actual);
    }

    private Type field(String name) {
        return fielder.getType(DefaultGenericsAtomicTest.class, name);
    }
}
