package au.net.netstorm.boost.gunge.generics;

import java.lang.reflect.Type;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.reflect.util.FieldTestUtil;

public final class DefaultInterfaceLocatorAtomicTest<T> extends LifecycleTestCase implements InjectableTest, HasFixtures {
    private X<String> xs;
    private Y<Integer> yi;
    private Type t;
    private Type x;
    private Type y;
    InterfaceLocator subject;
    FieldTestUtil fielder;

    public void fixtures() {
        x = field("xs");
        y = field("yi");
        t = Seven.class.getGenericInterfaces()[0];
    }

    public void test() {
        checkX(One.class);
        checkX(Two.class);
        checkXY(Three.class);
        checkXY(Four.class);
        checkXY(Five.class);
        checkXY(Six.class);
        check(t, X.class, Seven.class);
        check(t, X.class, Eight.class);
    }

    public void testBadness() {
        checkBombs(BadOne.class);
        checkBombs(BadTwo.class);
    }

    private void checkXY(Class cse) {
        checkX(cse);
        checkY(cse);
    }

    private void checkY(Class target) {
        check(y, Y.class, target);
    }

    private void checkX(Class target) {
        check(x, X.class, target);
    }

    private void check(Type expected, Class marker, Class target) {
        Type actual = subject.find(marker, target);
        assertEquals(expected, actual);
    }

    private void checkBombs(Class target) {
        try {
            subject.find(X.class, target);
            fail();
        } catch (IllegalArgumentException expected) {}
    }

    private Type field(String name) {
        return fielder.getType(DefaultInterfaceLocatorAtomicTest.class, name);
    }

    interface X<T> {
    }

    interface Y<T> {
    }

    interface One extends X<String> {
    }

    interface Two extends One {
    }

    interface Three extends X<String>, Y<Integer> {
    }

    interface Four extends Y<Integer>, X<String> {
    }

    interface Five extends One, Y<Integer> {
    }

    interface Six extends Four {
    }

    interface Seven<T> extends X<T> {
    }

    interface Eight extends Seven<String> {
    }

    interface BadOne extends X {
    }

    interface BadTwo {
    }
}
