package au.net.netstorm.boost.gunge.io;

import java.io.Serializable;
import au.net.netstorm.boost.gunge.sledge.java.io.EdgeOutputStream;
import au.net.netstorm.boost.sniper.check.Asserter;
import au.net.netstorm.boost.sniper.check.DefaultAsserter;
import junit.framework.Assert;

final class MockEdgeOutputStream extends Assert implements EdgeOutputStream, Serializable {
    private final transient Asserter asserter = new DefaultAsserter();
    private byte[] actual;
    private boolean flushed = false;
    private boolean writeCalled = false;

    public void write(byte[] bytes) {
        if (writeCalled) {
            fail("Expecting a single call only to write.");
        }
        writeCalled = true;
        actual = bytes;
    }

    public void flush() {
        if (!writeCalled) {
            fail("write(...) must be called prior to flush().");
        }
        flushed = true;
    }

    public void close() {
        throw new RuntimeException("NOT IMPLEMENTED YET");
    }

    public void verify(byte[] expected) {
        asserter.checkEquals(expected, actual);
        assertTrue(flushed);
    }
}