package au.net.netstorm.boost.gunge.lazy;

import java.util.concurrent.atomic.AtomicReference;

public final class DefaultLazy<T> implements Lazy<T> {
    private final AtomicReference<T> ref = new AtomicReference<T>();
    private final LazyCreator<T> creator;

    public DefaultLazy(LazyCreator<T> creator) {
        this.creator = creator;
    }

    public T get() {
        T instance = ref.get();
        if (instance != null) return instance;
        // creator.nu is expected to be side effect free.
        instance = creator.nu();
        ref.compareAndSet(null, instance);
        return ref.get();
    }
}
