package au.net.netstorm.boost.gunge.optional;

import au.net.netstorm.boost.bullet.primordial.Primordial;

public final class SetOptional<T> extends Primordial implements Optional<T> {
    private T t;

    public SetOptional(T t) {
        validate(t);
        this.t = t;
    }

    public boolean isSet() {
        return true;
    }

    public T get() {
        return t;
    }

    public int hashCode() {
        return t.hashCode();
    }

    public boolean equals(Object o) {
        if (getClass() != o.getClass()) return false;
        Optional other = (Optional) o;
        Object value = other.get();
        return t.equals(value);
    }

    private void validate(Object o) {
        if (o == null) throw new IllegalArgumentException("DefaultOptional can not be null. Use NotSet.");
    }
}
