package au.net.netstorm.boost.gunge.optional;

import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public final class SetOptionalAtomicTest extends LifecycleTestCase implements InjectableTest {
    private Object dummy = new Object();
    private Optional<Object> subject = new SetOptional<Object>(dummy);
    private Optional<Object> not = new NotSetOptional<Object>();

    public void testBlowUpOnNull() {
        try {
            new SetOptional(null);
            fail();
        } catch (IllegalArgumentException expected) {}
    }

    public void testIsSet() {
        boolean actual = subject.isSet();
        assertEquals(true, actual);
    }

    public void testGet() {
        Object actual = subject.get();
        assertSame(dummy, actual);
    }

    public void testEqual() {
        checkEquals(true, subject, subject);
        checkEquals(true, not, not);
        checkEquals(false, subject, not);
        checkEquals(false, not, subject);
    }

    private void checkEquals(boolean expected, Optional<Object> x, Optional<Object> y) {
        boolean actual = x.equals(y);
        assertEquals(expected, actual);
    }
}
