package au.net.netstorm.boost.gunge.primitives;

import java.lang.reflect.Array;

public final class DefaultArrayBoxer implements ArrayBoxer {
    private final PrimitiveBoxer boxer = new DefaultPrimitiveBoxer();

    public Object[] box(Object o) {
        Class boxed = getBoxed(o);
        int length = Array.getLength(o);
        Object[] target = (Object[]) Array.newInstance(boxed, length);
        for (int i = 0; i < target.length; i++) {
            target[i] = Array.get(o, i);
        }
        return target;
    }

    private Class getBoxed(Object o) {
        Class c = o.getClass();
        Class component = c.getComponentType();
        return boxer.getBoxed(component);
    }
}
