package au.net.netstorm.boost.gunge.proxy;

// FIX WHUPANT Use or lose. Wire into DefaultProxyFactory. Choose lower most classloader.
public final class DefaultClassLoaderMaster implements ClassLoaderMaster {
    public ClassLoader find(Class[] types) {
        check(types);
        ClassLoader loader = first(types);
        for (Class type : types) loader = sieve(type, loader);
        return loader;
    }

    private ClassLoader first(Class[] types) {
        for (Class type : types) if (has(type)) return cl(type);
        return ClassLoader.getSystemClassLoader();
    }

    private ClassLoader sieve(Class type, ClassLoader loader) {
        ClassLoader other = cl(type);
        if (irrelevant(loader, other)) return loader;
        if (hasParent(loader, other)) return loader;
        if (hasParent(other, loader)) return other;
        throw new IllegalArgumentException("No common root between loaders.");
    }

    private boolean irrelevant(ClassLoader loader, ClassLoader other) {
        return other == null || loader == other;
    }

    private boolean hasParent(ClassLoader child, ClassLoader perspective) {
        ClassLoader parent = child.getParent();
        if (parent == null) return false;
        if (parent == perspective) return true;
        return hasParent(parent, perspective);
    }

    private boolean has(Class type) {
        return cl(type) != null;
    }

    private ClassLoader cl(Class type) {
        return type.getClassLoader();
    }

    private void check(Class[] types) {
        if (types.length == 0) throw new IllegalArgumentException("Must provide at least one type.");
    }
}
