package au.net.netstorm.boost.gunge.proxy;

import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public final class DefaultClassLoaderMasterAtomicTest extends LifecycleTestCase implements InjectableTest {
    private ClassLoader root = getClass().getClassLoader();
    private TestClassLoader child = new TestClassLoader(root);
    private TestClassLoader independent = new TestClassLoader();
    private Class thing1 = load(child, "au.net.netstorm.boost.gunge.proxy.ThingOne");
    private Class thing2 = load(independent, "au.net.netstorm.boost.gunge.proxy.ThingTwo");
    private Class cat = TheCatInTheHat.class;
    ClassLoaderMaster subject;

    public void testSetUp() {
        assertEquals(root, cat.getClassLoader());
        assertEquals(independent, thing2.getClassLoader());
        assertEquals(child, thing1.getClassLoader());
    }

    public void testGood() {
        check(root, cat, cat);
        check(child, cat, thing1);
        check(child, thing1, cat);
        check(child, cat, thing1, cat);
        check(child, thing1, thing1);
        check(child, cat, cat, cat, cat, cat, cat, cat, thing1);
        check(child, thing1, cat, cat, cat, cat, cat, cat, cat);
    }

    public void testEvil() {
        checkEvil(thing1, thing2);
        checkEvil(cat, thing1, thing2);
        checkEvil(thing1, thing1, thing1, thing1, thing2);
        checkEvil(thing2, thing1, thing1, thing1, thing1);
    }

    private void check(ClassLoader expected, Class... classes) {
        ClassLoader actual = subject.find(classes);
        assertEquals(expected, actual);
    }

    private void checkEvil(Class... classes) {
        try {
            subject.find(classes);
            fail();
        } catch (IllegalArgumentException expected) {}
    }

    private Class load(ClassLoader loader, String name) {
        try {
            return Class.forName(name, true, loader);
        } catch (ClassNotFoundException e) {
            throw new RuntimeException(e);
        }
    }
}
