package au.net.netstorm.boost.gunge.proxy;

import java.lang.reflect.InvocationHandler;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.DefaultProxySupplier;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.ProxySupplier;
import au.net.netstorm.boost.gunge.type.DefaultInterfaceMaster;
import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.gunge.type.InterfaceMaster;

public final class DefaultProxyFactory implements ProxyFactory {
    private final ProxySupplier supplier = new DefaultProxySupplier();
    private final InterfaceMaster interfaces = new DefaultInterfaceMaster();
    private final ClassLoaderMaster loaders = new DefaultClassLoaderMaster();

    public Object proxy(InvocationHandler handler, Class[] types) {
        ClassLoader loader = loaders.find(types);
        return supplier.getProxy(loader, types, handler);
    }

    public Object proxy(InvocationHandler handler, Interface[] types) {
        Class[] classes = interfaces.classes(types);
        return proxy(handler, classes);
    }
}
