package au.net.netstorm.boost.gunge.proxy;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;

public final class TestClassLoader extends URLClassLoader {
    private static final String CLASS_FILE = "au/net/netstorm/boost/gunge/proxy/TestClassLoader.class";

    public TestClassLoader() {
        super(url(TestClassLoader.class.getClassLoader()), new DummyClassLoader());
    }

    public TestClassLoader(ClassLoader parent) {
        super(url(parent), parent);
    }

    private static URL[] url(ClassLoader parent) {
        URL resource = parent.getResource(CLASS_FILE);
        String full = resource.toString();
        String base = full.replace(CLASS_FILE, "");
        URL url = url(base);
        return new URL[]{url};
    }

    public synchronized Class<?> loadClass(String name, boolean resolve) throws ClassNotFoundException {
        if (loaded(name)) return findLoadedClass(name);
        if (!boost(name)) return super.loadClass(name, resolve);
        return findClass(name);
    }

    private boolean loaded(String name) {
        return findLoadedClass(name) != null;
    }

    private boolean boost(String name) {
        return name.startsWith("au.net.netstorm.boost");
    }

    private static URL url(String base) {
        try {
            return new URL(base);
        } catch (MalformedURLException e) {
            throw new RuntimeException(e);
        }
    }
}
