package au.net.netstorm.boost.gunge.recursion;

import java.util.List;
import au.net.netstorm.boost.gunge.set.HashSetWirer;
import au.net.netstorm.boost.gunge.set.Set;
import au.net.netstorm.boost.gunge.set.SetWirer;

public final class DefaultGuard<T> implements Guard<T> {
    Levels<Set> levels = new DefaultLevels<Set>();
    SetWirer wirer = new HashSetWirer();

    public void push() {
        Set level = wirer.identity();
        levels.push(level);
    }

    public void pop() {
        levels.pop();
    }

    public boolean guard(T t) {
        List<Set> all = levels.all();
        for (Set set : all) {
            if (set.has(t)) return true;
        }
        add(t);
        return false;
    }

    private void add(T t) {
        Set set = levels.current();
        set.put(t);
    }
}
