package au.net.netstorm.boost.gunge.recursion;

import au.net.netstorm.boost.gunge.set.HashSetWirer;
import au.net.netstorm.boost.gunge.set.SetWirer;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.Destroyable;
import au.net.netstorm.boost.sniper.marker.HasFixtures;
import au.net.netstorm.boost.sniper.marker.InjectableTest;
import au.net.netstorm.boost.sniper.marker.OverlaysWeb;

public final class DefaultGuardAtomicTest extends LifecycleTestCase implements HasFixtures, InjectableTest, Destroyable, OverlaysWeb {
    private Object o1 = new Object();
    private Object o2 = new Object();
    Guard independent;
    Guard subject;

    // FIX 3324 Mar 13, 2009 Might be able to remove.
    public void overlay() {
        wire.cls(HashSetWirer.class).to(SetWirer.class);
    }

    public void fixtures() {
        subject.push();
        independent.push();
    }

    public void destroy() {
        subject.pop();
        independent.pop();
    }

    public void testIndependence() {
        check(subject, false, o1);
        check(independent, false, o1);
    }

    public void testGuarding() {
        check(false, o1);
        check(true, o1);
        check(false, o2);
        check(true, o1);
        check(true, o2);
    }

    public void testLayers() {
        subject.push();
        check(false, o1);
        check(true, o1);
        subject.pop();
        check(false, o1);
    }

    private void check(boolean expected, Object ref) {
        check(subject, expected, ref);
    }

    private void check(Guard guard, boolean expected, Object ref) {
        boolean actual = guard.guard(ref);
        assertEquals(expected, actual);
    }
}
