package au.net.netstorm.boost.gunge.recursion;

import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
import au.net.netstorm.boost.gunge.thread.DefaultThreaded;
import au.net.netstorm.boost.gunge.thread.Threaded;

public class DefaultLevels<T> implements Levels<T> {
    Threaded<Stack> levels = new DefaultThreaded(Stack.class);

    public void push(T t) {
        Stack<T> stack = stack();
        stack.push(t);
    }

    public void pop() {
        Stack<T> stack = stack();
        stack.pop();
    }

    public T current() {
        Stack<T> stack = stack();
        return stack.peek();
    }

    public List<T> all() {
        Stack<T> stack = stack();
        return new ArrayList<T>(stack);
    }

    private Stack<T> stack() {
        if (!levels.exists()) initialize();
        return levels.get();
    }

    private void initialize() {
        Stack s = new Stack();
        levels.set(s);
    }
}
