package au.net.netstorm.boost.gunge.reflect.cls;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import au.net.netstorm.boost.gunge.sledge.support.SledgeException;
import au.net.netstorm.boost.sniper.core.BoooostCase;

public final class DefaultClassNameMorpherAtomicTest extends BoooostCase {
    private ClassMorpher morpher = new DefaultClassMorpher();

    public void testStripPrefix() {
        checkStripPrefix(Map.class, "Tree", TreeMap.class);
        checkStripPrefix(Set.class, "Hash", HashSet.class);
    }

    public void testPrefixNotInClass() {
        try {
            morpher.strip("Bollackery", HashSet.class);
            fail();
        } catch (IllegalArgumentException expected) { }
    }

    public void testStrippedClassNonExistent() {
        try {
            morpher.strip("TreeM", TreeMap.class);
            fail();
        } catch (SledgeException expected) { }
    }

    private void checkStripPrefix(Class expected, String prefix, Class cls) {
        Class result = morpher.strip(prefix, cls);
        assertEquals(expected, result);
    }
}
