package au.net.netstorm.boost.gunge.reflect.constructor;

import java.lang.reflect.Constructor;
import java.util.List;
import au.net.netstorm.boost.gunge.reflect.methcon.ConstructorsMethCons;
import au.net.netstorm.boost.gunge.reflect.methcon.DefaultMethConRefiner;
import au.net.netstorm.boost.gunge.reflect.methcon.DefaultParamsFilter;
import au.net.netstorm.boost.gunge.reflect.methcon.MethCon;
import au.net.netstorm.boost.gunge.reflect.methcon.MethConNotFoundBlock;
import au.net.netstorm.boost.gunge.reflect.methcon.MethConRefiner;
import au.net.netstorm.boost.gunge.reflect.methcon.MethCons;
import au.net.netstorm.boost.gunge.reflect.methcon.ParamsFilter;

public class DefaultConstructorResolver implements ConstructorResolver {
    private final MethConRefiner refiner = new DefaultMethConRefiner();
    private final ParamsFilter filter = new DefaultParamsFilter();

    public <T> Constructor<T> declared(Class<T> type, Object... params) {
        MethCons cons = new ConstructorsMethCons(type);
        List<MethCon> declared = cons.declared();
        return filter(type, declared, params);
    }

    public <T> Constructor<T> filter(Class<T> type, List<MethCon> mcs, Object... params) {
        List<MethCon> candidates = filter.filter(mcs, params);
        return refine(type, candidates, params);
    }

    @SuppressWarnings("unchecked")
    private <T> Constructor<T> refine(Class<T> type, List<MethCon> candidates, Object... params) {
        MethConNotFoundBlock notFound = notFound(type, params);
        MethCon con = refiner.refine(candidates, notFound);
        return con.constructor();
    }

    private MethConNotFoundBlock notFound(final Class type, final Object[] params) {
        return new MethConNotFoundBlock() {
            public void explode() {
                throw new ConstructorNotFoundException(type, params);
            }
        };
    }
}

