package au.net.netstorm.boost.gunge.reflect.constructor;

import java.lang.reflect.Constructor;
import au.net.netstorm.boost.gunge.type.Implementation;

public class DefaultSingleConstructor implements SingleConstructor {
    public <T> Constructor<T> ctor(Class<T> cls) {
        Constructor[] cs = cls.getDeclaredConstructors();
        check(cs, cls);
        return cs[0];
    }

    public <T> Constructor<T> ctor(Implementation<T> impl) {
        Class cls = impl.v();
        return ctor(cls);
    }

    private void check(Constructor[] constructors, Class cls) {
        if (constructors.length != 1) throw new IllegalStateException("We only support single constructors. " + cls);
    }
}
