package au.net.netstorm.boost.gunge.reflect.field;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.ArrayList;
import java.util.List;
import au.net.netstorm.boost.gunge.goop.BootstrapNvp;
import au.net.netstorm.boost.gunge.goop.Nvp;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.DefaultEdgeField;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.EdgeField;
// FIX BREADCRUMB 2751 AAAAAAAAAAAAAAAAAAAA Have this use the fielder/fields.
// FIX 2751 Jan 19, 2009 Can it make use of Fields.

// FIX 2751 Jan 16, 2009 This is SIMILAR to Fielder.
public final class DefaultFieldNvps implements FieldNvps {
    private final EdgeField edger = new DefaultEdgeField();

    public Nvp[] nvps(Object ref) {
        Class cls = ref.getClass();
        Field[] declared = cls.getDeclaredFields();
        return instanceFields(declared, ref);
    }

    private Nvp[] instanceFields(Field[] fields, Object ref) {
        List list = new ArrayList();
        for (Field field : fields) {
            addInstanceFields(list, field, ref);
        }
        return (Nvp[]) list.toArray(new Nvp[]{});
    }

    private void addInstanceFields(List list, Field field, Object ref) {
        if (isInstance(field)) {
            list.add(nvp(field, ref));
        }
    }

    private Nvp nvp(Field field, Object ref) {
        String name = field.getName();
        Object value = value(field, ref);
        return new BootstrapNvp(name, value);
    }

    private Object value(Field field, Object ref) {
        field.setAccessible(true);
        return edger.get(field, ref);
    }

    private boolean isInstance(Field field) {
        return !Modifier.isStatic(field.getModifiers());
    }
}
