package au.net.netstorm.boost.gunge.reflect.field;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import au.net.netstorm.boost.gunge.sledge.java.lang.DefaultEdgeClass;
import au.net.netstorm.boost.gunge.sledge.java.lang.EdgeClass;

public final class DefaultResolvableFieldFinder implements ResolvableFieldFinder {
    ResolvableFieldMaster resolvable = new DefaultResolvableFieldMaster();
    EdgeClass classer = new DefaultEdgeClass();

    public Field[] find(Object ref) {
        Field[] fields = getDeclaredFields(ref);
        List result = find(ref, fields);
        return (Field[]) result.toArray(new Field[result.size()]);
    }

    private List find(Object ref, Field[] fields) {
        List result = new ArrayList();
        for (Field field : fields) optionallyAdd(result, ref, field);
        return result;
    }

    private void optionallyAdd(List result, Object ref, Field field) {
        if (!resolvable.isResolvableField(ref, field)) return;
        result.add(field);
    }

    private Field[] getDeclaredFields(Object ref) {
        Class cls = ref.getClass();
        return classer.getDeclaredFields(cls);
    }
}
