package au.net.netstorm.boost.gunge.reflect.field;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.DefaultEdgeField;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.EdgeField;

public class DefaultResolvableFieldMaster implements ResolvableFieldMaster {
    // FIX 1531 Move "DefaultModifierTestUtil" in here and delegate to it.
    // FIX 1531 Dupe in all the private methods.
    private final EdgeField fielder = new DefaultEdgeField();

    public boolean isResolvableField(Object ref, Field field) {
        field.setAccessible(true);
        return isResolvableField(field) && isNull(ref, field);
    }

    public boolean isResolvableField(Field field) {
        field.setAccessible(true);
        // FIX 1531 Why doesn't this check not "public" | "protected" or do we consider them resolvable.
        return !isStatic(field) && !isFinal(field) && !isPrivate(field);
    }

    private boolean isStatic(Field field) {
        int modifiers = field.getModifiers();
        return Modifier.isStatic(modifiers);
    }

    private boolean isPrivate(Field field) {
        int modifiers = field.getModifiers();
        return Modifier.isPrivate(modifiers);
    }

    private boolean isNull(Object ref, Field field) {
        return fielder.get(field, ref) == null;
    }

    private boolean isFinal(Field field) {
        int modifiers = field.getModifiers();
        return Modifier.isFinal(modifiers);
    }
}
