package au.net.netstorm.boost.gunge.reflect.field;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import au.net.netstorm.boost.gunge.sledge.java.lang.EdgeClass;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.EdgeField;

public final class DefaultStaticFields implements StaticFields {
    EdgeClass classer;
    EdgeField edger;
    Fields fields;

    public <T> T get(Class cls, String name, Class<T> rtype) {
        Field field = field(cls, name);
        Object r = edger.get(field, null);
        return rtype.cast(r);
    }

    public boolean has(Class cls, String name) {
        if (!fields.has(cls, name)) return false;
        Field field = field(cls, name);
        return isStatic(field);
    }

    // FIX 2751 Jan 20, 2009 Need "modifiers" package.
    // FIX 2751 Move "DefaultModifierTestUtil" in here and delegate to it.
    private Field field(Class cls, String name) {
        return classer.getField(cls, name);
    }

    private boolean isStatic(Field field) {
        int i = field.getModifiers();
        return Modifier.isStatic(i);
    }
}
