package au.net.netstorm.boost.gunge.reflect.instantiate;

import java.lang.reflect.Array;
import java.lang.reflect.Constructor;
import au.net.netstorm.boost.gunge.reflect.constructor.DefaultSingleConstructor;
import au.net.netstorm.boost.gunge.reflect.constructor.SingleConstructor;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.DefaultEdgeConstructor;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.EdgeConstructor;
import au.net.netstorm.boost.gunge.type.DefaultImplementation;
import au.net.netstorm.boost.gunge.type.Implementation;
// FIX MARKH Delete me once JlsInstantiator is fixed.
// FIX MARKH Temp reinstate to work around bug. Will fix at lunch (which LUNCH?).
// FIX 3324 Mar 17, 2009 Sort this bucket of bolts out.

// FIX 3324 Mar 17, 2009 Or invite MARKH for lunch.
public class SingleInstantiator implements Instantiator {
    private SingleConstructor single = new DefaultSingleConstructor();
    private EdgeConstructor edger = new DefaultEdgeConstructor();

    public <T> T instantiate(Class<T> cls, Object... parameters) {
        Implementation<T> impl = new DefaultImplementation<T>(cls);
        return instantiate(impl, parameters);
    }

    public <T> T instantiate(Implementation<T> impl, Object... parameters) {
        Constructor<T> constructor = getConstructor(impl);
        if (isHard(constructor, parameters)) return hard(impl, constructor, parameters);
        return easy(impl, constructor, parameters);
    }

    private boolean isHard(Constructor constructor, Object... parameters) {
        if (!constructor.isVarArgs()) return false;
        if (parameters.length == 0) return true;
        return !isArray(parameters[parameters.length - 1]);
    }

    private boolean isArray(Object ref) {
        Class cls = ref.getClass();
        return cls.isArray();
    }

    private <T> T hard(Implementation<T> impl, Constructor<T> constructor, Object... parameters) {
        if (numParams(constructor) == 1) return single(impl, constructor, parameters);
        return multi(impl, constructor, parameters);
    }

    private <T> T single(Implementation<T> impl, Constructor<T> constructor, Object... parameters) {
        Class[] classes = constructor.getParameterTypes();
        Class type = classes[0].getComponentType();
        Object[] fixed = fix(type, parameters);
        return easy(impl, constructor, fixed);
    }

    private <T> T multi(Implementation<T> impl, Constructor<T> constructor, Object... parameters) {
        int num = numParams(constructor);
        Object[] actual = new Object[num];
        System.arraycopy(parameters, 0, actual, 0, num - 1);
        actual[num - 1] = varargs(constructor, parameters);
        return easy(impl, constructor, actual);
    }

    private Object[] fix(Class type, Object... parameters) {
        Object[] a = strong(type, parameters);
        return new Object[]{a};
    }

    private <T> Object[] varargs(Constructor<T> constructor, Object... parameters) {
        int num = numParams(constructor);
        Object[] varargs = new Object[parameters.length - (num - 1)];
        System.arraycopy(parameters, parameters.length - (parameters.length - (num - 1)), varargs, 0, varargs.length);
        Class type = varargsType(constructor);
        return strong(type, varargs);
    }

    private Class varargsType(Constructor constructor) {
        Class[] types = constructor.getParameterTypes();
        return types[types.length - 1].getComponentType();
    }

    private <T> T easy(Implementation<T> impl, Constructor<T> constructor, Object... parameters) {
        int expected = numParams(constructor);
        check(impl, expected, parameters.length);
        return instantiate(impl, constructor, parameters);
    }

    private <T> int numParams(Constructor<T> constructor) {
        Class[] paramTypes = constructor.getParameterTypes();
        return paramTypes.length;
    }

    private Object[] strong(Class type, Object... parameters) {
        Object[] result = (Object[]) Array.newInstance(type, parameters.length);
        System.arraycopy(parameters, 0, result, 0, result.length);
        return result;
    }

    private Constructor getConstructor(Implementation impl) {
        Class cls = impl.v();
        Constructor constructor = single.ctor(cls);
        constructor.setAccessible(true);
        return constructor;
    }

    private void check(Implementation impl, int expected, int supplied) {
        if (expected != supplied) boom(impl, expected, supplied);
    }

    private void boom(Implementation impl, int expected, int supplied) {
        String message = "Expected " + expected + " parameters, given " + supplied + " in constructor for " + impl;
        throw new IllegalArgumentException(message);
    }

    private <T> T instantiate(Implementation impl, Constructor<T> constructor, Object... parameters) {
        try {
            return edger.newInstance(constructor, parameters);
            // FIX 2751 should we be rewrapping here at all
        } catch (Exception e) {
            throw new IllegalArgumentException("Unable to construct a " + impl, e);
        }
    }
}


