package au.net.netstorm.boost.gunge.reflect.invoke;

import java.lang.reflect.Method;
import au.net.netstorm.boost.gunge.reflect.method.DefaultMethodResolver;
import au.net.netstorm.boost.gunge.reflect.method.MethodResolver;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.DefaultEdgeMethod;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.EdgeMethod;

public class DefaultMethodInvoker implements MethodInvoker {
    MethodResolver resolver = new DefaultMethodResolver();
    EdgeMethod methods = new DefaultEdgeMethod();

    public Object instance(Object invokee, String method, Object[] parameters) {
        Method m = method(invokee, method, parameters);
        return invoke(m, invokee, parameters);
    }

    public Object statik(Class cls, String method, Object[] parameters) {
        Method m = resolver.declared(cls, method, parameters);
        return invoke(m, NO_INSTANCE, parameters);
    }

    private Method method(Object ref, String name, Object[] params) {
        Class type = ref.getClass();
        return resolver.declared(type, name, params);
    }

    private Object invoke(Method method, Object invokee, Object[] parameters) {
        method.setAccessible(true);
        return methods.invoke(method, invokee, parameters);
    }

    private static final Object NO_INSTANCE = null;
}