package au.net.netstorm.boost.gunge.reflect.methcon;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

public final class DefaultMethCon implements MethCon {
    private final Constructor c;
    private final Method m;

    public DefaultMethCon(Constructor c) {
        this.c = c;
        m = null;
        validate(c);
    }

    public DefaultMethCon(Method m) {
        this.m = m;
        c = null;
        validate(m);
    }

    public Class<?>[] getParameterTypes() {
        return c == null ? m.getParameterTypes() : c.getParameterTypes();
    }

    public Constructor constructor() {
        state(c);
        return c;
    }

    public Method method() {
        state(m);
        return m;
    }

    private void state(Object m) {
        if (m == null) throw new IllegalStateException();
    }

    private void validate(Object o) {
        if (o == null) throw new IllegalArgumentException();
    }
}
