package au.net.netstorm.boost.gunge.reflect.methcon;

import java.util.List;
import au.net.netstorm.boost.gunge.collection.DefaultFunctionalCollection;
import au.net.netstorm.boost.gunge.collection.FunctionalCollection;
import au.net.netstorm.boost.gunge.reflect.signature.DefaultMostSpecificSignatureFinder;
import au.net.netstorm.boost.gunge.reflect.signature.MostSpecificSignatureFinder;

public final class DefaultMethConRefiner implements MethConRefiner {
    private final FunctionalCollection collection = new DefaultFunctionalCollection();

    public MethCon refine(List<MethCon> candidates, MethConNotFoundBlock notFound) {
        MostSpecificSignatureFinder finder = new DefaultMostSpecificSignatureFinder();
        int size = candidates.size();
        if (size == 0) notFound.explode();
        if (size == 1) return head(candidates);
        return collection.find(candidates, finder);
    }

    private MethCon head(List<MethCon> candidates) {
        return candidates.get(0);
    }
}
