package au.net.netstorm.boost.gunge.reflect.methcon;

import java.util.Collections;
import java.util.List;
import au.net.netstorm.boost.gunge.collection.DefaultFunctionalCollection;
import au.net.netstorm.boost.gunge.collection.FunctionalCollection;
import au.net.netstorm.boost.gunge.reflect.misc.DefaultObjectToClassMapper;
import au.net.netstorm.boost.gunge.reflect.misc.ObjectToClassMapper;
import au.net.netstorm.boost.gunge.reflect.signature.CompatibleSignaturesFilter;
import au.net.netstorm.boost.gunge.reflect.signature.DefaultCompatibleSignaturesFilter;

public class DefaultParamsFilter implements ParamsFilter {
    private final ObjectToClassMapper mapper = new DefaultObjectToClassMapper();
    private final FunctionalCollection collection = new DefaultFunctionalCollection();

    public List<MethCon> filter(List<MethCon> mcs, Object... params) {
        return filterSigs(mcs, params);
    }

    private List<MethCon> filterSigs(List<MethCon> mcs, Object... params) {
        List<Class> paramTypes = collection.map(params, mapper);
        CompatibleSignaturesFilter filter = new DefaultCompatibleSignaturesFilter(paramTypes);
        List<MethCon> r = collection.filter(mcs, filter);
        return Collections.unmodifiableList(r);
    }
}