package au.net.netstorm.boost.gunge.reflect.method;

import java.lang.reflect.Method;

public final class DefaultMethodInterrogator implements MethodInterrogator {
    public boolean parameterized(Method method) {
        Class<?>[] classes = method.getParameterTypes();
        return classes.length != 0;
    }

    public boolean primitive(Method method) {
        Class<?> type = method.getReturnType();
        return type.isPrimitive();
    }

    public boolean matches(Method method, Class type, String name) {
        String n = method.getName();
        Class t = method.getReturnType();
        return t.isAssignableFrom(type) && n.equals(name);
    }
}
