package au.net.netstorm.boost.gunge.reflect.method;

import java.lang.reflect.Method;
import java.util.List;
import au.net.netstorm.boost.gunge.reflect.methcon.DefaultMethConRefiner;
import au.net.netstorm.boost.gunge.reflect.methcon.DefaultMethodFilter;
import au.net.netstorm.boost.gunge.reflect.methcon.MethCon;
import au.net.netstorm.boost.gunge.reflect.methcon.MethConNotFoundBlock;
import au.net.netstorm.boost.gunge.reflect.methcon.MethConRefiner;
import au.net.netstorm.boost.gunge.reflect.methcon.MethCons;
import au.net.netstorm.boost.gunge.reflect.methcon.MethodFilter;
import au.net.netstorm.boost.gunge.reflect.methcon.MethodsMethCons;

public final class DefaultMethodResolver implements MethodResolver {
    MethConRefiner refiner = new DefaultMethConRefiner();

    public Method declared(Class type, String name, Object... params) {
        MethCons dec = new MethodsMethCons(type);
        List<MethCon> mcs = dec.declared();
        return filter(name, mcs, params);
    }

    private Method filter(String name, List<MethCon> mcs, Object... params) {
        MethodFilter filter = new DefaultMethodFilter();
        List<MethCon> candidates = filter.filter(mcs, name, params);
        MethConNotFoundBlock notFound = notFound(name, params);
        return refiner.refine(candidates, notFound).method();
    }

    private MethConNotFoundBlock notFound(final String name, final Object[] params) {
        return new MethConNotFoundBlock() {
            public void explode() {
                throw new MethodNotFoundException(name, params);
            }
        };
    }
}
