package au.net.netstorm.boost.gunge.reflect.misc;

import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassNames;

public final class DefaultClassNameMorpher implements ClassNameMorpher {
    ClassNames names = new DefaultClassNames();

    public String add(Class cls, String prefix) {
        String namespace = names.pkg(cls);
        String name = names.shorty(cls);
        return namespace + "." + prefix + name;
    }

    public String strip(Class cls, String prefix) {
        String namespace = names.pkg(cls);
        String name = names.shorty(cls);
        String morphedName = strip(prefix, name);
        return namespace + "." + morphedName;
    }

    // FIX 3324 Mar 18, 2009 This is just a string utility.  Got nothing to do with classes.
    public String strip(String prefix, String name) {
        if (!isPrefixIn(prefix, name))
            throw new IllegalArgumentException(prefix + " is not a prefix of " + name);
        int length = prefix.length();
        return name.substring(length);
    }

    private boolean isPrefixIn(String prefix, String shortName) {
        return shortName.startsWith(prefix);
    }
}
