package au.net.netstorm.boost.gunge.reflect.signature;

import java.util.List;
import au.net.netstorm.boost.gunge.reflect.methcon.MethCon;

public class DefaultCompatibleSignaturesFilter implements CompatibleSignaturesFilter {
    private final MethConSignatureRules jls = new DefaultMethConSignatureRules();
    private final Class<?>[] specificTypes;

    public DefaultCompatibleSignaturesFilter(List<Class> specificTypes) {
        this.specificTypes = specificTypes.toArray(new Class[specificTypes.size()]);
    }

    public boolean accept(MethCon c) {
        Class<?>[] candidate = c.getParameterTypes();
        return jls.compatible(candidate, specificTypes);
    }
}
