package au.net.netstorm.boost.gunge.reflect.signature;

import au.net.netstorm.boost.gunge.primitives.DefaultPrimitiveBoxer;
import au.net.netstorm.boost.gunge.primitives.PrimitiveBoxer;

public class DefaultMethConSignatureRules implements MethConSignatureRules {
    PrimitiveBoxer boxer = new DefaultPrimitiveBoxer();

    public boolean compatible(Class<?>[] target, Class<?>[] canIBeAssignedToTarget) {
        if (target.length != canIBeAssignedToTarget.length) return false;
        for (int i = 0; i < target.length; ++i) {
            if (!assignable(target[i], canIBeAssignedToTarget[i])) return false;
        }
        return true;
    }

    public boolean moreSpecific(Class<?>[] target, Class<?>[] amIMoreSpecificThanTarget) {
        // FIX 2852 Jan 23, 2009 MARKH The array should never be null should it, only the contents???
        // FIX 2380 Jan 23, 2009 Der, of course. 
        return amIMoreSpecificThanTarget == null ||
                (compatible(target, amIMoreSpecificThanTarget) &&
                        !compatible(amIMoreSpecificThanTarget, target));
    }

    private boolean assignable(Class<?> lhs, Class<?> rhs) {
        // FIX 2751 Jan 21, 2009 Sort out the null stuff.
        // FIX 2751 Jan 21, 2009 Test for this stuff.
        if (rhs == null) return true;
        if (lhs == null) return false;
        Class<?> boxedLeft = boxer.convertToBoxed(lhs);
        Class<?> boxedRight = boxer.convertToBoxed(rhs);
        return boxedLeft.isAssignableFrom(boxedRight);
    }
}
