package au.net.netstorm.boost.gunge.reflect.signature;

import au.net.netstorm.boost.gunge.reflect.methcon.MethCon;

public class DefaultMostSpecificSignatureFinder implements MostSpecificSignatureFinder {
    private final MethConSignatureRules jls = new DefaultMethConSignatureRules();
    private MethCon result;

    public boolean next(MethCon mc) {
        if (moreSpecific(mc, result)) result = mc;
        return true;
    }

    public MethCon result() {
        return result;
    }

    private boolean moreSpecific(MethCon lhs, MethCon rhs) {
        if (rhs == null) return true;
        Class<?>[] r = lhs.getParameterTypes();
        Class<?>[] l = rhs.getParameterTypes();
        return jls.moreSpecific(l, r);
    }
}
