package au.net.netstorm.boost.gunge.set;

import au.net.netstorm.boost.sniper.core.LifecycleTestCase;
import au.net.netstorm.boost.sniper.marker.InjectableTest;

public final class SetModuleTest extends LifecycleTestCase implements InjectableTest {
    SetWirer wirer = new HashSetWirer();
    Set subject1 = wirer.weakIdentity();
    Set subject2 = wirer.identity();
    Dot a = new ValueDot(1);
    Dot b = new ValueDot(2);
    Dot c = new ReferenceDot();
    Dot d = new ReferenceDot();
    Dot[] x = {};
    Dot[] xa = {a};
    Dot[] xb = {b};
    Dot[] xd = {d};
    Dot[] xab = {a, b};
    Dot[] xcd = {c, d};
    Dot[] xabc = {a, b, c};
    Dot[] xacd = {a, c, d};
    Dot[] xbcd = {b, c, d};
    Dot[] xabcd = {a, b, c, d};

    public void test() {
        pcheck(a, xa, xbcd);
        pcheck(b, xab, xcd);
        pcheck(c, xabc, xd);
        pcheck(d, xabcd, x);
        rcheck(b, xacd, xb);
    }

    private void pcheck(Dot dot, Dot[] good, Dot[] bad) {
        put(dot);
        check(good, bad);
    }

    private void rcheck(Dot dot, Dot[] good, Dot[] bad) {
        remove(dot);
        check(good, bad);
    }

    private void check(Dot[] good, Dot[] bad) {
        check(true, good);
        check(false, bad);
    }

    private void check(boolean expected, Dot... dots) {
        for (Dot dot : dots) check(expected, dot);
    }

    private void check(boolean expected, Dot dot) {
        check(expected, subject1, dot);
        check(expected, subject2, dot);
    }

    private void check(boolean expected, Set subject, Dot dot) {
        boolean actual = subject.has(dot);
        assertEquals(expected, actual);
    }

    private void put(Dot dot) {
        subject1.put(dot);
        subject2.put(dot);
    }

    private void remove(Dot dot) {
        subject1.remove(dot);
        subject2.remove(dot);
    }
}
