package au.net.netstorm.boost.gunge.set;

import java.lang.ref.WeakReference;

public final class WeakIdentityLink implements Link {
    public int hash(Object o) {
        if (!weak(o)) return 0;
        Object val = val(o);
        return System.identityHashCode(val);
    }

    public boolean equal(Object a, Object b) {
        if (!weak(a)) return false;
        if (!weak(b)) return false;
        return val(a) == val(b);
    }

    private Object val(Object o) {
        WeakReference ref = (WeakReference) o;
        return ref.get();
    }

    private boolean weak(Object o) {
        return o instanceof WeakReference;
    }
}
