package au.net.netstorm.boost.gunge.set;

import java.lang.ref.WeakReference;
import au.net.netstorm.boost.sniper.core.LifecycleTestCase;

public class WeakIdentityLinkConditionTest extends LifecycleTestCase {
    Object val = new Object();
    WeakReference ref = new WeakReference(val);
    Link subject = new WeakIdentityLink();

    public void testHash() {
        checkHash(0, null);
        checkHash(0, val);
    }

    public void testEqual() {
        checkEqual(false, ref, val);
        checkEqual(false, val, ref);
    }

    private void checkHash(int expected, Object o) {
        int actual = subject.hash(o);
        assertEquals(expected, actual);
    }

    private void checkEqual(boolean expected, Object a, Object b) {
        boolean actual = subject.equal(a, b);
        assertEquals(expected, actual);
    }
}
