package au.net.netstorm.boost.gunge.sledge.java.io;

import java.io.IOException;
import java.io.OutputStream;
import au.net.netstorm.boost.gunge.sledge.support.SledgeException;

public final class DefaultEdgeOutputStream implements EdgeOutputStream {
    private final OutputStream stream;

    public DefaultEdgeOutputStream(OutputStream stream) {
        this.stream = stream;
    }

    public void write(byte[] bytes) {
        try {
            stream.write(bytes);
        } catch (IOException e) {
            throw new SledgeException(e);
        }
    }

    public void flush() {
        try {
            stream.flush();
        } catch (IOException e) {
            throw new SledgeException(e);
        }
    }

    public void close() {
        try {
            stream.close();
        } catch (IOException e) {
            throw new SledgeException(e);
        }
    }
}
