package au.net.netstorm.boost.gunge.string;

public class DefaultStringStripper implements StringStripper {
    public String prefix(String s, String prefix) {
        if (!s.startsWith(prefix)) fail(s, "start", prefix);
        int newStart = prefix.length();
        return s.substring(newStart);
    }

    public String suffix(String s, String suffix) {
        if (!s.endsWith(suffix)) fail(s, "end", suffix);
        int newEnd = s.length() - suffix.length();
        return s.substring(0, newEnd);
    }

    public String regex(String s, String regex) {
        return s.replaceFirst(regex, "");
    }

    private void fail(String s, String reason, String token) {
        throw new IllegalArgumentException("Can't transform " + s + " does not " + reason + " with " + token);
    }
}
