package au.net.netstorm.boost.gunge.thread;

import au.net.netstorm.boost.gunge.collection.DefaultStrictMap;
import au.net.netstorm.boost.gunge.collection.StrictMap;

public final class DefaultThreadLocals implements ThreadLocals {
    private final ThreadLocal<StrictMap> threaded = new ThreadLocalMap<StrictMap>();

    public void clear() {
        get().clear();
    }

    public StrictMap get() {
        return threaded.get();
    }

    private static final class ThreadLocalMap<T> extends ThreadLocal<T> {
        public T initialValue() {
            return (T) new DefaultStrictMap();
        }
    }
}
