package au.net.netstorm.boost.gunge.tostring;

import java.lang.reflect.Array;
import au.net.netstorm.boost.gunge.goop.Nvp;
import au.net.netstorm.boost.gunge.indent.DefaultIndenterMaster;
import au.net.netstorm.boost.gunge.indent.IndenterMaster;
import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassNames;
import au.net.netstorm.boost.gunge.reflect.field.DefaultFieldNvps;
import au.net.netstorm.boost.gunge.reflect.field.FieldNvps;
import au.net.netstorm.boost.gunge.separator.Separator;
// FIX 2751 Jan 15, 2009 Bit of a trollop too.

// FIX 2394 This does not handle recursive links, blows up really badly.
public class IndentingToString implements ToString {
    private final ClassNames classer = new DefaultClassNames();
    private final FieldNvps reflecter = new DefaultFieldNvps();
    private final IndenterMaster indenter = new DefaultIndenterMaster();

    public String object(Object ref) {
        Nvp[] specs = reflecter.nvps(ref);
        boolean extended = useExtended(specs);
        return getClassName(ref, extended) + nvps(specs);
    }
    // FIX 2130 This beast has to live on!!!!!
//    if (MARKER.is(this, Sensitive.class)) return "Like XXXX, totally unflavoured.";

    public String nvps(Nvp[] nvps) {
        boolean extended = useExtended(nvps);
        String[] strings = extended ? multiple(nvps) : single(nvps[0]);
        return format(strings);
    }

    private String getClassName(Object ref, boolean extended) {
        return extended ? getClassName(ref) : BLANK;
    }

    private String format(String[] s) {
        if (s.length == 0) return "[]";
        if (s.length == 1) return getString(s);
        return "[" + LF + indent(getString(s)) + LF + "]";
    }

    private String getString(String[] s) {
        String result = BLANK;
        for (int i = 0; i < s.length; i++) {
            result += s[i];
            if (i < s.length - 1) {
                result += LF;
            }
        }
        return result;
    }

    private String[] multiple(Nvp[] nvps) {
        String[] result = new String[nvps.length];
        for (int i = 0; i < nvps.length; i++) {
            result[i] = formatField(nvps[i]);
        }
        return result;
    }

    private String[] single(Nvp nvp) {
        return new String[]{fieldValue(nvp)};
    }

    private String formatField(Nvp spec) {
        String name = spec.name();
        String value = fieldValue(spec);
        return name + "=" + value;
    }

    private String fieldValue(Nvp nvp) {
        Object value = nvp.value();
        if (value == null) return "NULL";
        return isArray(value) ? arrayValue(value) : value.toString();
    }

    private String arrayValue(Object array) {
        return "{" + arrayToString(array) + "}";
    }

    private String arrayToString(Object array) {
        String result = BLANK;
        for (int i = 0; i < Array.getLength(array); i++) {
            result += Array.get(array, i) + COMMA;
        }
        return removeLastChar(result);
    }

    private String getClassName(Object ref) {
        Class cls = ref.getClass();
        return classer.shorty(cls);
    }

    private boolean isArray(Object value) {
        Class cls = value.getClass();
        return cls.isArray();
    }

    private String removeLastChar(String s) {
        return s.length() == 0 ? s : s.substring(0, s.length() - 1);
    }

    private String indent(String result) {
        return indenter.indent(result);
    }

    private boolean useExtended(Object[] refs) {
        return refs.length != 1;
    }

    private static final String COMMA = ",";
    private static final String LF = Separator.LINE;
    private static final String BLANK = "";
}
// SUGGEST: It would be nice if byte[]s (int, long?) printed out in ASCII as well (hexdump style).