package au.net.netstorm.boost.gunge.type;

import java.util.HashSet;
import java.util.Set;

public final class DefaultTypeMaster implements TypeMaster {
    private final InterfaceMaster util = new DefaultInterfaceMaster();

    public boolean implementz(Implementation impl, Interface iface) {
        Class cls = impl.v();
        Class iFace = iface.v();
        return iFace.isAssignableFrom(cls);
    }

    public boolean extendz(Interface iface, Interface superIface) {
        Class superClass = superIface.v();
        Class cls = iface.v();
        return superClass.isAssignableFrom(cls);
    }

    public Interface[] declaredInterfaces(Implementation impl) {
        Class implClass = impl.v();
        return declaredInterfaces(implClass);
    }

    public Interface[] interfaces(Interface iface) {
        Class cls = iface.v();
        Set set = new HashSet();
        interfaces(set, cls);
        return toInterfaces(set);
    }

    public Interface[] interfaces(Implementation impl) {
        Class cls = impl.v();
        Class[] ifaces = cls.getInterfaces();
        Set set = new HashSet();
        interfaces(set, ifaces);
        return toInterfaces(set);
    }

    public Interface[] declaredInterfaces(Interface iface) {
        Class cls = iface.v();
        return declaredInterfaces(cls);
    }

    private Interface[] declaredInterfaces(Class cls) {
        Class[] ifaces = cls.getInterfaces();
        return util.interfaces(ifaces);
    }

    private void interfaces(Set set, Class[] ifaces) {
        for (Class iface : ifaces) {
            interfaces(set, iface);
        }
    }

    private void interfaces(Set set, Class iface) {
        set.add(iface);
        Class[] ifaces = iface.getInterfaces();
        interfaces(set, ifaces);
    }

    private Interface[] toInterfaces(Set set) {
        Class[] result = (Class[]) set.toArray(new Class[]{});
        return util.interfaces(result);
    }
}
