package au.net.netstorm.boost.sniper.automock;

import java.util.Random;
import au.net.netstorm.boost.sniper.field.FieldSuffix;
import au.net.netstorm.boost.sniper.field.MockFieldSuffix;
import au.net.netstorm.boost.sniper.inject.SubjectInjector;
import au.net.netstorm.boost.sniper.matcher.DummyMatcher;
import au.net.netstorm.boost.sniper.matcher.Matcher;
import au.net.netstorm.boost.sniper.matcher.MockMatcher;
import au.net.netstorm.boost.sniper.matcher.RandomMatcher;
import au.net.netstorm.boost.spider.api.config.web.Web;
import au.net.netstorm.boost.spider.api.config.wire.Wire;
import au.net.netstorm.boost.spider.api.runtime.Injector;

public class AutoMockWeb implements Web {
    Wire wire;

    public void web() {
        mocks();
        injectors();
        matchers();
    }

    private void mocks() {
        wire.ref(new Random()).to(Random.class);
        wire.nu(MockSupport.class).to(MockSupport.class);
    }

    private void injectors() {
        wire.cls(RandomsInjector.class).one().to(Injector.class, DefaultTestFieldInjector.class, "randominator");
        wire.cls(SubjectInjector.class).one().to(Injector.class, DefaultTestFieldInjector.class, "subjectinator");
        wire.cls(MockInjector.class).one().to(Injector.class, DefaultTestFieldInjector.class, "mockinator");
        wire.cls(DummyInjector.class).one().to(Injector.class, DefaultTestFieldInjector.class, "dumminator");
    }

    private void matchers() {
        wire.cls(MockFieldSuffix.class).one().to(FieldSuffix.class, SubjectInjector.class);
        wire.cls(MockMatcher.class).one().to(Matcher.class, MockInjector.class);
        wire.cls(RandomMatcher.class).one().to(Matcher.class, RandomsInjector.class);
        wire.cls(DummyMatcher.class).one().to(Matcher.class, DummyInjector.class);
    }
}
