package au.net.netstorm.boost.sniper.check;

import java.util.Arrays;
import au.net.netstorm.boost.gunge.primitives.ArrayBoxer;
import au.net.netstorm.boost.gunge.primitives.DefaultArrayBoxer;
import junit.framework.Assert;
import junit.framework.ComparisonFailure;

// FIX 1200 Jan 19, 2009 Generally ugly.  Tidy.  Split.
public final class DefaultAsserter implements Asserter {
    // FIX 2751 Jan 19, 2009 Can this be replaced with CoreEqualsMaster.
    private final ArrayBoxer arrays = new DefaultArrayBoxer();

    public void fail(String message) {
        Assert.fail(message);
    }

    public void checkEquals(Object o1, Object o2) {
        checkEquals(o1, o2, true);
    }

    public void checkNotEquals(Object o1, Object o2) {
        checkEquals(o1, o2, false);
    }

    public void checkBagEquals(Object[] o1, Object[] o2) {
        basicCheck(true, o1, o2);
        boolean[] used = used(o1);
        for (Object ref : o2) {
            if (!find(used, o1, ref)) Assert.fail("Not in bag " + Arrays.toString(o1) + " " + ref);
        }
    }

    private void checkEquals(Object o1, Object o2, boolean expected) {
        Class c1 = o1.getClass();
        Class c2 = o2.getClass();
        if (c1.isArray() && c2.isArray()) arrayEquals(expected, c1, o1, o2);
        else Assert.assertEquals(expected, o1.equals(o2));
    }

    private void arrayEquals(boolean expected, Class type, Object o1, Object o2) {
        Class component = type.getComponentType();
        if (component.isPrimitive()) checkPrimitiveArrayEquals(expected, o1, o2);
        else checkArrayEquals(expected, o1, o2);
    }

    private void checkPrimitiveArrayEquals(boolean expected, Object o1, Object o2) {
        Object[] a1 = arrays.box(o1);
        Object[] a2 = arrays.box(o2);
        checkArrayEquals(expected, a1, a2);
    }

    private void checkArrayEquals(boolean expected, Object o1, Object o2) {
        Object[] a1 = (Object[]) o1;
        Object[] a2 = (Object[]) o2;
        basicCheck(expected, a1, a2);
        boolean result = Arrays.deepEquals(a1, a2);
        if (result != expected) fail(a1, a2);
    }

    private boolean find(boolean[] used, Object[] array, Object toFind) {
        for (int i = 0; i < array.length; i++) {
            if (used[i]) continue;
            if (toFind.equals(array[i])) {
                used[i] = true;
                return true;
            }
        }
        return false;
    }

    private boolean[] used(Object[] o1) {
        boolean[] used = new boolean[o1.length];
        Arrays.fill(used, false);
        return used;
    }

    private void basicCheck(boolean expected, Object[] o1, Object[] o2) {
        Assert.assertNotNull(o1);
        Assert.assertNotNull(o2);
        Assert.assertEquals("Array lengths do not match.", expected, o1.length == o2.length);
    }

    private void fail(Object[] a1, Object[] a2) {
        throw new ComparisonFailure("Arrays not equal. ", Arrays.deepToString(a1), Arrays.deepToString(a2));
    }
}
