package au.net.netstorm.boost.sniper.core;

import au.net.netstorm.boost.sniper.web.SniperWeb;
import au.net.netstorm.boost.spider.api.builder.Egg;
import au.net.netstorm.boost.spider.api.builder.SpiderEgg;
import au.net.netstorm.boost.spider.api.config.wire.Wire;
import au.net.netstorm.boost.spider.api.runtime.Spider;
import au.net.netstorm.boost.spider.ioc.BoostWeb;

public abstract class SpiderTestCase extends CleanTestCase {
    Class[] classes = {BoostWeb.class, SniperWeb.class};
    public Spider spider;
    public Wire wire;

    public final void runBare() throws Throwable {
        Class[] webs = webs();
        Egg egg = new SpiderEgg(webs);
        spider = egg.hatch();
        wire = spider.resolve(Wire.class);
        ioc();
    }

    /* This is overridden ... be careful. */
    public Class[] webs() {
        return classes;
    }

    public abstract void ioc();
}
