package au.net.netstorm.boost.sniper.inject;

import java.lang.reflect.Field;
import java.util.List;
import au.net.netstorm.boost.gunge.reflect.field.ResolvableFieldFinder;
import au.net.netstorm.boost.gunge.sledge.support.SledgeException;
import au.net.netstorm.boost.sniper.field.FieldSuffix;
import au.net.netstorm.boost.sniper.reflect.util.FieldTestUtil;
import au.net.netstorm.boost.spider.api.runtime.Injector;

public final class SubjectInjector implements Injector {
    FieldTestUtil fielder;
    ResolvableFieldFinder resolvableFieldFinder;
    FieldNameFinder fieldNameFinder;
    FieldSuffix mockSuffix;

    public void inject(Object testCase) {
        Object subject = nullGetSubject(testCase);
        if (subject != null) {
            Field[] subjectFields = resolvableFieldFinder.find(subject);
            List testFields = fieldNameFinder.find(testCase);
            inject(testCase, testFields, subject, subjectFields);
        }
    }

    private void inject(Object testCase, List testFields, Object subject, Field[] subjectFields) {
        for (int i = 0; i < subjectFields.length; i++) {
            injectField(testFields, subjectFields[i], testCase, subject);
        }
    }

    private void injectField(List testFields, Field subjectField, Object testCase, Object subject) {
        if (isMatchingField(subjectField, testFields)) {
            String testFieldName = getTestFieldName(subjectField, testFields);
            Object value = fielder.getInstance(testCase, testFieldName);
            String subjectFieldName = getFieldName(subjectField);
            fielder.setInstance(subject, subjectFieldName, value);
        }
    }

    private String getTestFieldName(Field field, List testFields) {
        String name = getFieldName(field);
        if (testFields.contains(name)) return name;
        return getMockFieldName(field);
    }

    private String getMockFieldName(Field field) {
        return mockSuffix.addSuffix(field);
    }

    private boolean isMatchingField(Field field, List testFields) {
        String fieldName = getFieldName(field);
        if (testFields.contains(fieldName)) return true;
        String mockName = getMockFieldName(field);
        return testFields.contains(mockName);
    }

    private String getFieldName(Field field) {
        return field.getName();
    }

    // FIX DEBT Stinky.  Need a getField or fieldExists().
    private Object nullGetSubject(Object testCase) {
        try {
            return fielder.getInstance(testCase, "subject");
        } catch (SledgeException e) {
            return null;
        }
    }
}
