package au.net.netstorm.boost.sniper.resolver;

import java.lang.reflect.Array;
import au.net.netstorm.boost.gunge.provider.NotProvidedException;

public final class ArrayRandomTestResolver implements SpecificTestResolver {
    TestResolver testResolver;

    public <T> T resolve(Class<T> type) {
        if (!canProvide(type)) throw new NotProvidedException(type);
        Class componentType = type.getComponentType();
        int size = randomSize();
        T array = (T) Array.newInstance(componentType, size);
        populate(size, componentType, array);
        return array;
    }

    public boolean canProvide(Class type) {
        return type.isArray();
    }

    private void populate(int size, Class componentType, Object array) {
        for (int i = 0; i < size; i++) {
            Object instance = testResolver.resolve(componentType);
            Array.set(array, i, instance);
        }
    }

    private int randomSize() {
        Boolean on = testResolver.resolve(Boolean.class);
        return on ? 4 : 5;
    }
}
