package au.net.netstorm.boost.sniper.resolver;

import au.net.netstorm.boost.spider.api.lifecycle.Constructable;

public final class EverythingRandomTestResolver implements Constructable, TestResolver {
    private SpecificTestResolver[] all;
    SpecificTestResolver arrays;
    SpecificTestResolver primitives;
    SpecificTestResolver concretes;
    SpecificTestResolver strong;
    SpecificTestResolver struct;
    SpecificTestResolver times;
    SpecificTestResolver immutables;
    SpecificTestResolver custom;
    SpecificTestResolver interfaces;
    SpecificTestResolver enums;

    public void constructor() {
        all = new SpecificTestResolver[]{
                custom, strong, struct, times, immutables, interfaces, enums, primitives, arrays, concretes
        };
    }

    public <T> T resolve(Class<T> type) {
        for (SpecificTestResolver provider : all) {
            if (is(type, provider)) return provider.resolve(type);
        }
        throw new IllegalStateException("Cannot provide type: " + type);
    }

    private boolean is(Class type, SpecificTestResolver provider) {
        return provider.canProvide(type);
    }
}
