package au.net.netstorm.boost.sniper.resolver;

import au.net.netstorm.boost.gunge.primitives.PrimitiveBoxer;
import au.net.netstorm.boost.gunge.provider.NotProvidedException;

public final class PrimitiveTestResolver implements SpecificTestResolver {
    PrimitiveBoxer primitives;
    TestResolver concretes;

    public <T> T resolve(Class<T> type) {
        if (!canProvide(type)) throw new NotProvidedException(type);
        return random(type);
    }

    public boolean canProvide(Class type) {
        return primitives.isPrimitive(type);
    }

    private <T> T random(Class<T> type) {
        Class<T> boxed = primitives.getBoxed(type);
        return concretes.resolve(boxed);
    }
}
