package au.net.netstorm.boost.sniper.specific;

import java.util.Map;

public final class DefaultCustomTestResolver implements CustomTestResolver {
    Map<Class, TestType> datas;

    public <T> void add(Class<T> type, TestType test) {
        datas.put(type, test);
    }

    public boolean canProvide(Class type) {
        return datas.containsKey(type);
    }

    public <T> T resolve(Class<T> type) {
        TestType test = datas.get(type);
        Object data = test.get();
        return type.cast(data);
    }
}
