package au.net.netstorm.boost.spider.api.builder;

import au.net.netstorm.boost.spider.api.config.web.Web;
import au.net.netstorm.boost.spider.api.runtime.Spider;
import au.net.netstorm.boost.spider.internals.bootstrap.build.Bootstrapper;
import au.net.netstorm.boost.spider.internals.bootstrap.build.SpiderBootstrapper;

// FIX MH Why is this statefull, other than making it hard to use, does it serve a purpose??
// FIX 3324 Mar 13, 2009 Move into "entry".
public class SpiderEgg implements Egg {
    private Class<? extends Web>[] webs;
    private boolean hatched = false;

    public SpiderEgg(Class<? extends Web>... webs) {
        setWebs(webs);
    }

    // The following constructors take care of most calling code getting unchecked generic array creation warnings.
    public SpiderEgg(Class<? extends Web> web) {
        setWebs(web);
    }

    public SpiderEgg(Class<? extends Web> web1, Class<? extends Web> web2) {
        setWebs(web1, web2);
    }

    public SpiderEgg(Class<? extends Web> web1, Class<? extends Web> web2, Class<? extends Web> web3) {
        setWebs(web1, web2, web3);
    }

    // OK LineLength {
    public SpiderEgg(Class<? extends Web> web1, Class<? extends Web> web2, Class<? extends Web> web3, Class<? extends Web> web4) {
        setWebs(web1, web2, web3, web4);
    }
    // } OK LineLength

    public synchronized Spider hatch() {
        oneshot();
        Spider spider = spider();
        spin(spider);
        return spider;
    }

    private void setWebs(Class<? extends Web>... webs) {
        this.webs = webs;
    }

    private Spider spider() {
        Bootstrapper bootstrapper = new SpiderBootstrapper();
        return bootstrapper.bootstrap();
    }

    private void spin(Spider spider) {
        Spinneret spinneret = spider.resolve(Spinneret.class);
        spinneret.spin(webs);
    }

    private void oneshot() {
        if (hatched) throw new IllegalStateException("You can't hatch an egg twice ya goose.");
        hatched = true;
    }
}
