package au.net.netstorm.boost.spider.api.config.mapping;

import au.net.netstorm.boost.spider.api.runtime.Impl;
import au.net.netstorm.boost.spider.plugs.factory.builtin.Mapping;
import au.net.netstorm.boost.spider.plugs.factory.builtin.Mappings;
import au.net.netstorm.boost.spider.plugs.factory.builtin.PackageMapping;
import au.net.netstorm.boost.spider.plugs.factory.builtin.PrefixMapping;
import au.net.netstorm.boost.spider.plugs.factory.builtin.ScopedMapping;
import au.net.netstorm.boost.spider.plugs.factory.builtin.SuffixMapping;

public class DefaultMapper implements Mapper {
    Mappings mappings;
    Impl impl;

    public void prefix(String name) {
        fu(PrefixMapping.class, name);
    }

    public void suffix(String name) {
        fu(SuffixMapping.class, name);
    }

    public void prefix(String name, String scope) {
        fu(PrefixMapping.class, name, scope);
    }

    public void suffix(String name, String scope) {
        fu(SuffixMapping.class, name, scope);
    }

    public void prefix(String name, String pkgfrom, String pkgto) {
        fu(PrefixMapping.class, name, pkgfrom, pkgto);
    }

    public void suffix(String name, String pkgfrom, String pkgto) {
        fu(SuffixMapping.class, name, pkgfrom, pkgto);
    }

    private void fu(Class<? extends Mapping> type, String name, String scope) {
        Mapping cls = impl.impl(type, name);
        fu(ScopedMapping.class, cls, scope);
    }

    private void fu(Class<? extends Mapping> type, String name, String pkgfrom, String pkgto) {
        Mapping cls = impl.impl(type, name);
        fu(PackageMapping.class, cls, pkgfrom, pkgto);
    }

    private void fu(Class<? extends Mapping> type, Object... args) {
        Mapping mapping = impl.impl(type, args);
        mappings.add(mapping);
    }
}
