package au.net.netstorm.boost.spider.api.config.wire;

import au.net.netstorm.boost.spider.api.runtime.Nu;
import au.net.netstorm.boost.spider.core.binding.Pattern;
import au.net.netstorm.boost.spider.core.binding.Patterns;
import au.net.netstorm.boost.spider.internals.bind.nustuff.Store;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public final class DefaultLine<T> implements Line<T> {
    final Provider<T> provider;
    Providers providers;
    Patterns patterns;
    Store store;
    Nu nu;

    public DefaultLine(Provider<T> provider) {
        this.provider = provider;
    }

    public Line<T> to(Class<? super T> type, Class host, String name) {
        Pattern p = patterns.pattern(type, host, name);
        return line(p);
    }

    public Line<T> to(Class<? super T> type, String name) {
        Pattern p = patterns.pattern(type, name);
        return line(p);
    }

    public Line<T> to(Class<? super T> type, Class host) {
        Pattern p = patterns.pattern(type, host);
        return line(p);
    }

    public Line<T> to(Class<? super T> type) {
        Pattern p = patterns.pattern(type);
        return line(p);
    }

    public Line<T> one() {
        Provider one = providers.one(provider);
        return nu.nu(Line.class, one);
    }

    private Line<T> line(Pattern<T> p) {
        store.store(p, provider);
        return nu.nu(Line.class, provider);
    }
}
