package au.net.netstorm.boost.spider.api.config.wire;

import au.net.netstorm.boost.spider.api.runtime.Spider;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public final class DefaultWire implements Wire {
    Providerer providerer;
    Clser clser;
    Refer refer;
    Nuer nuer;
    Impler impler;
    Resolverer resolverer;
    Spiderer spiderer;

    public <T> Line<T> cls(Class<T> impl) {
        return clser.cls(impl);
    }

    public <T> Line<T> ref(T o) {
        return refer.ref(o);
    }

    public <T> Line<T> nu(Class<T> iface, Object... values) {
        return nuer.nu(iface, values);
    }

    public <T> Line<T> provider(Class<? extends Provider<T>> provider) {
        return providerer.provider(provider);
    }

    public <T> Line<T> provider(Provider<T> provider) {
        return providerer.provider(provider);
    }

    public <T> Line<T> impl(Class<T> impl, Object... params) {
        return impler.impl(impl, params);
    }

    public <T> Line<T> resolve(Class<T> type) {
        // FIX 3324 Mar 17, 2009 Should we just call .to(type).
        return resolverer.resolve(type);
    }

    public <T> Line<T> spider(Class<T> type, Spider spider) {
        return spiderer.spider(type, spider);
    }
}
