package au.net.netstorm.boost.spider.api.runtime;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.BindingWirer;
import au.net.netstorm.boost.spider.core.injection.types.DefaultInjectionTypeWirer;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.core.injection.types.InjectionTypeWirer;
import au.net.netstorm.boost.spider.internals.entry.Grapher;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;
import au.net.netstorm.boost.spider.plugs.provider.supplied.DefaultImplProviderWirer;
import au.net.netstorm.boost.spider.plugs.provider.supplied.ImplProviderWirer;

public class DefaultImpl implements Impl {
    InjectionTypeWirer typer = new DefaultInjectionTypeWirer();
    ImplProviderWirer impls = new DefaultImplProviderWirer();
    BindingWirer wirer;
    Grapher grapher;

    public <T> T impl(Class<T> cls, Object... args) {
        InjectionType<T> type = typer.build(cls);
        Provider provider = impls.nu(cls);
        Binding binding = wirer.nu(type, provider);
        return grapher.graph(type, binding, args);
    }
}
