package au.net.netstorm.boost.spider.api.runtime;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.BindingWirer;
import au.net.netstorm.boost.spider.core.injection.types.DefaultInjectionTypeWirer;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.core.injection.types.InjectionTypeWirer;
import au.net.netstorm.boost.spider.internals.bindings.constraints.AnyBindingConstraint;
import au.net.netstorm.boost.spider.internals.entry.Grapher;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;
import au.net.netstorm.boost.spider.plugs.provider.supplied.InjectableInstanceProvider;

public class DefaultInjector implements Injector {
    InjectionTypeWirer typer = new DefaultInjectionTypeWirer();
    AnyBindingConstraint any = new AnyBindingConstraint();
    BindingWirer bindings;
    Grapher grapher;

    public void inject(Object ref) {
        Class<?> cls = ref.getClass();
        InjectionType type = typer.build(cls);
        Provider provider = new InjectableInstanceProvider(ref);
        Binding binding = bindings.nu(type, provider);
        grapher.graph(type, binding);
    }
}
