package au.net.netstorm.boost.spider.core.binding;

import au.net.netstorm.boost.gunge.lazy.DefaultLazy;
import au.net.netstorm.boost.gunge.lazy.Lazy;
import au.net.netstorm.boost.gunge.lazy.LazyCreator;
import au.net.netstorm.boost.spider.internals.bindings.core.GraphLazyCreator;
import au.net.netstorm.boost.spider.internals.graph.builder.GraphBuilder;
import au.net.netstorm.boost.spider.internals.graph.core.Graph;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DefaultBinding implements Binding {
    Lazy<Graph> graph;
    Pattern pattern;
    Provider provider;

    public DefaultBinding(GraphBuilder builder, Pattern pattern, Provider provider) {
        this.pattern = pattern;
        this.provider = provider;
        this.graph = lazy(builder);
    }

    public Pattern pattern() {
        return pattern;
    }

    public Provider provider() {
        return provider;
    }

    public Graph graph() {
        return graph.get();
    }

    private Lazy<Graph> lazy(GraphBuilder builder) {
        LazyCreator<Graph> creator = new GraphLazyCreator(builder, this);
        return new DefaultLazy<Graph>(creator);
    }
}
