package au.net.netstorm.boost.spider.core.binding;

import au.net.netstorm.boost.gunge.optional.NotSetOptional;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.gunge.optional.SetOptional;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.internals.bindings.core.BindingWirerFu;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DefaultBindingWirer implements BindingWirer {
    Optional star = new NotSetOptional();
    BindingWirerFu fu;

    public Binding nu(InjectionType type, Provider p) {
        return nu(type, p, star, star);
    }

    public Binding nu(InjectionType type, Class host, Provider p) {
        return nu(type, p, set(host), star);
    }

    public Binding nu(InjectionType type, String name, Provider p) {
        return nu(type, p, star, set(name));
    }

    public Binding nu(InjectionType type, Class host, String name, Provider p) {
        return nu(type, p, set(host), set(name));
    }

    private Binding nu(InjectionType type, Provider p, Optional<Class> host, Optional<String> name) {
        Pattern pattern = new DefaultPattern(type, host, name);
        return fu.nu(pattern, p);
    }

    private <T> Optional<T> set(T t) {
        return new SetOptional(t);
    }
}