package au.net.netstorm.boost.spider.core.binding;

import au.net.netstorm.boost.bullet.primordial.Primordial;
import au.net.netstorm.boost.gunge.equals.DefaultEqualsConstraints;
import au.net.netstorm.boost.gunge.equals.EqualsConstraints;
import au.net.netstorm.boost.gunge.hash.DefaultHasher;
import au.net.netstorm.boost.gunge.hash.Hasher;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

public final class DefaultPattern<T> extends Primordial implements Pattern<T> {
    InjectionType<T> type;
    Optional<String> name;
    Optional<Class> host;

    public DefaultPattern(InjectionType<T> type, Optional<Class> host, Optional<String> name) {
        this.type = type;
        this.name = name;
        this.host = host;
    }

    public InjectionType type() {
        return type;
    }

    public Optional<Class> host() {
        return host;
    }

    public Optional<String> name() {
        return name;
    }

    public int hashCode() {
        int hash = 0;
        hash = hasher.hash(hash, host);
        hash = hasher.hash(hash, name);
        hash = hasher.hash(hash, type);
        return hash;
    }

    public boolean equals(Object o) {
        if (!constraints.ok(this, o)) return false;
        Pattern other = (Pattern) o;
        return type.equals(other.type())
                && name.equals(other.name())
                && host.equals(other.host());
    }

    private static final EqualsConstraints constraints = new DefaultEqualsConstraints();
    private static final Hasher hasher = new DefaultHasher();
}
