package au.net.netstorm.boost.spider.core.binding;

import au.net.netstorm.boost.gunge.optional.NotSetOptional;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.gunge.optional.SetOptional;
import au.net.netstorm.boost.spider.core.injection.types.DefaultInjectionTypeWirer;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.core.injection.types.InjectionTypeWirer;

public class DefaultPatterns implements Patterns {
    InjectionTypeWirer types = new DefaultInjectionTypeWirer();
    Optional not = new NotSetOptional();

    public Pattern pattern(Class type, Class host, String name) {
        return nu(type, set(host), set(name));
    }

    public Pattern pattern(Class type, Class host) {
        return nu(type, set(host), not);
    }

    public Pattern pattern(Class type, String name) {
        return nu(type, not, set(name));
    }

    public Pattern pattern(Class type) {
        return nu(type, not, not);
    }

    private Pattern nu(Class type, Optional<Class> host, Optional<String> name) {
        InjectionType t = types.build(type);
        return new DefaultPattern(t, host, name);
    }

    private <T> Optional<T> set(T t) {
        return new SetOptional(t);
    }
}
