package au.net.netstorm.boost.spider.core.injection.sites;

import au.net.netstorm.boost.bullet.primordial.Primordial;
import au.net.netstorm.boost.gunge.hash.DefaultHasher;
import au.net.netstorm.boost.gunge.hash.Hasher;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

// FIX 1596 Dec 22, 2008 Consider custom to string for this. It is pivitol to everything.
public class DefaultInjectionSite extends Primordial implements InjectionSite {
    InjectionType type;
    String name;
    Class host;

    public DefaultInjectionSite(InjectionType type, Class host, String name) {
        this.type = type;
        this.host = host;
        this.name = name;
    }

    public InjectionType type() {
        return type;
    }

    public Class host() {
        return host;
    }

    public String name() {
        return name;
    }

    public boolean equals(Object o) {
        return equals.equals(this, o);
    }

    public int hashCode() {
        int hash = 0;
        hash = hasher.hash(hash, host);
        hash = hasher.hash(hash, type);
        hash = hasher.hash(hash, name);
        return hash;
    }

    private static final InjectionSiteEquals equals = new DefaultInjectionSiteEquals();
    private static final Hasher hasher = new DefaultHasher();
}
