package au.net.netstorm.boost.spider.core.injection.sites;

import au.net.netstorm.boost.gunge.equals.DefaultEqualsConstraints;
import au.net.netstorm.boost.gunge.equals.EqualsConstraints;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

public class DefaultInjectionSiteEquals implements InjectionSiteEquals {
    EqualsConstraints constraints = new DefaultEqualsConstraints();

    public boolean equals(InjectionSite one, Object two) {
        if (!constraints.ok(one, two)) return false;
        InjectionSite thing = (InjectionSite) two;
        return equals(one, thing);
    }

    public boolean equals(InjectionSite one, InjectionSite two) {
        return type(one, two) && host(one, two) && name(one, two);
    }

    private boolean type(InjectionSite one, InjectionSite two) {
        InjectionType a = one.type();
        InjectionType b = two.type();
        return eq(a, b);
    }

    private boolean name(InjectionSite one, InjectionSite two) {
        String a = one.name();
        String b = two.name();
        return eq(a, b);
    }

    private boolean host(InjectionSite one, InjectionSite two) {
        Class a = one.host();
        Class b = two.host();
        return eq(a, b);
    }

    private boolean eq(Object one, Object two) {
        return one.equals(two);
    }
}
