package au.net.netstorm.boost.spider.core.injection.sites;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.List;
import au.net.netstorm.boost.gunge.reflect.field.DefaultFields;
import au.net.netstorm.boost.gunge.reflect.field.DefaultResolvableFieldMaster;
import au.net.netstorm.boost.gunge.reflect.field.Fields;
import au.net.netstorm.boost.gunge.reflect.field.ResolvableFieldMaster;
import au.net.netstorm.boost.spider.internals.graph.scope.Scope;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DefaultInjectionSiteLocator implements InjectionSiteLocator {
    private final ResolvableFieldMaster resolvable = new DefaultResolvableFieldMaster();
    private final InjectionSiteWirer wirer = new DefaultInjectionSiteWirer();
    private final Fields fields = new DefaultFields();
    private final Scope scope;

    public DefaultInjectionSiteLocator(Scope scope) {
        this.scope = scope;
    }

    public List<InjectionSite> sites(Provider provider) {
        Class<?> target = provider.target();
        return sites(target);
    }

    // FIX 3324 Mar 16, 2009 Can be "private".
    public List<InjectionSite> sites(Class target) {
        List<InjectionSite> sites = new ArrayList<InjectionSite>();
        for (Field f : fields.fields(target))
            if (ok(f)) add(sites, f);
        return sites;
    }

    private boolean ok(Field f) {
        Class host = f.getDeclaringClass();
        // FIX 1596 Jan 9, 2009 Consider returning a 'NonResolvableInjectionsSite' instead of dropping out of scopes.
        return resolvable.isResolvableField(f) && scope.in(host);
    }

    private void add(List<InjectionSite> sites, Field f) {
        InjectionSite site = wirer.fields(f);
        sites.add(site);
    }
}
