package au.net.netstorm.boost.spider.core.injection.sites;

import java.lang.reflect.Field;
import java.lang.reflect.Type;
import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.DefaultPatternGrounder;
import au.net.netstorm.boost.spider.core.binding.Pattern;
import au.net.netstorm.boost.spider.core.binding.PatternGrounder;
import au.net.netstorm.boost.spider.core.injection.types.DefaultInjectionTypeWirer;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.core.injection.types.InjectionTypeWirer;

public class DefaultInjectionSiteWirer implements InjectionSiteWirer {
    InjectionTypeWirer types = new DefaultInjectionTypeWirer();
    PatternGrounder grounder = new DefaultPatternGrounder();

    public InjectionSite root(InjectionType type) {
        return new DefaultInjectionSite(type, NoHost.class, "");
    }

    public InjectionSite root(Binding binding) {
        Pattern pattern = binding.pattern();
        return grounder.ground(pattern);
    }

    public InjectionSite fields(Field field) {
        Class host = host(field);
        InjectionType type = type(field);
        String name = name(field);
        return new DefaultInjectionSite(type, host, name);
    }

    public InjectionSite[] constructors(Class raw, Type[] reified) {
        InjectionSite[] sites = new InjectionSite[reified.length];
        for (int i = 0; i < reified.length; ++i) {
            sites[i] = site(raw, reified, i);
        }
        return sites;
    }

    private InjectionSite site(Class<?> host, Type[] reified, int i) {
        InjectionType type = types.build(reified[i]);
        String name = "" + i;
        return new DefaultInjectionSite(type, host, name);
    }

    private InjectionType type(Field field) {
        Type reified = field.getGenericType();
        return types.build(reified);
    }

    private String name(Field field) {
        return field.getName();
    }

    private Class host(Field field) {
        return field.getDeclaringClass();
    }
}
