package au.net.netstorm.boost.spider.internals.aspects;

import au.net.netstorm.boost.bullet.primordial.Primordial;
import au.net.netstorm.boost.gunge.layer.Layer;
import au.net.netstorm.boost.gunge.type.Implementation;
import au.net.netstorm.boost.gunge.type.Interface;

public class DefaultAspect extends Primordial implements Aspect {
    private final Implementation impl;
    private final Interface[] ifaces;
    private final Class<? extends Layer>[] layers;

    public DefaultAspect(Implementation impl, Interface[] ifaces, Class<? extends Layer>[] layers) {
        this.impl = impl;
        this.ifaces = ifaces;
        this.layers = layers;
    }

    public Implementation impl() {
        return impl;
    }

    public Interface[] interfaces() {
        return ifaces;
    }

    public Class<? extends Layer>[] layers() {
        return layers;
    }

    public boolean hasLayers() {
        return layers.length != 0;
    }
}
