package au.net.netstorm.boost.spider.internals.bindings.core;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.Pattern;

public class DefaultBindingSet implements BindingSet {
    private final Map<Pattern, Binding> unique = new HashMap();
    private final Comparator<Binding> precedence = new BindingComparator();
    private List<Binding> sorted = new ArrayList();

    public void add(Binding binding) {
        Pattern pattern = binding.pattern();
        unique.put(pattern, binding);
        sort();
    }

    public List<Binding> sorted() {
        return sorted;
    }

    private void sort() {
        Collection<Binding> unsorted = unique.values();
        sorted = new ArrayList(unsorted);
        Collections.sort(sorted, precedence);
    }
}
