package au.net.netstorm.boost.spider.internals.bindings.core;

import java.util.List;
import au.net.netstorm.boost.bullet.primordial.Primordial;
import au.net.netstorm.boost.gunge.collection.Creator;
import au.net.netstorm.boost.gunge.collection.DefaultIntegrityMap;
import au.net.netstorm.boost.gunge.collection.IntegrityMap;
import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.Pattern;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

public class DefaultBindingsGu extends Primordial implements BindingsGu {
    private final IntegrityMap<InjectionType, BindingSet> bindings = new DefaultIntegrityMap();
    private final Creator<InjectionType, BindingSet> creator = new BindingSetCreator();

    public List<Binding> lookup(InjectionType type) {
        BindingSet set = get(type);
        return set.sorted();
    }

    public void add(Binding binding) {
        Pattern pattern = binding.pattern();
        InjectionType type = pattern.type();
        BindingSet set = get(type);
        set.add(binding);
    }

    private BindingSet get(InjectionType type) {
        return bindings.get(type, creator);
    }
}
