package au.net.netstorm.boost.spider.internals.bindings.core;

import au.net.netstorm.boost.gunge.collection.Function;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.spider.core.binding.Pattern;
import static au.net.netstorm.boost.spider.internals.bindings.core.Precedence.HOSTED;
import static au.net.netstorm.boost.spider.internals.bindings.core.Precedence.HOSTED_AND_NAMED;
import static au.net.netstorm.boost.spider.internals.bindings.core.Precedence.RAW;

public final class PatternToPrecedence implements Function<Pattern, Precedence> {
    public Precedence apply(Pattern p) {
        Optional host = p.host();
        Optional name = p.name();
        return precedence(host, name);
    }

    // DEBT CyclomaticComplexity {
    private Precedence precedence(Optional host, Optional name) {
        if (host.isSet() && name.isSet()) return HOSTED_AND_NAMED;
        if (host.isSet()) return HOSTED;
        if (name.isSet()) return HOSTED;
        return RAW;
    }
    // } DEBT CyclomaticComplexity
}
