package au.net.netstorm.boost.spider.internals.bindings.resolver;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.internals.bindings.core.Bindings;
import au.net.netstorm.boost.spider.plugs.connectrex.core.Connectrex;
import au.net.netstorm.boost.spider.plugs.connectrex.core.Connectrexes;

public final class DefaultBindingResolver implements BindingResolver {
    Connectrexes connectrexes;
    Bindings bindings;

    public Binding resolve(InjectionSite site) {
        Connectrex c = connectrexes.find(site);
        Binding binding = c.nu(site);
        // Must add binding to list if it's a SingleProvider.
        // Actually, we can't really tell if it's single.  Any provider could really be single.
        bindings.add(binding);
        return binding;
    }

    public boolean can(InjectionSite site) {
        return connectrexes.can(site);
    }
}
