package au.net.netstorm.boost.spider.internals.bootstrap.build;

import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassNames;
import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.BindingWirer;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.sites.NoHost;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.internals.bootstrap.mini.MiniSpider;
import au.net.netstorm.boost.spider.plugs.connectrex.core.Connectrex;

// FIX 3324 Mar 13, 2009 Use or lose.
public class BootstrapConnectrex implements Connectrex {
    ClassNames names = new DefaultClassNames();
    BindingWirer wirer;
    MiniSpider mini;
    WhiteList white;

    public Binding nu(InjectionSite site) {
        InjectionType type = site.type();
        BootstrapProvider p = new BootstrapProvider();
        //
        p.mini = mini;
        p.site = site;
        //
        // FIX 3324 Mar 18, 2009 Collapse.  Should be site - pattern utility.
        return wirer.nu(type, p);
    }

    public boolean can(InjectionSite site) {
        if (whitelist(site)) return true;
        if (root(site)) return false;
        //
        //
        if (appropriate(site)) return true;
        return false;
    }

    private boolean root(InjectionSite site) {
        Class host = site.host();
        return host.equals(NoHost.class);
    }

    private boolean appropriate(InjectionSite site) {
        boolean from = from(site);
        boolean host = host(site);
        return from && host;
    }

    private boolean whitelist(InjectionSite site) {
        Class cls = cls(site);
        return white.in(cls);
    }

    private Class cls(InjectionSite site) {
        InjectionType type = site.type();
        return type.rawClass();
    }

    // FIX 3324 Mar 18, 2009 Name.
    private boolean host(InjectionSite site) {
        Class cls = site.host();
        return in(cls);
    }

    private boolean from(InjectionSite site) {
        Class cls = cls(site);
        return in(cls);
    }

    private boolean in(Class cls) {
        return names.in("au.net.netstorm.boost.spider", cls);
    }
}
