package au.net.netstorm.boost.spider.internals.bootstrap.build;

import au.net.netstorm.boost.gunge.optional.NotSetOptional;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.gunge.optional.SetOptional;
import au.net.netstorm.boost.spider.api.runtime.Spider;

public class DefaultFutureSpider implements FutureSpider {
    private Optional<Spider> spider = new NotSetOptional<Spider>();

    public <T> T nu(Class<T> iface, Object... values) {
        return delegate().nu(iface, values);
    }

    public void inject(Object ref) {
        delegate().inject(ref);
    }

    public <T> T resolve(Class<T> type) {
        return delegate().resolve(type);
    }

    public <T> T impl(Class<T> impl, Object... params) {
        return delegate().impl(impl, params);
    }

    public void set(Spider spider) {
        this.spider = new SetOptional(spider);
    }

    private Spider delegate() {
        if (!spider.isSet()) throw new IllegalStateException("Future spider is not ready. Patience please.");
        return spider.get();
    }
}
