package au.net.netstorm.boost.spider.internals.bootstrap.mini;

import java.lang.reflect.Field;

public final class DefaultMiniFerret implements MiniFerret {
    final MiniRegistry registry;

    public DefaultMiniFerret(MiniRegistry registry) {
        this.registry = registry;
    }

    public Class impl(Field f) {
        Class type = f.getType();
        Class host = f.getDeclaringClass();
        String name = f.getName();
        return registry(type, host, name);
    }

    private Class registry(Class type, Class host, String name) {
        if (registry.contains(type, host, name))
            return registry.get(type, host, name);
        if (registry.contains(type, host))
            return registry.get(type, host);
        return null;
    }
}
