package au.net.netstorm.boost.spider.internals.bootstrap.mini;

import au.net.netstorm.boost.gunge.collection.DefaultStrictMap;
import au.net.netstorm.boost.gunge.collection.StrictMap;
import au.net.netstorm.boost.gunge.type.DefaultInterface;
import au.net.netstorm.boost.gunge.type.Interface;

public final class DefaultMiniRefs implements MiniRefs {
    MiniInterfacer ifacer = new DefaultMiniInterfacer();
    StrictMap<Interface, Object> refs = new DefaultStrictMap<Interface, Object>();

    public void add(Object... refs) {
        for (Object ref : refs) add(ref);
    }

    public <T> boolean contains(Class<T> type) {
        Interface iface = new DefaultInterface(type);
        return refs.exists(iface);
    }

    public <T> T get(Class<T> type) {
        Interface iface = new DefaultInterface(type);
        Object r = refs.get(iface);
        return type.cast(r);
    }

    private void add(Object ref) {
        Interface iface = ifacer.iface(ref);
        refs.put(iface, ref);
    }
}
