package au.net.netstorm.boost.spider.internals.bootstrap.mini;

import java.util.ArrayList;
import java.util.List;
import au.net.netstorm.boost.gunge.collection.DefaultStrictMap;
import au.net.netstorm.boost.gunge.collection.StrictMap;

// FIX 3324 Mar 16, 2009 Should use Pattern and Patterns.
public final class DefaultMiniRegistry implements MiniRegistry {
    StrictMap<List, Class> registry = new DefaultStrictMap();

    public <T> void add(Class<T> iface, Class<? extends T> impl) {
        add(iface, impl, null);
    }

    public <T> void add(Class<T> iface, Class<? extends T> impl, Class host) {
        add(iface, impl, host, null);
    }

    public <T> void add(Class<T> iface, Class<? extends T> impl, Class host, String name) {
        List key = key(iface, host, name);
        registry.put(key, impl);
    }

    public <T> boolean contains(Class<T> iface) {
        return contains(iface, null);
    }

    public <T> boolean contains(Class<T> iface, Class host) {
        return contains(iface, host, null);
    }

    public <T> boolean contains(Class<T> iface, Class host, String name) {
        List key = key(iface, host, name);
        return registry.exists(key);
    }

    public <T> Class<? extends T> get(Class<T> iface) {
        return get(iface, null);
    }

    public <T> Class<? extends T> get(Class<T> iface, Class host) {
        return get(iface, host, null);
    }

    public <T> Class<? extends T> get(Class<T> iface, Class host, String name) {
        List key = key(iface, host, name);
        return registry.get(key);
    }

    private <T> List key(Class<T> iface, Class host, String name) {
        List tuple = new ArrayList();
        tuple.add(iface);
        tuple.add(host);
        tuple.add(name);
        return tuple;
    }
}
