package au.net.netstorm.boost.spider.internals.bootstrap.mini;

import java.lang.reflect.Field;
import au.net.netstorm.boost.gunge.reflect.cls.ClassMorpher;
import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassMorpher;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassNames;
import au.net.netstorm.boost.gunge.reflect.field.DefaultResolvableFieldFinder;
import au.net.netstorm.boost.gunge.reflect.field.ResolvableFieldFinder;
import au.net.netstorm.boost.gunge.reflect.instantiate.Instantiator;
import au.net.netstorm.boost.gunge.reflect.instantiate.SingleInstantiator;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.DefaultEdgeField;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.EdgeField;
// DEBT GenericIllegalRegexp|NCSS {
// FIX 3324 Mar 18, 2009 Love me.  I need it.
// FIX 3324 Mar 18, 2009 Make sure this ONLY resolve things in boost.spider, boost.gunge and other authorised

// FIX 3324 Mar 18, 2009 LOW LEVEL things.
public final class DefaultMiniSpider implements MiniSpider {
    String pkg = "au.net.netstorm.boost.spider";
    ResolvableFieldFinder finder = new DefaultResolvableFieldFinder();
    Instantiator instantiator = new SingleInstantiator();
    ClassMorpher morpher = new DefaultClassMorpher();
    EdgeField fielder = new DefaultEdgeField();
    ClassNames names = new DefaultClassNames();
    final MiniRegistry registry;
    final MiniFerret ferret;
    final MiniRefs refs;
    //
    private int indent = 0;

    public DefaultMiniSpider(MiniRefs refs, MiniRegistry registry) {
        this.refs = refs;
        this.registry = registry;
        this.ferret = new DefaultMiniFerret(registry);
        refs.add(this);
    }

    public <T> T resolve(Class<T> type) {
        indent++;
        log("r", type);
        T t = xx(type);
        indent--;
        return t;
    }

    private <T> T nu(Class<? extends T> iface, Class<? extends T> impl) {
        if (!names.in(pkg, impl)) throw new IllegalStateException("Can only spin within " + pkg + " for " + impl);
        indent++;
        log("i", impl);
        T ref = instantiator.instantiate(impl);
        if (!refs.contains(iface)) refs.add(ref);
        Field[] fields = finder.find(ref);
        for (Field f : fields) inject(ref, f);
        indent--;
        return ref;
    }

    private void log(String s, Class impl) {
//        String c = names.shorty(impl);
//        for (int i = 0; i < indent; i++) System.out.print(" ");
//        System.out.print(f());
//        System.out.print(" ");
//        System.out.print(s);
//        System.out.print(" ");
//        System.out.println(c);
    }

    private <T> T xx(Class<T> type) {
        return refs.contains(type) ? refs.get(type) : build(type);
    }

    private <T> void inject(T ref, Field f) {
        Object o = create(f);
        fielder.set(f, ref, o);
    }

    private Object create(Field f) {
        Class impl = ferret.impl(f);
        if (impl == null) return resolve(f);
        Class iface = f.getType();
        return nu(iface, impl);
    }

    private <T> T build(Class<T> type) {
        Class<? extends T> impl = registry.contains(type) ? registry.get(type) : morpher.add("Default", type);
        return nu(type, impl);
    }

    private Object resolve(Field f) {
        Class type = f.getType();
        return resolve(type);
    }
}
// } DEBT GenericIllegalRegexp|NCSS