package au.net.netstorm.boost.spider.internals.entry;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.injection.sites.DefaultInjectionSiteWirer;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSiteWirer;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.internals.bindings.resolver.BindingResolver;

public class DefaultGrapher implements Grapher {
    InjectionSiteWirer sites = new DefaultInjectionSiteWirer();
    BindingResolver resolver;
    GrapherFu fu;

    public <T> T graph(InjectionType<T> type, Object... args) {
        // FIX 1205 Consider guarding against incorrectly implemented providers.
        // FIX 1205 Blow up if same root type is passed to this guy in a loop.
        InjectionSite root = sites.root(type);
        Binding binding = resolver.resolve(root);
        return graph(type, binding, args);
    }

    public <T> T graph(InjectionType<T> type, Binding binding, Object... args) {
        return fu.graph(type, binding, args);
    }
}
