package au.net.netstorm.boost.spider.internals.entry;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.internals.graph.core.Graph;
import au.net.netstorm.boost.spider.internals.graph.instantiate.GraphInstantiator;
import au.net.netstorm.boost.spider.internals.graph.instantiate.GraphInstantiatorWirer;

public class DefaultGrapherFu implements GrapherFu {
    GraphInstantiatorWirer wirer;

    public <T> T graph(InjectionType<T> type, Binding binding, Object... args) {
        Graph graph = binding.graph();
        Object instance = resolve(graph, args);
        return cast(type, instance);
    }

    private Object resolve(Graph graph, Object... args) {
        GraphInstantiator instantiator = wirer.nu();
        return instantiator.resolve(graph, args);
    }

    private <T> T cast(InjectionType<T> type, Object instance) {
        Class<T> cls = type.rawClass();
        return cls.cast(instance);
    }
}
