package au.net.netstorm.boost.spider.internals.errors;

import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
import au.net.netstorm.boost.gunge.optional.NotSetOptional;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.gunge.optional.SetOptional;
import au.net.netstorm.boost.spider.internals.graph.core.Node;

public class DefaultCogs implements Cogs {
    private List<Cog> cogs = new ArrayList();
    private Stack<Node> current = new Stack<Node>();

    public void instantiating(Node node) {
        current.push(node);
    }

    public void got(Object ref) {
        add(ref);
    }

    public List<Cog> data() {
        tieoff();
        return cogs;
    }

    private void tieoff() {
        if (current.empty()) return;
        Optional notset = new NotSetOptional();
        add(notset);
    }

    private void add(Optional optional) {
        Node node = current.pop();
        Cog cog = new DefaultCog(node, optional);
        cogs.add(cog);
    }

    private void add(Object ref) {
        SetOptional set = new SetOptional(ref);
        add(set);
    }
}
