package au.net.netstorm.boost.spider.internals.errors;

import java.util.List;
import au.net.netstorm.boost.gunge.exception.DefaultThrowableMaster;
import au.net.netstorm.boost.gunge.exception.ThrowableMaster;
import au.net.netstorm.boost.spider.api.bang.SpiderException;
import au.net.netstorm.boost.spider.internals.log.DefaultGraphSpewer;
import au.net.netstorm.boost.spider.internals.log.GraphSpewer;

public class DefaultHandler implements Handler {
    ThrowableMaster thrower = new DefaultThrowableMaster();
    ErrorInstantiationProbe probe;

    // FIX 1437 Dec 12, 2008 Complete.
    public void handle(Exception e) {
        String msg = message();
        throw new SpiderException(msg, e);
    }

    private String message() {
        // FIX 1437 Dec 22, 2008 Add support for specific error messages as well as graph.
        // FIX 1437 Dec 22, 2008 i.e. it blew up because.... and here is the graph....
        return graph();
    }

    private String graph() {
        Cogs cogs = probe.get();
        GraphSpewer spewer = new DefaultGraphSpewer();
        List<Cog> list = cogs.data();
        return "\n" + spewer.chunder(list);
    }
}
