package au.net.netstorm.boost.spider.internals.graph.builder;

import java.lang.reflect.Type;
import au.net.netstorm.boost.spider.core.injection.sites.DefaultInjectionSiteWirer;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSiteWirer;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.internals.graph.scope.Scope;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;
import au.net.netstorm.boost.spider.plugs.provider.supplied.Argumentor;
import au.net.netstorm.boost.spider.plugs.provider.supplied.DefaultArgumentor;

public class ConstructorWalker implements Walker {
    InjectionSiteWirer sites = new DefaultInjectionSiteWirer();
    Argumentor argumentor = new DefaultArgumentor();
    InjectionSite[] none = new InjectionSite[0];
    Walker ascender;
    Scope scope;

    public ConstructorWalker(Walker ascender, Scope scope) {
        this.ascender = ascender;
        this.scope = scope;
    }

    public void walk(Node node, InjectionSite site, Provider provider) {
        InjectionSite[] sites = constructors(provider);
        for (InjectionSite arg : sites) {
            ascender.walk(node, arg, provider);
        }
    }

    public InjectionSite[] constructors(Provider provider) {
        if (!provider.constructable()) return none;
        Class<?> target = provider.target();
        if (!scope.in(target)) return none;
        Type[] types = argumentor.types(target);
        return sites.constructors(target, types);
    }
}
