package au.net.netstorm.boost.spider.internals.graph.builder;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.Pattern;
import au.net.netstorm.boost.spider.core.injection.sites.DefaultInjectionSiteWirer;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSiteWirer;
import au.net.netstorm.boost.spider.internals.graph.core.DefaultGraph;
import au.net.netstorm.boost.spider.internals.graph.core.DefaultNode;
import au.net.netstorm.boost.spider.internals.graph.core.Graph;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DefaultGraphBuilder implements GraphBuilder {
    private final InjectionSiteWirer sites = new DefaultInjectionSiteWirer();
    WalkerWirer wirer;

    public Graph graph(Binding binding) {
        check(binding);
        InjectionSite site = sites.root(binding);
        Provider provider = binding.provider();
        Node root = root(site, provider, binding);
        Graph graph = new DefaultGraph(root);
        Walker walker = wirer.nu(graph);
        walker.walk(root, site, provider);
        return graph;
    }

    // FIX 3082 Feb 18, 2009 Remove this later.
    private void check(Binding binding) {
        Pattern pattern = binding.pattern();
        if (pattern.host().isSet()) throw new IllegalStateException();
        if (pattern.name().isSet()) throw new IllegalStateException();
    }

    private Node root(InjectionSite site, Provider provider, Binding binding) {
        Node root = new DefaultNode(site);
        root.setProvider(provider);
        root.setBinding(binding);
        return root;
    }
}
