package au.net.netstorm.boost.spider.internals.graph.builder;

import au.net.netstorm.boost.gunge.recursion.DefaultGuard;
import au.net.netstorm.boost.gunge.recursion.Guard;
import au.net.netstorm.boost.spider.core.injection.sites.DefaultInjectionSiteLocator;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSiteLocator;
import au.net.netstorm.boost.spider.internals.bindings.resolver.BindingResolver;
import au.net.netstorm.boost.spider.internals.graph.core.Graph;
import au.net.netstorm.boost.spider.internals.graph.scope.Scope;
import au.net.netstorm.boost.spider.internals.probe.Probe;

// OK ClassDataAbstractionCoupling {
public class DefaultWalkerWirer implements WalkerWirer {
    Guard<InjectionSite> guard = new DefaultGuard<InjectionSite>();
    BindingResolver resolver;
    // FIX 3324 Mar 10, 2009 Was WalkingProbe.  More specific.
    Probe probe;
    Scope scope;

    public Walker nu(Graph graph) {
        FutureWalker future = new DefaultFutureWalker();
        Walker root = nu(graph, future);
        future.set(root);
        return root;
    }

    private Walker nu(Graph graph, FutureWalker future) {
        Walker constructor = constructor(graph, future);
        Walker field = field(graph, future);
        Walker walker = new DefaultWalker(constructor, field);
        return new ProbingWalker(walker, probe);
    }

    private Walker constructor(Graph graph, FutureWalker future) {
        Linker dependency = new DependencyLinker(graph);
        Walker guarded = guarded(future, dependency);
        return new ConstructorWalker(guarded, scope);
    }

    private Walker field(Graph graph, FutureWalker future) {
        InjectionSiteLocator locator = new DefaultInjectionSiteLocator(scope);
        Linker child = new ChildLinker(graph);
        Walker guarded = guarded(future, child);
        return new FieldWalker(guarded, locator);
    }

    private Walker guarded(FutureWalker future, Linker linker) {
        Walker descending = new DescendingWalker(future, resolver);
        return new GuardedWalker(descending, guard, linker);
    }
}
// } OK ClassDataAbstractionCoupling