package au.net.netstorm.boost.spider.internals.graph.builder;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.internals.bindings.resolver.BindingResolver;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DescendingWalker implements Walker {
    BindingResolver resolver;
    Walker engine;

    public DescendingWalker(Walker engine, BindingResolver resolver) {
        this.engine = engine;
        this.resolver = resolver;
    }

    public void walk(Node child, InjectionSite site, Provider old) {
        if (child.hasProvider()) return;
        if (!resolver.can(site)) return;
        Provider provider = provide(site, child);
        engine.walk(child, site, provider);
    }

    private Provider provide(InjectionSite site, Node child) {
        // FIX 3324 Mar 17, 2009 Does this trigger Config->Runtime?  For a given Binding/Pattern.
        Binding binding = resolver.resolve(site);
        Provider provider = binding.provider();
        child.setProvider(provider);
        child.setBinding(binding);
        return provider;
    }
}