package au.net.netstorm.boost.spider.internals.graph.builder;

import java.util.List;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSiteLocator;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class FieldWalker implements Walker {
    private final InjectionSiteLocator locator;
    private final Walker descender;

    public FieldWalker(Walker descender, InjectionSiteLocator locator) {
        this.descender = descender;
        this.locator = locator;
    }

    public void walk(Node node, InjectionSite site, Provider provider) {
        if (!provider.injectable()) return;
        List<InjectionSite> sites = locator.sites(provider);
        for (InjectionSite field : sites) {
            descender.walk(node, field, provider);
        }
    }
}
