package au.net.netstorm.boost.spider.internals.graph.builder;

import au.net.netstorm.boost.gunge.recursion.Guard;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class GuardedWalker implements Walker {
    Guard<InjectionSite> guard;
    Linker linker;
    Walker engine;

    public GuardedWalker(Walker engine, Guard<InjectionSite> guard, Linker linker) {
        this.engine = engine;
        this.guard = guard;
        this.linker = linker;
    }

    public void walk(Node parent, InjectionSite site, Provider old) {
        Node child = linker.link(parent, site);
        guard(child, site, old);
    }

    private void guard(Node child, InjectionSite site, Provider old) {
        guard.push();
        try {
            if (guard.guard(site)) return;
            engine.walk(child, site, old);
        } finally {
            guard.pop();
        }
    }
}
