package au.net.netstorm.boost.spider.internals.graph.core;

import java.util.HashMap;
import java.util.Map;
import au.net.netstorm.boost.bullet.primordial.Primordial;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;

public class DefaultGraph extends Primordial implements Graph {
    private final Map<InjectionSite, Node> nodes = new HashMap<InjectionSite, Node>();
    private final Node root;

    public DefaultGraph(Node root) {
        this.root = root;
    }

    public Node root() {
        return root;
    }

    public Node get(InjectionSite site) {
        return nodes.containsKey(site) ? nodes.get(site) : create(site);
    }

    private Node create(InjectionSite site) {
        Node child = new DefaultNode(site);
        nodes.put(site, child);
        return child;
    }
}
