package au.net.netstorm.boost.spider.internals.graph.instantiate;

import java.lang.reflect.Field;
import au.net.netstorm.boost.gunge.sledge.java.lang.DefaultEdgeClass;
import au.net.netstorm.boost.gunge.sledge.java.lang.EdgeClass;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.DefaultEdgeField;
import au.net.netstorm.boost.gunge.sledge.java.lang.reflect.EdgeField;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;

public class
        DefaultFieldInjector implements FieldInjector {
    private final EdgeClass classer = new DefaultEdgeClass();
    private final EdgeField fielder = new DefaultEdgeField();

    public void inject(InjectionSite site, Object ref, Object resolved) {
        Field field = field(site);
        inject(field, ref, resolved);
    }

    public boolean isWired(InjectionSite site, Object ref) {
        Field field = field(site);
        return isWired(field, ref);
    }

    private Field field(InjectionSite site) {
        Class host = site.host();
        String name = site.name();
        Field field = classer.getDeclaredField(host, name);
        field.setAccessible(true);
        return field;
    }

    private void inject(Field field, Object ref, Object resolved) {
        fielder.set(field, ref, resolved);
    }

    private boolean isWired(Field field, Object ref) {
        Object value = fielder.get(field, ref);
        return value != null;
    }
}
