package au.net.netstorm.boost.spider.internals.graph.instantiate;

import au.net.netstorm.boost.spider.internals.graph.core.Graph;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DefaultGraphInstantiator implements GraphInstantiator {
    private final GraphInstantiatorFu fu;

    public DefaultGraphInstantiator(GraphInstantiatorFu fu) {
        this.fu = fu;
    }

    public Object resolve(Graph graph, Object[] args) {
        Node node = graph.root();
        return args.length == 0 ? fu.resolve(node) : resolve(node, args);
    }

    private Object resolve(Node node, Object[] args) {
        Provider p = node.provider();
        Object plain = p.nu(args);
        return fu.resolve(node, plain);
    }
}
