package au.net.netstorm.boost.spider.internals.graph.instantiate;

import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.internals.graph.decorator.Decorator;
import au.net.netstorm.boost.spider.internals.graph.lifecycle.Constructables;

// DEBT ParameterNumber {
public class DefaultGraphInstantiatorFu implements GraphInstantiatorFu {
    Constructables constructables;
    Provisioner provisioner;
    Decorator decorator;
    Instances instances;
    Wirer wirer;

    // FIX 1596 Dec 10, 2008 Think about tidy/split of this. Think Gu.
    public DefaultGraphInstantiatorFu(
            Constructables constructables,
            Decorator decorator,
            Instances instances,
            Wirer wirer,
            Provisioner provisioner) {
        this.constructables = constructables;
        this.decorator = decorator;
        this.instances = instances;
        this.wirer = wirer;
        this.provisioner = provisioner;
    }
    /*
    * resolve(node)
    * 1.   if instances.contains(node): return instances.get(node)
    * 2.   dependencies = [resolve(d) for d in node.dependencies]
    * 3.   plain = node.provide(dependencies)
    * 4.   decorated = postprocess(plain)
    * 5.   instances.put(node, decorated)
    * 6.   children = [resolve(c) for c in node.children]
    * 7.   for c in children: inject(plain, c)
    * 8.   construct(plain) # pushes construction delayed until graph complete
    * 9.   instances.remove(node)
    *10.   return final
    */

    public Object resolve(Node node) {
        if (instances.exists(node)) return instances.get(node);
        Object plain = provisioner.provide(node);
        return resolve(node, plain);
    }

    public Object resolve(Node node, Object plain) {
        Object decorated = decorator.decorate(plain);
        instances.put(node, decorated);
        wirer.wire(node, plain);
        instances.remove(node);
        constructables.construct(plain);
        return decorated;
    }
}
// } DEBT ParameterNumber