package au.net.netstorm.boost.spider.internals.graph.instantiate;

import java.util.ArrayList;
import java.util.List;
import au.net.netstorm.boost.spider.internals.graph.core.DefaultInstance;
import au.net.netstorm.boost.spider.internals.graph.core.Instance;
import au.net.netstorm.boost.spider.internals.graph.core.Node;

public class DefaultInstanceCollector implements InstanceCollector {
    private final GraphInstantiatorFu resolver;

    public DefaultInstanceCollector(GraphInstantiatorFu resolver) {
        this.resolver = resolver;
    }

    public List<Instance> collect(List<Node> nodes, NodeFilter filter) {
        List<Instance> result = new ArrayList<Instance>();
        for (Node node : nodes) {
            if (!filter.accept(node)) continue;
            Object ref = resolver.resolve(node);
            Instance instance = new DefaultInstance(node, ref);
            result.add(instance);
        }
        return result;
    }
}
