package au.net.netstorm.boost.spider.internals.graph.instantiate;

import java.util.List;
import au.net.netstorm.boost.spider.internals.graph.core.Instance;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DefaultProvisioner implements Provisioner {
    private final NodeFilter all = new DefaultNodeFilter();
    private final InstanceCollector collector;

    public DefaultProvisioner(InstanceCollector collector) {
        this.collector = collector;
    }

    public Object provide(Node node) {
        List<Instance> dependencies = dependencies(node);
        return provide(node, dependencies);
    }

    private Object provide(Node node, List<Instance> dependencies) {
        Provider provider = node.provider();
        Object[] args = new Object[dependencies.size()];
        for (int i = 0; i < args.length; i++) {
            Instance instance = dependencies.get(i);
            args[i] = instance.ref();
        }
        // FIX 3324 Mar 17, 2009 Triggers the Conf -> RunTime transition. Maybe. More likely on provider.target()
        return provider.nu(args);
    }

    private List<Instance> dependencies(Node node) {
        List<Node> dependencies = node.dependencies();
        return collector.collect(dependencies, all);
    }
}
