package au.net.netstorm.boost.spider.internals.graph.instantiate;

import java.util.List;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.internals.graph.core.Instance;
import au.net.netstorm.boost.spider.internals.graph.core.Node;

public class DefaultWirer implements Wirer {
    private final FieldInjector fielder = new DefaultFieldInjector();
    private final InstanceCollector collector;

    public DefaultWirer(InstanceCollector collector) {
        this.collector = collector;
    }

    public void wire(Node node, Object host) {
        List<Instance> children = children(node, host);
        for (Instance child : children) wire(host, child);
    }

    private void wire(Object host, Instance child) {
        Node node = child.node();
        InjectionSite site = node.site();
        Object ref = child.ref();
        fielder.inject(site, host, ref);
    }

    private List<Instance> children(Node node, Object host) {
        List<Node> children = node.children();
        NodeFilter injectable = new InjectableNodeFilter(host);
        return collector.collect(children, injectable);
    }
}
