package au.net.netstorm.boost.spider.internals.graph.instantiate;

import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.internals.probe.InstantiationProbe;

public final class ProbingInstances implements Instances {
    InstantiationProbe probe;
    Instances delegate;

    public ProbingInstances(Instances delegate, InstantiationProbe probe) {
        this.delegate = delegate;
        this.probe = probe;
    }

    public boolean exists(Node node) {
        return delegate.exists(node);
    }

    public Object get(Node node) {
        Object ref = delegate.get(node);
        probe.got(ref);
        return ref;
    }

    public void put(Node node, Object decorated) {
        probe.got(decorated);
        delegate.put(node, decorated);
    }

    public void remove(Node node) {
        delegate.remove(node);
    }
}
