package au.net.netstorm.boost.spider.internals.impl;

import au.net.netstorm.boost.gunge.type.Interface;
import au.net.netstorm.boost.spider.api.runtime.Nu;
import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSiteWirer;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.core.injection.types.InjectionTypeWirer;
import au.net.netstorm.boost.spider.internals.bindings.resolver.BindingResolver;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class DefaultImplResolver implements ImplResolver {
    InjectionTypeWirer types;
    InjectionSiteWirer sites;
    BindingResolver resolver;
    Nu nu;

    public <T> Class<? extends T> impl(Class<T> iface) {
        nu.nu(Interface.class, iface);
        InjectionType injection = types.build(iface);
        InjectionSite site = sites.root(injection);
        Binding binding = resolver.resolve(site);
        Provider provider = binding.provider();
        return provider.target();
    }
}
