package au.net.netstorm.boost.spider.internals.log;

import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.internals.errors.Cog;
import au.net.netstorm.boost.spider.internals.graph.core.Node;

public final class DefaultCogPrinter implements CogPrinter {
    InjectionSitePrinter sites = new DefaultInjectionSitePrinter();
    ReferencePrinter refs = new DefaultReferencePrinter();

    public String print(Cog cog) {
        String site = site(cog);
        String ref = ref(cog);
        return "+---- " + site + " " + ref;
    }

    private String site(Cog cog) {
        Node node = cog.node();
        InjectionSite site = node.site();
        return sites.print(site);
    }

    private String ref(Cog cog) {
        Optional optional = cog.ref();
        return optional.isSet() ? set(optional) : "*** Not Resolved ***";
    }

    private String set(Optional optional) {
        Object ref = optional.get();
        return refs.print(ref);
    }
}
