package au.net.netstorm.boost.spider.internals.log;

import java.util.ArrayList;
import java.util.List;
import au.net.netstorm.boost.gunge.indent.DefaultIndenterMaster;
import au.net.netstorm.boost.gunge.indent.IndenterMaster;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.spider.internals.errors.Cog;
import au.net.netstorm.boost.spider.internals.graph.core.Node;

// FIX 1437 Dec 11, 2008 Tidy this mother and settle on a format.
public final class DefaultGraphSpewer implements GraphSpewer {
    IndenterMaster master = new DefaultIndenterMaster();
    CogPrinter cogs = new DefaultCogPrinter();
    List<Cog> depth = new ArrayList<Cog>();

    public String chunder(List<Cog> cogs) {
        String r = "";
        for (Cog cog : cogs) r += chunder(cog) + "\n";
        return r;
    }

    public String chunder(Cog cog) {
        backtrack(cog);
        String text = chunks(cog);
        depth.add(cog);
        return indent(text);
    }

    private void backtrack(Cog cog) {
        while (!depth.isEmpty() && !hosted(cog)) clip();
    }

    private boolean hosted(Cog cog) {
        Node current = cog.node();
        Node last = last();
        List<Node> children = last.children();
        return children.contains(current);
    }

    private void clip() {
        int size = depth.size();
        depth.remove(size - 1);
    }

    private Node last() {
        int size = depth.size();
        Cog cog = depth.get(size - 1);
        return cog.node();
    }

    private String chunks(Cog cog) {
        boolean cycles = cycles(cog);
        String detail = cogs.print(cog);
        return cycles ? detail + " *** Cycle Detected ***" : detail;
    }

    private boolean cycles(Cog other) {
        for (Cog cog : depth) if (same(cog, other)) return true;
        return false;
    }

    private boolean same(Cog c1, Cog c2) {
        Optional o1 = c1.ref();
        Optional o2 = c2.ref();
        return same(o1, o2);
    }

    private boolean same(Optional o1, Optional o2) {
        if (!o1.isSet()) return false;
        if (!o2.isSet()) return false;
        return o1.get() == o2.get();
    }

    private String indent(String text) {
        int indent = depth.size() - 1;
        return master.indent(text, indent);
    }
}
