package au.net.netstorm.boost.spider.internals.log;

import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

public final class DefaultInjectionSitePrinter implements InjectionSitePrinter {
    public String print(InjectionSite site) {
        String type = type(site);
        String constraint = constraint(site);
        return type + " [" + constraint + "]";
    }

    private String constraint(InjectionSite site) {
        String host = host(site);
        String name = name(site);
        return name.length() != 0 ? host + " | " + name : host;
    }

    private String type(InjectionSite site) {
        InjectionType type = site.type();
        Class cls = type.rawClass();
        return cls.getSimpleName();
    }

    private String host(InjectionSite site) {
        Class host = site.host();
        return host.getSimpleName();
    }

    private String name(InjectionSite site) {
        return site.name();
    }
}
