package au.net.netstorm.boost.spider.internals.log;

import static java.lang.Integer.toHexString;
import static java.lang.System.identityHashCode;

public final class DefaultReferencePrinter implements ReferencePrinter {
    // FIX 1437 Dec 22, 2008 Handle "onions".
    public String print(Object ref) {
        String type = type(ref);
        String identity = identity(ref);
        return type + "@" + identity;
    }

    private String type(Object ref) {
        Class cls = ref.getClass();
        return cls.getSimpleName();
    }

    private String identity(Object ref) {
        int identity = identityHashCode(ref);
        return toHexString(identity);
    }
}
