package au.net.netstorm.boost.spider.internals.log;

import au.net.netstorm.boost.bullet.log.Log;
import au.net.netstorm.boost.gunge.optional.Optional;
import au.net.netstorm.boost.gunge.optional.SetOptional;
import au.net.netstorm.boost.spider.internals.errors.Cog;
import au.net.netstorm.boost.spider.internals.errors.DefaultCog;
import au.net.netstorm.boost.spider.internals.graph.core.Node;
import au.net.netstorm.boost.spider.internals.probe.InstantiationProbe;

public class LogInstantiationProbe implements InstantiationProbe {
    // FIX 1596 Dec 22, 2008 Encode this protocol better. instantiating -> either<nu, cycled>
    private Node current;
    GraphSpewer spewer;
    Log bucket;

    public void instantiating(Node node) {
        current = node;
    }

    public void got(Object ref) {
        chunder(ref);
    }

    private void chunder(Object ref) {
        Optional optional = new SetOptional(ref);
        Cog cog = new DefaultCog(current, optional);
        String chunder = spewer.chunder(cog);
        clean(chunder);
    }

    private void clean(String chunder) {
        if (chunder.contains("DisableTrace")) return;
        bucket.info(chunder);
    }
}
