package au.net.netstorm.boost.spider.internals.probe;

import java.util.List;

public class DefaultProber implements Prober {
    Probes probes;

    public void probe(Probe probe) {
        probe((InstantiationProbe) probe);
        probe((WalkingProbe) probe);
    }

    public void probe(InstantiationProbe probe) {
        List<InstantiationProbe> list = probes.iprobes();
        list.add(probe);
    }

    public void probe(WalkingProbe probe) {
        List<WalkingProbe> list = probes.wprobes();
        list.add(probe);
    }

    public void snip(Probe probe) {
        snip((InstantiationProbe) probe);
        snip((WalkingProbe) probe);
    }

    public void snip(InstantiationProbe probe) {
        List<InstantiationProbe> list = probes.iprobes();
        list.remove(probe);
    }

    public void snip(WalkingProbe probe) {
        List<WalkingProbe> list = probes.wprobes();
        list.remove(probe);
    }
}
