package au.net.netstorm.boost.spider.ioc;

import au.net.netstorm.boost.bullet.incredibles.core.Incredibles;
import au.net.netstorm.boost.bullet.incredibles.engine.core.IncrediblesWeb;
import au.net.netstorm.boost.bullet.incredibles.spider.IncrediblesFactory;
import au.net.netstorm.boost.bullet.scalpel.spider.EdgeFactory;
import au.net.netstorm.boost.bullet.scalpel.spider.ScalpelWeb;
import au.net.netstorm.boost.gunge.async.Daemon;
import au.net.netstorm.boost.gunge.equals.CoreEquals;
import au.net.netstorm.boost.gunge.equals.Equals;
import au.net.netstorm.boost.gunge.reflect.instantiate.Instantiator;
import au.net.netstorm.boost.gunge.reflect.instantiate.JlsInstantiator;
import au.net.netstorm.boost.spider.api.builder.Spinneret;
import au.net.netstorm.boost.spider.api.config.factory.Connectrexor;
import au.net.netstorm.boost.spider.api.config.factory.Factorer;
import au.net.netstorm.boost.spider.api.config.mapping.Mapper;
import au.net.netstorm.boost.spider.api.config.web.Web;
import au.net.netstorm.boost.spider.api.config.wire.Wire;
import au.net.netstorm.boost.spider.api.runtime.Resolver;
import au.net.netstorm.boost.spider.plugs.connectrex.supplied.LogConnectrex;
import au.net.netstorm.boost.spider.plugs.factory.builtin.ImplicitFactory;
import au.net.netstorm.boost.spider.plugs.factory.core.Factory;
import au.net.netstorm.boost.spider.plugs.factory.supplied.CollectionsFactory;
import au.net.netstorm.boost.spider.plugs.factory.supplied.ThreadedFactory;

// FIX 1596 Feb 25, 2009 This really is a SpiderWeb.
public class BoostWeb implements Web {
    String scope = "au.net.netstorm.boost";
    Spinneret spinneret;
    Connectrexor connectrexor;
    Factorer factorer;
    Resolver resolver;
    Mapper mapper;
    Wire wire;

    public void web() {
        mapper.prefix("Default", scope);
        dependencies();
        factories();
        equals();
        threads();
        mappings();
    }

    // FIX 1596 Jan 7, 2009 Need a better way of declaring dependencies.
    private void dependencies() {
        spinneret.spin(IncrediblesWeb.class, ScalpelWeb.class);
    }

    private void factories() {
        factorer.add(EdgeFactory.class);
        factorer.add(IncrediblesFactory.class);
        factorer.add(CollectionsFactory.class);
        wire.cls(ImplicitFactory.class).to(Factory.class, ThreadedFactory.class);
        factorer.add(ThreadedFactory.class);
        connectrexor.add(LogConnectrex.class);
    }

    // FIX 1438 Jan 16, 2009 Sort this out.  Should be simpler? non?
    private void threads() {
        Incredibles incredibles = resolver.resolve(Incredibles.class);
        Daemon daemon = incredibles.nu(Daemon.class, true);
        wire.ref(daemon).to(Daemon.class);
    }

    private void equals() {
        wire.cls(CoreEquals.class).to(Equals.class);
    }

    private void mappings() {
        // FIX 2377 Jan 20, 2009 We should not have to specify multi/single here.  Simply a binding.
        wire.cls(JlsInstantiator.class).to(Instantiator.class);
    }
}
