package au.net.netstorm.boost.spider.plugs.connectrex.builtin;

import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.BindingWirer;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.plugs.connectrex.core.Connectrex;
import au.net.netstorm.boost.spider.plugs.factory.core.Factory;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class FactoryConnectrex implements Connectrex {
    final Factory factory;
    BindingWirer wirer;

    public FactoryConnectrex(Factory factory) {
        this.factory = factory;
    }

    public Binding nu(InjectionSite site) {
        InjectionType type = site.type();
        Provider provider = factory.nu(type);
        return wirer.nu(type, provider);
    }

    public boolean can(InjectionSite site) {
        InjectionType type = site.type();
        return factory.can(type);
    }
}
