package au.net.netstorm.boost.spider.plugs.connectrex.core;

import java.util.ArrayList;
import java.util.List;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;

// DEBT CyclomaticComplexity {
public class DefaultConnectrexes implements Connectrexes {
    List<Connectrex> connectrexes = new ArrayList();
    Connectrex bootstrap;
    Connectrex wiring;

    public Connectrex find(InjectionSite site) {
        Connectrex connectrex = lookup(site);
        if (connectrex != null) return connectrex;
        throw new IllegalStateException("No connectrex for type: " + site);
    }

    public boolean can(InjectionSite site) {
        return lookup(site) != null;
    }

    public void add(Connectrex connectrex) {
        if (connectrex == null) throw new IllegalArgumentException("Connectrex cannot be null.");
        if (connectrexes.contains(connectrex)) throw new IllegalArgumentException("Connectrex already exists.");
        connectrexes.add(FIRST, connectrex);
    }

    private Connectrex lookup(InjectionSite site) {
        if (wiring.can(site)) return wiring;
        if (bootstrap.can(site)) return bootstrap;
        for (Connectrex connectrex : connectrexes)
            if (connectrex.can(site)) return connectrex;
        return null;
    }

    private static final int FIRST = 0;
}
// } DEBT CyclomaticComplexity