package au.net.netstorm.boost.spider.plugs.connectrex.supplied;

import au.net.netstorm.boost.bullet.log.Log;
import au.net.netstorm.boost.bullet.log.LogEngine;
import au.net.netstorm.boost.bullet.log.LogNice;
import au.net.netstorm.boost.spider.api.runtime.Impl;
import au.net.netstorm.boost.spider.core.binding.Binding;
import au.net.netstorm.boost.spider.core.binding.BindingWirer;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.plugs.connectrex.core.Connectrex;
import au.net.netstorm.boost.spider.plugs.gunge.Is;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;
import au.net.netstorm.boost.spider.plugs.provider.supplied.LogProvider;

public class LogConnectrex implements Connectrex {
    BindingWirer binding;
    Impl impl;
    Is is;

    public Binding nu(InjectionSite site) {
        if (!can(site)) throw new IllegalArgumentException();
        InjectionType type = site.type();
        Class host = site.host();
        Provider p = impl.impl(LogProvider.class, site);
        return binding.nu(type, host, p);
    }

    public boolean can(InjectionSite site) {
        return is.equal(site, Log.class, LogEngine.class, LogNice.class);
    }
}
