package au.net.netstorm.boost.spider.plugs.factory.builtin;

import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassNames;
import au.net.netstorm.boost.spider.api.config.wire.Wire;
import au.net.netstorm.boost.spider.api.runtime.Nu;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.plugs.factory.core.Factory;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class ImplicitFactory implements Factory {
    ClassNames names = new DefaultClassNames();
    ImplicitFactoryFu fu;
    Mappings mappings;
    Wire wire;
    Nu nu;

    public Provider nu(InjectionType type) {
        for (Mapping mapping : mappings) {
            if (fu.can(type, mapping)) return fu.nu(type, mapping);
        }
        throw new CanNotProvideException(type);
    }

    public boolean can(InjectionType type) {
        if (!hasPackage(type)) return false;
        if (ourBIGHEAVYBLOCKER(type)) return false;
        return mappings(type);
    }

    private boolean mappings(InjectionType type) {
        for (Mapping mapping : mappings) {
            if (fu.can(type, mapping)) return true;
        }
        return false;
    }

    // FIX 3324 Mar 18, 2009 Sort.
    private boolean ourBIGHEAVYBLOCKER(InjectionType type) {
        Class cls = type.rawClass();
        return names.in("au.net.netstorm.boost.spider", cls);
    }

    private boolean hasPackage(InjectionType type) {
        Class cls = type.rawClass();
        Package pkg = cls.getPackage();
        return pkg != null;
    }
}
