package au.net.netstorm.boost.spider.plugs.factory.builtin;

import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassNames;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

public class PackageMapping implements Mapping {
    ClassNames names = new DefaultClassNames();
    Mapping classer;
    String from;
    String to;

    public PackageMapping(Mapping classer, String from, String to) {
        this.classer = classer;
        this.from = from;
        this.to = to;
    }

    public boolean can(InjectionType type) {
        Class cls = type.rawClass();
        String pkg = names.pkg(cls);
        return pkg.equals(from) && classer.can(type);
    }

    public String map(InjectionType type) {
        String name = classer.map(type);
        return name.replace(from, to);
    }
}
