package au.net.netstorm.boost.spider.plugs.factory.builtin;

import au.net.netstorm.boost.gunge.reflect.misc.ClassNameMorpher;
import au.net.netstorm.boost.gunge.reflect.misc.DefaultClassNameMorpher;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

public class PrefixMapping implements Mapping {
    private final ClassNameMorpher morpher = new DefaultClassNameMorpher();
    private final String prefix;

    public PrefixMapping(String prefix) {
        this.prefix = prefix;
    }

    public String map(InjectionType type) {
        Class cls = type.rawClass();
        return morpher.add(cls, prefix);
    }

    public boolean can(InjectionType type) {
        return true;
    }
}