package au.net.netstorm.boost.spider.plugs.factory.builtin;

import au.net.netstorm.boost.gunge.reflect.cls.ClassNames;
import au.net.netstorm.boost.gunge.reflect.cls.DefaultClassNames;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

// FIX 1596 Dec 30, 2008 Use or lose wire into Mapper.
public class ScopedMapping implements Mapping {
    ClassNames names = new DefaultClassNames();
    Mapping classer;
    String scope;

    // FIX 1596 Dec 30, 2008 Consider asserting scope is non empty.
    public ScopedMapping(Mapping classer, String scope) {
        this.classer = classer;
        this.scope = scope;
    }

    public boolean can(InjectionType type) {
        Class cls = type.rawClass();
        return names.in(scope, cls) && classer.can(type);
    }

    public String map(InjectionType type) {
        return classer.map(type);
    }
}