package au.net.netstorm.boost.spider.plugs.factory.supplied;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import au.net.netstorm.boost.gunge.array.ArrayMaestro;
import au.net.netstorm.boost.gunge.collection.DefaultStrictMap;
import au.net.netstorm.boost.gunge.collection.StrictMap;
import au.net.netstorm.boost.gunge.type.Implementation;
import au.net.netstorm.boost.spider.api.runtime.Impl;
import au.net.netstorm.boost.spider.api.runtime.Nu;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.plugs.factory.core.Factory;
import au.net.netstorm.boost.spider.plugs.gunge.Is;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;
import au.net.netstorm.boost.spider.plugs.provider.supplied.AmbiguousConstructorProvider;

public class CollectionsFactory implements Factory {
    StrictMap<Class, Class> rules = new DefaultStrictMap<Class, Class>();
    ArrayMaestro arrays;
    Impl impl;
    Nu nu;
    Is is;

    {
        rules.put(List.class, ArrayList.class);
        rules.put(Map.class, HashMap.class);
        rules.put(Set.class, HashSet.class);
    }

    public Provider nu(InjectionType type) {
        Class cls = type.rawClass();
        Class target = rules.get(cls);
        Implementation implementation = nu.nu(Implementation.class, target);
        return impl.impl(AmbiguousConstructorProvider.class, implementation);
    }

    public boolean can(InjectionType type) {
        Set<Class> keys = rules.keySet();
        Class[] candidates = arrays.array(keys, Class.class);
        return is.equal(type, candidates);
    }
}
