package au.net.netstorm.boost.spider.plugs.gunge;

import au.net.netstorm.boost.gunge.array.ArrayMaster;
import au.net.netstorm.boost.gunge.array.DefaultArrayMaster;
import au.net.netstorm.boost.spider.core.injection.sites.InjectionSite;
import au.net.netstorm.boost.spider.core.injection.types.InjectionType;

public class DefaultIs implements Is {
    ArrayMaster arrays = new DefaultArrayMaster();

    public boolean equal(InjectionType type, Class... candidates) {
        Class c = type.rawClass();
        return arrays.contains(candidates, c);
    }

    public boolean equal(InjectionSite site, Class... candidates) {
        InjectionType type = site.type();
        return equal(type, candidates);
    }

    public boolean assignable(InjectionType type, Class... candidates) {
        Class cls = type.rawClass();
        for (Class c : candidates) if (assignable(c, cls)) return true;
        return false;
    }

    public boolean assignable(InjectionSite site, Class... candidates) {
        InjectionType type = site.type();
        return assignable(type, candidates);
    }

    private boolean assignable(Class candidate, Class type) {
        return candidate.isAssignableFrom(type);
    }
}
