package au.net.netstorm.boost.spider.plugs.provider.supplied;

import au.net.netstorm.boost.spider.core.injection.types.InjectionType;
import au.net.netstorm.boost.spider.plugs.provider.core.CleanProvider;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class ReifiedGenericProvider extends CleanProvider {
    private final Provider delegate;
    private final InjectionType type;

    public ReifiedGenericProvider(Provider delegate, InjectionType type) {
        this.delegate = delegate;
        this.type = type;
    }

    public Object nu(Object... args) {
        if (args.length != 0) return barf();
        Class[] params = type.parameters();
        return delegate.nu((Object[])params);
    }

    public Provider root() {
        return delegate;
    }

    private Object barf() {
        throw new IllegalArgumentException("Generic provider infers arguments, can not be supplied.");
    }
}
