package au.net.netstorm.boost.spider.plugs.provider.supplied;

import au.net.netstorm.boost.gunge.lazy.DefaultLazy;
import au.net.netstorm.boost.gunge.lazy.Lazy;
import au.net.netstorm.boost.gunge.lazy.LazyCreator;
import au.net.netstorm.boost.spider.plugs.provider.core.DelegatingProvider;
import au.net.netstorm.boost.spider.plugs.provider.core.Provider;

public class SingleProvider extends DelegatingProvider {
    private final Lazy<Object> single;

    public SingleProvider(Provider provider) {
        super(provider);
        single = lazy(provider);
    }

    public Object nu(Object... args) {
        if (args.length != 0) throw new IllegalArgumentException("Single providers do not support arguments. ");
        return single.get();
    }

    private Lazy<Object> lazy(Provider provider) {
        LazyCreator<Object> creator = new ProviderLazyCreator(provider);
        return new DefaultLazy<Object>(creator);
    }
}
